/*
 * 
 * 
 * 
 * jquery gritter library http://boedesign.com/blog/2009/07/11/growl-for-jquery-gritter/
 * 
 */

(function($){

	function bind(fn, ctx) {
		if (typeof fn.bind === "function") {
			return fn.bind(ctx);
		} else {
			return function() {
				fn.apply(ctx, arguments);
			};
		}
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////																											  	   ////
	////	Constructor for cytoscapeMenu object. cytoscapeMenu display menu 1 with function for the graph 			   	   ////
	///		and menu 2 with functions for nodes sequences:													 		   	   ////
	////	Function call with $(selector).cytoscapeMenu(type) with type is the type of menu (north or south)	   		   ////
	////									  																		  	   ////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function CytoscapeMenu($el){
		this.$el = $el;
		this.menubarGraph = bind(this.menuGraph, this);
		this.menubarSeq = bind(this.menuSeq, this);
	}
	
	var cyNetwork = JSON.parse(localStorage.getItem('networkData'));
	var currentConfig;
	var menuNorth = {
						items: [
								{ 
									name: "Load file", 
									open: function(){	
										
									},
									items: [
										{ 
											name: "Load session file (vjson, sjson)", 
											attr: { id:"upload_session" },
											selecton: function(){
												fakeInputFile($('#upload_session'));
											}		
										},{ 
											name: "Start page", 
											attr: { id:"start_page"},
											selecton: function(){
												localStorage['fromVisu'] = true;
												window.location.href = 'index.html';
												//localStorage.clear('fileName');
											} 
										}
									]
								},{
									name: "Save file", 
									open: function(){
										
									},
									items: [
										/*{ 
											name: "Save vizmapper (vjson)", 
											attr: { id:"download_vjson" },
											selecton: function(){
												//saveGraph($('#download_json').children());
											}		
										},*/{ 
											name: "Save session file (sjson)", 
											attr: { id:"download_sjson"},
											selecton: function(){
												cy.nodes(":selected").unselect();
												saveSession($('#download_sjson').children());
											} 
										}
									]
								},{
								name: "Style", 
									open: function(){
										
									},
									items: [
										{ 
											name: "Show nodes labels", 
											checkable: true,
											attr: {id: "nodesLabel" },
											selecton: function(){
												cy.nodes().css("content", "data(id)");
												labelNodesIsShow(true);
											},
											selectoff: function(){
												cy.nodes().css("content", "");
												labelNodesIsShow(false);
											}		
										},{ 
											name: "Show edges labels", 
											checkable: true,
											attr: {id: "edgesLabel" },
											selecton: function(){ 
												cy.edges().css("content", "data(direction)");
												labelEdgesIsShow(true);
											},
											selectoff: function(){
												cy.edges().css("content", "");
												labelEdgesIsShow(false);
											}
										}
									]
								},{
								name: "Layout", 
									open: function(){
										
									},
									items: [
										{ 
											name: "Recalculate layout", 
											attr: { id: " "},
											selecton: function(){
												 cy.layout();
											}				
										},{
											name: "Mechanism", 
											attr: {},
											open: function(){
												
											},
											items: [
													{ 
													name: "Null",
													checkable: true,
													attr: {id: "null" },
													selecton: function(){ 
														cy.layout({name:"null"});
														$("#null").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
													}
												},{
													name: "Preset",
													checkable: true,
													attr: {id: "preset" }, 
													selecton: function(){ 
														cy.layout({name:"preset"});
														$("#preset").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
													}
												},{
													name: "Random",
													checkable: true,
													attr: {id: "random" }, 
														selecton: function(){ 
															cy.layout({name:"random"});
															$("#random").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
														}
												},{
													name: "Grid",
													checkable: true,
													attr: {id: "grid" },
														selecton: function(){ 
															cy.layout({name:"grid"});
															$("#grid").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
														}
												},{
													name: "Arbor",
													checkable: true,
														attr: {id: "arbor" }, 
														selecton: function(){ 
															cy.layout({name:"arbor"});
															$("#arbor").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
														}
												},{
													name: "Circle",
													checkable: true,
													attr: {id: "circle" }, 
													selecton: function(){
														cy.layout({name:"circle"});
														$("#circle").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
													}
												},{
													name: "Cose",
													attr: {id: "cose" },
													checkable: true, 
													selecton: function(){ 
														cy.layout({name:"cose"});
														$("#cose").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
													}
												},{
													name: "Breadthfirst",
													attr: {id: "breadthfirst" },
													checkable: true, 
														selecton: function(){ 
															cy.layout({name:"breadthfirst"});
															$("#breadthfirst").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
														}
												},{
													name: "Hirarchical",
													attr: {id: "hierarchical" },
													checkable: true, 
													selecton: function(){ 
															cy.layout({
																name:"hierarchical",
																roots: cyNetwork.starter.data.id, // id of root of the trees
								    							rightChildren: cyNetwork.position.right, // id of the first right node
																leftChildren: cyNetwork.position.left, //id of the first left node
																});
															$("#hierarchical").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
														}
												}
											]
										}
										//TODO:implement this
										/*,{
											name: "Settings", 
											attr: { },
											selecton: function(){
												open_settings(["Null","Preset","Random","Grid","Arbor","Circle","Radial*","Breadthfirst", "Hierarchical"]);
											} 
	
										}*/	
									]
								}, {
								name: "Help", 
									selecton: function(){
										window.open('doc/doc.html');
									}
								}		
							]
					};
	
	var itemThemes = {
											name: "Visualisation", 
											attr: {},
											open: function(){
												
											},
											items: [
													{ 
													name: "Default",
													checkable: true,
													attr: {id: "default" }, 
													selecton: function(){
														var visualStyles = {}, 
	        											requests = [];
														requests.push(
	            												$.getJSON("./style/initStyle.tjson", function(file) {
	                											visualStyles = file.style;
	            		  										})
	        											);
	        											$.when.apply($, requests).done(
												        	function (){
												        		applyStyle(visualStyles);
												        		$("#cy").removeClass("loading");
												        		$("#default").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
												        	}
												    	); 
														
													}
												},{
													name: "Cytoscape",
													checkable: true,
													attr: {id: "cytoscape" }, 
													selecton: function(){
														var visualStyles = {}, 
	        											requests = [];
														requests.push(
						            							$.getJSON("./style/cytoscape.tjson", function(file) {
						                						visualStyles = file.style;
									            				})
									      
									        			);
											        	$.when.apply($, requests).done(
												        	function (){
												        		applyStyle(visualStyles);
												        		$("#cy").removeClass("loading");
												        		$("#cytoscape").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
												        	}
												    	);
												    	
												    	
													}
													
												},{
													name: "Default2",
													checkable: true,
													attr: {id: "cytoscape" }, 
													selecton: function(){
														var visualStyles = {}, 
	        											requests = [];
														requests.push(
						            							$.getJSON("./style/default.tjson", function(file) {
						                						visualStyles = file.style;
									            				})
									      
									        			);
											        	$.when.apply($, requests).done(
												        	function (){
												        		applyStyle(visualStyles);
												        		$("#cy").removeClass("loading");
												        		$("#cytoscape").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
												        	}
												    	);
												    	
												    	
													}
												}
											]
										};
	
	var idNumber =0;
	var menuSouth = {
					items: [
								{ 
									
									name: "Concatenation", 
									attr: {id:"ConcaSeq"},
									selecton: function(){
										concatSelectedSeq();								
									} 
								},{
									name: "Export", 
									attr: {id:"exportSeq"},
									selecton: function(){

											var sequenceExport = $("#sequences_content").find("pre");
											sequenceExport.splice(0, 1); //remove the first element >> <pre> in Nodes....
											var textSequenceExport = $(sequenceExport).text(); 
											var blob = new Blob([textSequenceExport], {type: "text/plain;charset=utf-8"});
											if($('#fasta').children(":first").hasClass("ui-menu-checked")){
												saveAs(blob, "squencesExported.fasta");
											}else if ($('#codata').children(":first").hasClass("ui-menu-checked")){
												saveAs(blob, "squencesExported.codata");
											}else if ($('#pride').children(":first").hasClass("ui-menu-checked")){
												saveAs(blob, "squencesExported.pride");
											}else if ($('#raw').children(":first").hasClass("ui-menu-checked")){
												saveAs(blob, "squencesExported.txt");
											}
											
											
									} 
								},{
									name: "Add",
									attr: {id:"addSeqElements"}, 
									open: function(){
									
									},
									items: [
										{ 
											name: "Annotation", 
											attr: { id:"addAnnotation" },
											selecton: function(){
												var $biojs = $(".ui-sequences-visible");
												$biojs.each(function(){
													//var idNodes = this.data("id");
													var biojsData = $(this).data("biojsData");
													var index; //index need to be define here to keep the right value
													biojsData.addAnnotation( { 
														  name: "annotation_"+idNumber,
														  index: idNumber, 
   														  html:"", 
														  color:"blue", 
														  regions: [
														      {start: biojsData.opt.selection.start, 
															   end: biojsData.opt.selection.end,
															  
															  }
														      ]
													});
											
													 
													
													 //$(".annotation."+idNumber).last().after('<div class="annotation-chooser" id="annotationpicker_'+idNumber+'"style="position:absolute; visibility:hidden"></div>');
													

													 
													 biojsData.onAnnotationClicked(function(e) {
														
														
														index = e.index;
														if($("#annotationpicker_"+index)[0]== undefined){
															$(".annotation."+index).parent().append('<div class="annotation-chooser" id="annotationpicker_'+index+'"style="position:absolute;display:none;"></div>');
														}
				      									var id = $(".annotation."+index).attr("name");
				      									$('#annotationpicker_'+index).picker({
																	onShow: function (colpkr) {
																		var bodyHeight = $("body").height();
																		var paneSouthHeight = $("#paneSouth").height();
																		var menuSouthHeight = $("#menu_southPaneVisuGraph").height();
																		var colprkHeight = $(colpkr).height();
																		
																		$(colpkr).css("top", bodyHeight-paneSouthHeight-colprkHeight+menuSouthHeight);
																	},
																	onChangeColor: function (){
																		var colorSelected = "#"+$(this).find(".colorpicker_hex input").val();
																		biojsData._annotations[id].color = colorSelected;
																		$(".annotation."+index).attr("color", colorSelected).css("border-color", colorSelected);
																		$('.annotation-chooser').css("backgroundColor", colorSelected);
																	},
																	onChangeName:function (){
																		biojsData._annotations[id].name = $(this).data("picker").name;
																		
																	},
																	onChangeText:function (){
																		biojsData._annotations[id].html = $(this).data("picker").text;
																	},
																	onHide: function(colpkr){
																		$('#annotationpicker_'+index).hide();
																	},
																		
																		
														});
																
														
														var color = $.Color($(".annotation."+index).attr("color")).toHexString();
														var top = $(".annotation."+index).position().top-10;
														var left = $(".annotation."+index).position().left;
													
														$('#annotationpicker_'+index)
																				.css({
																						top: top,
																						left: left,
																						backgroundColor:$(".annotation."+index).attr("color"),
																						display:"block"
																				})
																				.pickerSetColor(color, 1, undefined, biojsData._annotations[id].name, biojsData._annotations[id].html)
																				.pickerShow();
																					
													});	
													biojsData.setSelection(0, 0);
													
			  									});
			  										
			  										
			  									idNumber++;		 
	
											}		
										},{ 
											name: "Hightlight", 
											attr: { id:"addHightlight"},
											selecton: function(){
												//highlight the characters within the position x to y, included.
												var $biojs = $(".ui-sequences-visible");
												$biojs.each(function(){
													//var idNodes = this.data("id");
													var biojsData = $(this).data("biojsData");
													biojsData.addHighlight( { 
																"start": biojsData.opt.selection.start, 
																"end": biojsData.opt.selection.end, 
																"color": "white", 
																"background": "red", 
																"id": "id_"+idNumber
													});
													biojsData.setSelection(0, 0);
													idNumber++;
												});
											} 
										}
							 	 ]
							  },{
							  name: "Remove",
							  attr: { id:"removeSeqElements" },  
							  open: function(){
									
							  },
							  items: [
							  			{ 
											name: "All", 
											attr: { id:"removeAll"},
											selecton: function(){
												var $biojs = $(".ui-sequences-visible");
												$biojs.each(function(){
													  var biojsData = $(this).data("biojsData");
													 biojsData.removeAllAnnotations();
													 biojsData.unHighlightAll();
												});
											}
										},{ 
											name: "All Annotation", 
											attr: { id:"removeAllAnnotation"},
											selecton: function(){
												var $biojs = $(".ui-sequences-visible");
												$biojs.each(function(){
													  var biojsData = $(this).data("biojsData");
													 biojsData.removeAllAnnotations();
												});
											} 
										},{ 
											name: "All Hightlight", 
											attr: { id:"unAllHightlight"},
											selecton: function(){
												var $biojs = $(".ui-sequences-visible");
												$biojs.each(function(){
													 var biojsData = $(this).data("biojsData");
													 biojsData.unHighlightAll();
												});
											} 
										}/*,{ 
											name: "Hightlight", 
											attr: { id:"unHightlight"},
											selecton: function(){
												$(".ui-sequences").data("biojsData").unHighlight( "aa");
												
											} 
										}*/
							  ]
							  },{
							  name: "Set", 
							  attr: { id:"SetSeq"},
							  open: function(){
									
								},
							   items: [
										{ 
											name: "Format", 
											attr: { id:"setFormat" },
											open: function(){
									
											},
											items: [
													{ 
														name: "FASTA",
														checkable: true,  
														attr: { id:"fasta" },
														selecton: function(){
															cy.nodes(":selected").each(function(){
																this.data("biojsData").setFormat("FASTA");
															});
															$("#fasta").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
														}		
													},{ 
														name: "CODATA", 
														checkable: true, 
														attr: { id:"codata"},
														selecton: function(){
															cy.nodes(":selected").each(function(){
																this.data("biojsData").setFormat("CODATA");
															});
															$("#codata").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
														} 
													},{ 
														name: "PRIDE",
														checkable: true,  
														attr: { id:"pride"},
														selecton: function(){
															cy.nodes(":selected").each(function(){
																this.data("biojsData").setFormat("PRIDE");
															});
															$("#pride").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
														} 
													},{ 
														name: "RAW",
														checkable: true,  
														attr: { id:"raw"},
														selecton: function(){
															cy.nodes(":selected").each(function(){
																this.data("biojsData").setFormat("RAW");
															});
															$("#raw").siblings().find(".ui-menu-checked").removeClass("ui-menu-checked");
														}
													}
										 	 ]		
										}
							 	 ]
							 },{
							  
							  name: "Hold",
							  checkable: true,  
							  attr: { id:"holdSouth"},
							  selecton: function(){
									$("body").layout().disableClosable("south");
									$("body").layout().disableSlidable("south");
							  },
							  selectoff: function(){
									$("body").layout().enableClosable("south");
									$("body").layout().close("south");
							  }
							  
						}
					]
			};
					
	CytoscapeMenu.prototype = {
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////																											  ////
	////	When body is ready, create the menu north with cytoscape graph functions (jquery.menubar.js): 			  ////
	////	- Load file:  call loadSession() for restore old session saved in a file								  ////
	////	- Start page : Loading a new start page for load new graph file											  ////
	////	- Save file : call saveGraph() for save a graph file (json) 											 ////
	////				  or saveSession() for save a session file(vjson or sjson) 									////
	////	- Style : show/hide elements label and set visual style													  ////
	////	- Layout : recalculate layout, set layout type and change layout settings //TODO						  ////
	////																											  ////
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//TODO:add class attr

	menuGraph : function(config){
			
			if(config.with_themes){
				menuNorth.items[2].items.push(itemThemes);
			}
			
			this.$el.menubar(menuNorth)
					//// Display name file in input text ////
					.children().prepend('<form class="ui-state-default ui-corner-all ui-menu-title" id="files_upload">\
										<input type="text" id="selectedfile" class="ui-menu-title ui-state-default value="" readonly" />\
										 </form>'
					)
					.append('<form class="ui-state-default ui-corner-all ui-menu-title" id="files_session" style="position: absolute; right: 0px;">\
										<label> Session : </label>\
										<input type="text" id="currentSession" class="ui-menu-title ui-state-default" style="width:160px;" value="" readonly" />\
										 </form>'
					);
			
			var fileName = localStorage.getItem("fileName");
			$('#selectedfile').val(fileName);
			
			currentConfig = config;
		
	},
				
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////																											  ////
	////	When body is ready, create the menu south with biojs functions (Biojs.Sequence.js): 			  		  ////
	////	- Concatenation:  concatenate sequences of selected nodes	//TODO										  ////	////	- Add : add hightlight or annotation on sequences 		//TODO										 	  ////
	////	- Remove : remove hightlight or annotation on sequences 		//TODO									  ////
	////	- Set :  set text format of sequences								  									  ////
	////																											  ////
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////			
	//TODO:add class attr
	menuSeq : function(){
		this.$el.menubar(menuSouth);
		
		}
 };


//**************************************************************** menu functions (load, save, ...)************************************************// 
 
 
    /*
     * Concatenate node sequence, when it's possible, in order of the user click
     * @concatSelectedSeq
     * @param none
     * @return {String} : concatenate nodes sequences
     */
   

	function concatSelectedSeq() {
		var concatSequence = "";
		var nodesLen = cy.nodes().length;
		var concatHeader = "";
		var sequenceString = [];
		var collection = [];

		collection = cy._private.orderingSelection;
		var kmerLen = collection[0].data("k");
		var collectionLen = collection.length;
		console.log(collection);

		//test if collection contained only one element and alert and stop function if it's the case
		if (collectionLen <= 1) {
			$.extend($.gritter.options, {
				position : 'bottom-right',

			});
			$.gritter.add({
				title : 'Concatenate warning',
				text : "Please select two nodes or more.",
				sticky : false,
				time : 8000,
				class_name : 'alert-gritter',
			});
			return false;
		}

		cy.edges(":selected").unselect();
		//variable define condition concatenation, alert and break loop
		var sequencePrecedente;
		var isAlerted = false;
		var leaveConditionFF, leaveConditionFR, leaveConditionRF, enterConditionFF, enterConditionFR, enterConditionRF, leaveConditionRR, enterConditionRR;

		//first loop on nodes selected
		for (var n = 0; n < collectionLen; n++) {

			var thisId = collection[n].data("id");
			var nbConnectedEdges = collection[n]._private.edges.length;
			var isTarget;

			//Second loop on all edges of nodes selected
			for (var h = 0; h < nbConnectedEdges; h++) {
				var edge = collection[n]._private.edges[h];
				var target = cy.nodes("#" + edge.data("target"));
				var source = cy.nodes("#" + edge.data("source"));
				var targetId = target.data("id");
				var sourceId = source.data("id");
				var directionEdgesLeave, directionEdgesEnter;

				//using target nodes for concatenate sequences so the way is between 0 and n-1
				//for concatenate, it's necessary to have target of edge selected and the target nodes different of the current nodes ( repetition of nodes with the 2 loops)
				if (n < collectionLen - 1 && targetId != thisId && target.selected()) {

					//target must be the second one in selected nodes
					if (targetId == collection[n + 1].data("id")) {

						//define edges enter direction and edges leave direction
						if (n == 0) {

							//first node haven't enter condition'
							enterConditionFF = undefined;
							enterConditionFR = undefined;
							enterConditionRF = undefined;
							enterConditionRR = undefined;
							directionEdgesLeave = edge.data("direction");
							leaveConditionFF = (directionEdgesLeave == "FF" || directionEdgesLeave == "ff" );
							leaveConditionFR = (directionEdgesLeave == "FR" || directionEdgesLeave == "fr");
							leaveConditionRF = (directionEdgesLeave == "RF" || directionEdgesLeave == "rf");
							leaveConditionRR = (directionEdgesLeave == "RR" || directionEdgesLeave == "rr");
							isTarget = targetId;
							//}else if(n>=collectionLen-1){

						} else if (isTarget == thisId) {
							//if the current node is the target of precedent node selected,  the enter condition of the current nodes is the leave condition of the precedent node
							//console.log("n", n, h, thisId, targetId, collection[n+1].data("id"))
							enterConditionFF = leaveConditionFF;
							enterConditionFR = leaveConditionFR;
							enterConditionRF = leaveConditionRF;
							enterConditionRR = leaveConditionRR;
							directionEdgesLeave = edge.data("direction");
							leaveConditionFF = (directionEdgesLeave == "FF" || directionEdgesLeave == "ff" );
							leaveConditionFR = (directionEdgesLeave == "FR" || directionEdgesLeave == "fr");
							leaveConditionRF = (directionEdgesLeave == "RF" || directionEdgesLeave == "rf");
							leaveConditionRR = (directionEdgesLeave == "RR" || directionEdgesLeave == "rr");
							isTarget = targetId;
						} else {
							//break edge loop if the current node is not the target
							break;
						}
					} else {
						//if the target of edge is not the next node selected continue with an other edge
						continue;

					}

					var thisSequence = collection[n].data("sequence");
					var targetSequence = target.data("sequence");
					var testConcatSeq;
					//var initialDirection;

					//concatenation for the first node with the second
					if (n == 0) {
						concatHeader += thisId;
						//if (target.data("id") == collection[n + 1].data("id")) {
						if (leaveConditionFF) {
							concatHeader += "-" + targetId;
							sequenceString[0] = thisSequence;
							sequenceString[1] = targetSequence.substring(kmerLen - 1);
							concatSequence = sequenceString[0] + sequenceString[1];
							testConcatSeq = verifConcatenateSeq(collection[n], target, kmerLen, edge.data("direction"));
							initialDirection = "FF";
							edge.select();
							if (!testConcatSeq) {
								alert("Error with concatenate function: k-mer of " + thisId.bold() + " and " + targetId.bold() + " are not identical");
							};

							console.log(thisId, target.data("id"), concatSequence, edge.data("direction"))
						} else if (leaveConditionRF) {
							concatHeader += "-" + targetId;
							sequenceString[0] = reverse(complement(thisSequence));
							sequenceString[1] = targetSequence.substring(kmerLen - 1);
							concatSequence = sequenceString[0] + sequenceString[1];
							testConcatSeq = verifConcatenateSeq(collection[n], target, kmerLen, edge.data("direction"));
							initialDirection = "RF";
							edge.select();
							if (!testConcatSeq) {
								alert("Error with concatenate function: k-mer of " + thisId.bold() + " and " + targetId.bold() + " are not identical");
							};
							console.log(thisId, target.data("id"), concatSequence, edge.data("direction"))
						} else if (leaveConditionRR) {
							concatHeader += "-" + targetId;
							sequenceString[0] = reverse(complement(thisSequence));
							sequenceString[1] = reverse(complement(targetSequence)).substring(kmerLen - 1);
							concatSequence = sequenceString[0] + sequenceString[1];
							testConcatSeq = verifConcatenateSeq(collection[n], target, kmerLen, edge.data("direction"));
							initialDirection = "RR";
							edge.select();
							if (!testConcatSeq) {
								alert("Error with concatenate function: k-mer of " + thisId.bold() + " and " + targetId.bold() + " are not identical");
							};
							console.log(thisId, target.data("id"), concatSequence, edge.data("direction"))
						} else if (leaveConditionFR) {
							concatHeader += "-" + targetId;
							sequenceString[0] = thisSequence;
							sequenceString[1] = reverse(complement(targetSequence)).substring(kmerLen - 1);
							concatSequence = sequenceString[0] + sequenceString[1];
							testConcatSeq = verifConcatenateSeq(collection[n], target, kmerLen, edge.data("direction"));
							initialDirection = "FR";
							edge.select();
							if (!testConcatSeq) {
								alert("Error with concatenate function: k-mer of " + thisId.bold() + " and " + targetId.bold() + " are not identical");
							};
							console.log(thisId, target.data("id"), concatSequence, edge.data("direction"))
						} else if (!isAlerted) {
							//alert gritter if enter and leave condition are not respected
							$.extend($.gritter.options, {
								position : 'bottom-right',

							});
							//alert gritter if leave condition is not respected for the first node
							$.gritter.add({
								title : 'Concatenate warning',
								text : "Node " + thisId.bold() + " can't be concatenated with node " + target.data("id").bold() + ".",
								sticky : false,
								time : 8000,
								class_name : 'alert-gritter',
							});
							isAlerted = true;
							break;

						}

						//concatenation for others nodes
					} else if (n < collectionLen - 1) {
						//if (target.data("id") == collection[n + 1].data("id")) {
						if (enterConditionFF && leaveConditionFF /*&& (initialDirection=="FF"|| initialDirection=="RF")*/) {
							concatHeader += "-" + targetId;
							if (concatSequence == "") {
								sequenceString[0] = thisSequence;

							} else {
								sequenceString[0] = concatSequence;
							}

							sequenceString[1] = targetSequence.substring(kmerLen - 1);
							concatSequence = sequenceString[0] + sequenceString[1];
							testConcatSeq = verifConcatenateSeq(collection[n], target, kmerLen, edge.data("direction"));
							//edge.select();
							if (!testConcatSeq) {
								alert("Error with concatenate function: k-mer of " + thisId.bold() + " and " + targetId.bold() + " are not identical");
							};
							console.log(thisId, target.data("id"), concatSequence, edge.data("direction"))
						} else if (enterConditionRR && leaveConditionRR /*&& (initialDirection=="RR"|| initialDirection=="FR")*/) {
							concatHeader += "-" + targetId;
							if (concatSequence == "") {
								sequenceString[0] = reverse(complement(thisSequence));

							} else {
								sequenceString[0] = reverse(complement(concatSequence));
							}

							sequenceString[1] = reverse(complement(targetSequence)).substring(kmerLen - 1);
							concatSequence = sequenceString[0] + sequenceString[1];
							testConcatSeq = verifConcatenateSeq(collection[n], target, kmerLen, edge.data("direction"));
							//edge.select();
							if (!testConcatSeq) {
								alert("Error with concatenate function: k-mer of " + thisId.bold() + " and " + targetId.bold() + " are not identical");
							};
							console.log(thisId, target.data("id"), concatSequence, edge.data("direction"))
						} else if ((enterConditionFF && leaveConditionFR /*&& (initialDirection=="FF"|| initialDirection=="RF" || initialDirection=="FR")*/) || (enterConditionFR && leaveConditionRR /*&& (initialDirection=="FF"|| initialDirection=="RF" || initialDirection=="FR")*/)) {
							concatHeader += "-" + targetId;
							if (concatSequence == "") {
								sequenceString[0] = thisSequence;

							} else {
								sequenceString[0] = concatSequence;
							}

							sequenceString[1] = reverse(complement(targetSequence)).substring(kmerLen - 1);
							concatSequence = sequenceString[0] + sequenceString[1];
							testConcatSeq = verifConcatenateSeq(collection[n], target, kmerLen, edge.data("direction"));
							//edge.select();
							if (!testConcatSeq) {
								alert("Error with concatenate function: k-mer of " + thisId.bold() + " and " + targetId.bold() + " are not identical");
							};
							console.log(thisId, target.data("id"), concatSequence, edge.data("direction"))
						} else if ((enterConditionRR && leaveConditionRF /*&& (initialDirection=="RR"|| initialDirection=="RF" || initialDirection=="FR")*/) || (enterConditionRF && leaveConditionFF /*&& (initialDirection=="RR"|| initialDirection=="RF" || initialDirection=="FR")*/)) {
							concatHeader += "-" + targetId;
							if (concatSequence == "") {
								sequenceString[0] = reverse(complement(thisSequence));

							} else {
								sequenceString[0] = reverse(complement(concatSequence));
							}

							sequenceString[1] = targetSequence.substring(kmerLen - 1);
							concatSequence = sequenceString[0] + sequenceString[1];
							testConcatSeq = verifConcatenateSeq(collection[n], target, kmerLen, edge.data("direction"));
							//edge.select();
							if (!testConcatSeq) {
								alert("Error with concatenate function: k-mer of " + thisId.bold() + " and " + targetId.bold() + " are not identical");
							};
							console.log(thisId, target.data("id"), concatSequence, edge.data("direction"))

						} else if (!isAlerted) {
							//alert gritter if enter and leave condition are not respected
							$.extend($.gritter.options, {
								position : 'bottom-right',

							});
							$.gritter.add({
								title : 'Concatenate warning',
								text : "Node " + thisId.bold() + " can't be concatenated with node " + target.data("id").bold() + ".",
								sticky : false,
								time : 8000,
								class_name : 'alert-gritter',
							});
							isAlerted = true;
							break;

						}
						//}

					}

				}

			}//end of edges loop

			//alert if the sequence concatenate haven't changed compare to the precedent lap of nodes selected loop
			//alert only when:
			//			- target is different of the current node ( 2 loops cause repetition),
			//			- the is not the first or the last
			//			- the target of the edge is selected
			//			- the target of the edge is not in selected nodes
			//if (concatSequence == sequencePrecedente && targetId != thisId && n > 0 && n < collectionLen - 1 && isTarget != collection[n + 1].data("id") && target.selected()) {
			if (concatSequence == sequencePrecedente && n > 0 && n < collectionLen - 1 && target.selected() && isTarget != undefined && isTarget != collection[n + 1].data("id") && !isAlerted) {
				console.log(thisId, targetId, isTarget);
				isAlerted = true, $.extend($.gritter.options, {
					position : 'bottom-right',

				});
				$.gritter.add({
					title : 'Concatenate warning',
					text : "Node " + isTarget.bold() + " can't be concatenated with node " + collection[n + 1].data("id").bold() + ".",
					sticky : false,
					time : 8000,
					class_name : 'alert-gritter',
				});
				isAlerted = true;
				break;
				//continue;

			} else {
				sequencePrecedente = concatSequence;
			}
			

		}//end of nodes selected loop

		//Show concatenate sequences in south pane
		if (concatSequence != "" && concatSequence != undefined && !isAlerted) {
			var $onSequenceSelectionChanged = $("#onSequenceSelectionChanged");
			var formatSelected = $("#setFormat > ul").find(".ui-menu-checked").siblings("label").text();
			var sequenceWidth = parseInt($("#paneSouth").width() / 8.2);
			$onSequenceSelectionChanged.after('<div id="divSequence_'+concatHeader+'" class="ui-sequences ui-concatenated-sequences"> </div>');
			var index;
			var biojs = new Biojs.Sequence({
				sequence : concatSequence,
				target : "divSequence_"+concatHeader,
				format : formatSelected,
				id : concatHeader,
				fontSize : '18px',
				columns : {
					size : sequenceWidth
				}

			});
			
			biojs.hideFormatSelector();
			//// Display position in sequence of char selection ////
			biojs.onSelectionChange(function(e) {
				$(".ui-sequences-selected").show();
				$onSequenceSelectionChanged.text("In node " + concatHeader + " interval selected: " + e.start + ", " + e.end);
				$onSequenceSelectionChanged.data("selectedSequence", [e.start, e.end]);

			});
			
			$("#divSequence_"+concatHeader).data("biojsData",biojs);
	  		
			return concatSequence;


		} else if (!isAlerted) {
			//alert gritter if concatSequence is empty or undefined
			//for( var m=0; m<collectionLen-1; m++) {
			$.extend($.gritter.options, {
				position : 'bottom-right',

			});
			$.gritter.add({
				title : 'Concatenate warning',
				text : "Node " + collection[0].data("id").bold() + " can't be concatenated with node " + collection[1].data("id").bold() + ".",
				time : 8000,
				class_name : 'alert-gritter',
			});
			isAlerted = true;
			//}
			return false;

		}

	}

	
	/*
	 * Check if concatenate sequence is valid between two nodes
	 * 
	 * @method verifConcatenateSeq
	 * @param {object} node The current node
	 * @param {object} target The target of node
	 * @param {int} kmerLen The length of kmer for sequences in the graph
	 * @return {boolean} return true if concatenation is validate
	 */	
	function verifConcatenateSeq (node, target, kmerLen, edgeDirection){
		var thisSeqLenght = node.data("sequence").length;
		
		if(edgeDirection == "FF" || edgeDirection == "ff"){
			var thisSeqKmer = node.data("sequence").substring(thisSeqLenght-(kmerLen-1),thisSeqLenght);
			var targetSeqKmer = target.data("sequence").substring(0, kmerLen - 1);
			console.log(thisSeqKmer, targetSeqKmer);
		}else if(edgeDirection == "RR" || edgeDirection == "rr"){
			var thisSeqKmer = reverse(complement(node.data("sequence"))).substring(thisSeqLenght-(kmerLen-1),thisSeqLenght);
			var targetSeqKmer = reverse(complement(target.data("sequence"))).substring(0, kmerLen - 1);
			console.log(thisSeqKmer, targetSeqKmer);
		}else if(edgeDirection == "FR" || edgeDirection == "fr"){
			var thisSeqKmer =  node.data("sequence").substring(thisSeqLenght-(kmerLen-1),thisSeqLenght);
			var targetSeqKmer = reverse(complement(target.data("sequence"))).substring(0, kmerLen - 1);
			console.log(thisSeqKmer, targetSeqKmer);
		}else if(edgeDirection == "RF" || edgeDirection == "rf"){
			var thisSeqKmer =  reverse(complement(node.data("sequence"))).substring(thisSeqLenght-(kmerLen-1),thisSeqLenght);
			var targetSeqKmer = target.data("sequence").substring(0, kmerLen - 1);
			console.log(thisSeqKmer, targetSeqKmer);
		}

		
		if(thisSeqKmer==targetSeqKmer || reverse(complement(thisSeqKmer))==targetSeqKmer){
			return true;
		}else{
			return false;
		};
		
	}
	


	/*
	 * Concatenate sequence of selected nodes to produce max length sequence
	 * TODO: Correct the concatenate part
	 * TODO: test and improve with cycle
	 * !!! function under dev, it's not ready to use them !!!
	 */
	/*function concatMaxSeq (){
			var concatSequence = "";
			var thisId;
			var targetId;
			var sourceId;
			var nodesLen = cy.nodes().length;
			var concatHeader = "";
			var text = "";
			var sequenceString = [];
			var collection = [];
			var i = 0;
			var nodesVisited = [];
														
			//construct array with selected nodes
			cy.nodes(":selected").each(function(){	
				collection[i] = this;
				i++;
			});
			var kmerLen = collection[0].data("k");
														
			//loop substarter to sequences	
			for (var n =0; n<collection.length; n++){
															
			var id = collection[n].data("id");
			
				//view substarter
				if ((/s[0-9]+$/).test(thisId)) {
					collection[n].edgesTo("#" + thisId).each(function() {
						var targetSelected = cy.nodes("#" + this.data("target") + ":selected");
						var targetSelectedLen = targetSelected.length;
						var direction = this.data("direction");
						var thisSequence = collection[n].data("sequence");
						var targetSequence = targetSelected.data("sequence");
						targetSelected.each(function() {
							console.log(this.data());

						});
						if (targetSelected != 0) {
							//test if nodes have been selected on right side of graph, in other word test if collection[n].data("direction") == FR or FF (edges leave node substarter with FR or FF)
							concatHeader = collection[n].data("id");
							if (direction == "FF" || direction == "ff") {
								sequenceString[0] = thisSequence;
								if (concatSequence != "") {
									sequenceString[1] = concatSequence.substring(kmerLen - 1);
								} else {
									sequenceString[1] = targetSequence.substring(kmerLen - 1);
								}

							} else if ((direction == "RF" || direction == "rf") && this.data("source") > this.data("target")) {
								sequenceString[0] = reverse(complement(thisSequence));
								if (concatSequence != "") {
									//test if nodes have been selected on left side of graph, in other word test if collection[n].data("direction") == FR or FF (edges leave node substarter with FR or FF)
									sequenceString[1] = concatSequence.substring(kmerLen - 1);
								} else {

									sequenceString[1] = targetSequence.substring(kmerLen - 1);
								}

							}
							;

							concatSequence = sequenceString[0] + sequenceString[1];
							console.log(concatSequence);

						}
					});

				} else {
					//if is the first loop and it isn't substarter first elements of sequenceString is node selected sequence
					var nbConnectedEdges = collection[n]._private.edges.length;
					//Parcour de toutes les branches connectées au noeud
					for (var h = 0; h < nbConnectedEdges; h++) {

						var edge = collection[n]._private.edges[h];
						var directionEdgesEnter;
						var directionEdgesLeave;
						var targetSelected = cy.nodes("#" + edge.data("target") + ":selected");
						var targetSelectedLen = targetSelected.length;
						var sourceSelected = cy.nodes("#" + edge.data("source") + ":selected");
						var sourceSelectedLen = targetSelected.length;
						var thisSequence = collection[n].data("sequence");
						var targetSequence = targetSelected.data("sequence");

						//test if target has selected
						if (targetSelectedLen != 0) {

							targetId = targetSelected.data("id");
							sourceId = sourceSelected.data("id");

							//define edges enter direction and edges leave direction
							if (edge.data("target") == targetId) {
								directionEdgesEnter = edge.data("direction");
								//console.log(targetSelected.data("id"))
							}

							if (edge.data("source") == thisId) {
								directionEdgesLeave = edge.data("direction");
							};

							var enterConditionFF = (directionEdgesEnter == "FF" || directionEdgesEnter == "ff" );
							var leaveConditionFF = (directionEdgesLeave == "FF" || directionEdgesLeave == "ff" );
							var enterConditionFR = (directionEdgesEnter == "FR" || directionEdgesEnter == "fr");
							var leaveConditionFR = (directionEdgesLeave == "FR" || directionEdgesLeave == "fr");
							var enterConditionRF = (directionEdgesEnter == "RF" || directionEdgesEnter == "rf");
							var leaveConditionRF = (directionEdgesLeave == "RF" || directionEdgesLeave == "rf");

							if (((enterConditionFF && leaveConditionFF) || (enterConditionFR && leaveConditionRF))) {
								if (concatSequence == "") {
									sequenceString[0] = thisSequence;

								} else {
									sequenceString[0] = concatSequence;
								}

								//define array with nodes have already seen
								nodesVisited.push(thisId);
								var occThis = 0;
								var occTarget = 0;
								var needToVisit = false;
								//see content of nodes visited array
								for (var i = 0; i < nodesVisited.length; i++) {
									//test if the nodes is in the array and save number of occurences
									if (nodesVisited[i] == thisId) {
										occThis++;
									}
									//test if the target nodes is in the array and save number of occurences
									if (nodesVisited[i] == targetId) {
										occTarget++;
									}

									if (nodesVisited[i] == sourceId) {
										needToVisit = true;
									}

								}

								//test if the nodes and is target is present only one time in the array
								if (occThis < 2 && occTarget < 2 && needToVisit) {
									nodesVisited.push(targetId);
									sequenceString[1] = targetSequence.substring(kmerLen - 1);
									concatSequence = sequenceString[0] + sequenceString[1];
									console.log(concatSequence);

								}

							} else if (enterConditionRF && leaveConditionFF) {
								if (concatSequence == "") {
									sequenceString[0] = thisId;

								} else {
									sequenceString[0] = concatSequence;
								}

								//define array with nodes have already seen
								nodesVisited.push(thisId);
								//console.log(n, nodesVisited);
								var occThis = 0;
								var occTarget = 0;
								var needToVisit = false;
								//see content of nodes visited array
								for (var i = 0; i < nodesVisited.length; i++) {
									//test if the nodes is in the array and save number of occurences
									if (nodesVisited[i] == thisId) {
										occThis++;
									}
									//test if the target nodes is in the array and save number of occurences
									if (nodesVisited[i] == targetId) {
										occTarget++;
									}
									if (nodesVisited[i] == sourceId) {
										needToVisit = true;
									}

								}

								//test if the nodes and is target is present only one time in the array
								if (occThis < 2 && occTarget < 2 && needToVisit) {
									nodesVisited.push(targetId);
									sequenceString[1] = targetSequence.substring(kmerLen - 1);
									concatSequence = sequenceString[0] + sequenceString[1];
									console.log(concatSequence);

								}

							} else {

							}
							;

						};
					};
				};
				concatHeader += thisId;
				};

				//loop sequence to substarter
				for (var m = collection.length - 1; m >= 0; m--) {
					var thisId = collection[n].data("id");

					if ((/s[0-9]+$/).test(thisId)) {
						var nbConnectedEdges = collection[n]._private.edges.length;
						//Parcour de toutes les brancehes connectées au noeud
						for (var l = 0; l < nbConnectedEdges; l++) {
							var edge = collection[n]._private.edges[l];
							var sourceSelected = cy.nodes("#" + edge.data("source") + ":selected");
							var sourceSelectedLen = sourceSelected.length;
							var direction = edge.data("direction");
							var thisSequence = collection[n].data("sequence");
							var sourceSequence = sourceSelected.data("sequence");
							//console.log(sourceSequence)

							if (sourceSelectedLen != 0) {
								//test if nodes have been selected on right side of graph, in other word test if collection[n].data("direction") == FR or FF (edges leave node substarter with FR or FF)
								concatHeader = thisId;
								if (direction == "RR" || direction == "rr") {
									sequenceString[0] = reverse(complement(thisSequence));
									if (concatSequence != "") {
										sequenceString[1] = concatSequence.substring(kmerLen - 1);
									} else {
										sequenceString[1] = reverse(complement(sourceSequence));
									}

								} else if ((direction == "RF" || direction == "rf") && edge.data("source") < edge.data("target")) {
									sequenceString[0] = reverse(complement(thisSequence));
									console.log("in")
									if (concatSequence != "") {
										//test if nodes have been selected on left side of graph, in other word test if collection[n].data("direction") == FR or FF (edges leave node substarter with FR or FF)
										sequenceString[1] = concatSequence.substring(kmerLen - 1);
									} else {
										sequenceString[1] = sourceSequence.substring(kmerLen - 1);
									}

								}
								;

								concatSequence = sequenceString[0] + sequenceString[1];
								console.log(concatSequence);

							}
						};

					} else {
						//if is the first loop and it isn't substarter first elements of sequenceString is node selected sequence
						//output concatSequenceRight
						var nbConnectedEdges = collection[n]._private.edges.length;
						//Parcour de toutes les brancehes connectées au noeud
						for (var h = 0; h < nbConnectedEdges; h++) {
							var edge = collection[n]._private.edges[h];
							var directionEdgesEnter;
							var directionEdgesLeave;
							var targetSelected = cy.nodes("#" + edge.data("target") + ":selected");
							var targetSelectedLen = targetSelected.length;
							var sourceSelected = cy.nodes("#" + edge.data("source") + ":selected");
							var sourceSelectedLen = sourceSelected.length;
							var thisSequence = collection[n].data("sequence");
							var targetSequence = targetSelected.data("sequence");

							//test if target has selected
							if (targetSelectedLen != 0) {

								targetId = targetSelected.data("id");
								sourceId = sourceSelected.data("id");

								//define edges enter direction and edges leave direction
								if (edge.data("target") == targetId) {
									directionEdgesEnter = edge.data("direction");
								}

								if (edge.data("source") == thisId) {
									directionEdgesLeave = edge.data("direction");
								};

								var enterConditionRR = (directionEdgesEnter == "RR" || directionEdgesEnter == "rr" );
								var leaveConditionRR = (directionEdgesLeave == "RR" || directionEdgesLeave == "rr" );
								var enterConditionFR = (directionEdgesEnter == "FR" || directionEdgesEnter == "fr");
								var leaveConditionFR = (directionEdgesLeave == "FR" || directionEdgesLeave == "fr");
								var enterConditionRF = (directionEdgesEnter == "RF" || directionEdgesEnter == "rf");
								var leaveConditionRF = (directionEdgesLeave == "RF" || directionEdgesLeave == "rf");

								if ((enterConditionRR && leaveConditionRR) || (enterConditionRF && leaveConditionFR)) {
									if (concatSequence == "") {
										sequenceString[0] = reverse(complement(thisSequence));

									} else {
										sequenceString[0] = concatSequence;
									}

									//define array with nodes have already seen
									nodesVisited.push(thisId);
									var occThis = 0;
									var occTarget = 0;
									var needToVisit = false;
									//see content of nodes visited array
									for (var i = 0; i < nodesVisited.length; i++) {

										//test if the nodes is in the array and save number of occurences
										if (nodesVisited[i] == thisId) {
											occThis++;
										}
										//test if the target nodes is in the array and save number of occurences
										if (nodesVisited[i] == targetId) {
											occTarget++;
										}

										if (nodesVisited[i] == sourceId) {
											needToVisit = true;
										}

									};

									//test if the nodes and is target is present only one time in the array
									if (occThis < 2 && occTarget < 2 && needToVisit) {
										nodesVisited.push(targetId);
										sequenceString[1] = reverse(complement(targetSequence.substring(kmerLen - 1)));
										//console.log(collection[n].data("sequence"))
										concatSequence = sequenceString[0] + sequenceString[1];
										console.log(concatSequence);
									}

								} else if (enterConditionRR && leaveConditionRF) {
									if (concatSequence == "") {
										sequenceString[0] = reverse(complement(thisSequence));

									} else {
										sequenceString[0] = concatSequence;
									}

									//define array with nodes have already seen
									nodesVisited.push(thisId);
									//console.log(m, nodesVisited);
									var occThis = 0;
									var occTarget = 0;
									var needToVisit = false;
									//see content of nodes visited array
									for (var i = 0; i < nodesVisited.length; i++) {
										//test if the nodes is in the array and save number of occurences
										if (nodesVisited[i] == thisId) {
											occThis++;
										}
										//test if the target nodes is in the array and save number of occurences
										if (nodesVisited[i] == targetId) {
											occTarget++;
										}
										if (nodesVisited[i] == sourceId) {
											needToVisit = true;
										}

									}

									//test if the nodes and is target is present only one time in the array
									if (occThis < 2 && occTarget < 2 && needToVisit) {
										nodesVisited.push(targetId);
										sequenceString[1] = tagetSequence.substring(kmerLen - 1);
										concatSequence = sequenceString[0] + sequenceString[1];
										console.log(concatSequence);
									}

								} else {

								}
								;

							};
						};
					};
					concatHeader += thisId;
				}

				//console.log(concatSequence);
				if (concatSequence != "" && concatSequence != undefined) {
					var formatSelected = $("#setFormat > ul").find(".ui-menu-checked").siblings("label").text();
					var sequenceWidth = parseInt($("#paneSouth").width() / 8.2);
					var biojs = new Biojs.Sequence({
						sequence : concatSequence,
						target : "divSequence",
						format : formatSelected,
						id : concatHeader,
						fontSize : '18px',
						columns : {
							size : sequenceWidth
						}

					});
					biojs.hideFormatSelector();
				}

    }*/
     
    
    function readBlob (files, opt_startByte, opt_stopByte) {
		    	
			    if (!files.length) {
			      alert('Please select a file!');
			    }
			    
			    var file = files[0],
			    	//start = parseInt(opt_startByte) || 0,
			   		//stop = parseInt(opt_stopByte) || file.size - 1,
			    	extension = (/\.(sjson)$/i).test(file.name);			    		    
				  reader = new FileReader();
				  reader.onloadend = function (event) {
				  	  var target = event.target;

				  	  if (target.readyState == reader.DONE) { // DONE == 2
				  	  			if(extension){
				    				loadSession(JSON.parse(target.result));
									$('#currentSession').val(localStorage.getItem('sessionName'));
				    			}else{
				    				 alert('Please select SJSON files');
				    			}
				    };	
				    
				  };
				  
				 // var blob = file.slice(start, stop + 1);
		    	  //reader.readAsBinaryString(blob);
		    	  reader.readAsText(file);
		    		
		    	
    	};
 
    	
    //TODO: Optimize save object	
	saveStyle = function (item_click) {
	
		var elements = cy.elements();
		var nodes = cy.nodes().css();
		var edges = cy.edges().css();
		var core =  {"background-color" : $.Color($("#cy").css('background-color')).toHexString()};
		var core_selected = cy.style()._private.coreStyle;
		elements.select();
		var nodes_selected = cy.nodes(":selected").css();
		var edges_selected = cy.edges(":selected").css();
		elements.unselect();
		$('body').layout().close("south");

		
		var css_save = {
			"core": {
       	 		"style": {
            		"unselected": core, 
            		"selected": core_selected,
        		}
    		},
   		 	"nodes": {
        		"style": {
            		"unselected": nodes, 
            		"selected": nodes_selected
       			}
    		},
    		"edges": {
        		"style": {
            		"unselected": edges,
            		"selected":  edges_selected
        		}
   			 }
		};
	
		var text_save = JSON.stringify(css_save);
	
	
		 //downloadDataURI($, {filename: "session.jss",data:"data:application/jss;charset=utf-8,"+encodeURIComponent(text_save)});
	 	/*var url = "data:application/octet-stream;base64,"+ Base64.encode(text_save);*/
	
		uri_content = "data:application/jst;filename=style.jst;charset=utf-8," + encodeURIComponent(text_save);    
    	item_click.attr("href", uri_content);
   
	};
	
	
	applyStyle = function(jsonStyle){
		cy.elements(":selected").unselect();
		
		var rootId = cy._private.root.data("id");
		var root = cy.nodes("#"+rootId);
		var nodes = cy.nodes();
		var edges = cy.edges();
		
		var curStyleObj = cy.style(),
            elementCount = jsonStyle.length;
		
		//reset style to default
		cy.style().resetToDefault();
		
		//support root style
		for (var i = 0; i < elementCount; i++) {
			
			if (jsonStyle[i].selector == "core") {
				$("#cy").css("background-color", jsonStyle[i].css.backgroundColor);
			}
		
			if (jsonStyle[i].selector == "root:unselected") {
				jsonStyle[i].selector = "#" + rootId + ":unselected";
			} else if (jsonStyle[i].selector == "root:selected") {
				jsonStyle[i].selector = "#" + rootId + ":selected";
			} else if (jsonStyle[i].selector == "root") {
				jsonStyle[i].selector = "#" + rootId;
			}

	
		}
		
			//re-apply hide rr edges and content definition
			cy.style().fromJson(jsonStyle).update();
			
			var edges_ff = [],
				edges_rr = [];
			
			edges
			.each(function () {
							
							this.css("content", "data(direction)");
							if (this.data("direction")=="RR" || this.data("direction")=="rr" ){
								edges_rr.push(this);
								this.hide();
							}else if((this.data("direction")=="rf" || this.data("direction")=="RF") && this.data("source")<this.data("target")){
								edges_rr.push(this);
								this.hide();
							}

			});
			nodes.css("content", "data(id)");
			
			//save bypass
			nodes.data("bypass", nodes.css());
			edges.data("bypass", edges.css());
			// save initial style in bypass only for the root
			root.data("bypass", root.css());

	};

	//TODO: link between JSON and session files with head in session files
	//TODO: save starter and substarter clicked
	saveSession = function (itemClick) {
		var sessionSave =new Object(); // { "nodes" : {}, "edges": {}, "position":[] };
		var saveNodes;
		var saveEdges;
		var nbNodes= cy.nodes().length;
		var currentTab = $("#side").find(".ui-tabs-selected").children();
		var headerSessionSave = {header:{
											jsonFiles:localStorage.getItem("fileName"),
											starterSelected: localStorage.getItem("starterSelected"),
											substarterSelected: localStorage.getItem("substarterSelected"),
											coverageFilesSelected: cy.$('#n0').data("coverageFileSelected")
										}
								};
		if(!$("#vizmapper_link").parent().hasClass("ui-state-active")){

			$("#vizmapper_link").trigger("click");

			//$("#nodes_link").trigger("click");
			saveNodes = $("#vizmapper.content").vizMapSave();
			sessionSave.nodes = saveNodes;
		
			$("#edges_link").trigger("click");
			saveEdges = $("#vizmapper.content").vizMapSave();
			sessionSave.edges = saveEdges;
		
		} else if ($("#nodes_link").parent().hasClass("ui-state-active")){
			saveNodes = $("#vizmapper.content").vizMapSave();
			sessionSave.nodes = saveNodes;
		
			$("#edges_link").trigger("click");
			saveEdges = $("#vizmapper.content").vizMapSave();
			sessionSave.edges = saveEdges;
		
		}else if($("#edges_link").parent().hasClass("ui-state-active")){
			saveEdges = $("#vizmapper.content").vizMapSave();
			sessionSave.edges = saveEdges;
		
			$("#nodes_link").trigger("click");
			saveNodes = $("#vizmapper.content").vizMapSave();
			sessionSave.nodes = saveNodes;
		
		};
		
		if(currentConfig.vizstyle.display){	
			if(currentTab[0]==$("#vizstyle_link")[0]){
					$("#vizstyle_link").click();
					$("#core_link").click();
			}else if(currentTab[0]==$("#vizmapper_link")[0] && currentTab[1]==$("#edges_link")[0]) {
					$("#vizmapper_link").click();
					$("#edges_link").click();
			}else if(currentTab[0]==$("#vizmapper_link")[0] && currentTab[1]==$("#nodes_link")[0]){
					$("#vizmapper_link").click();
					$("#nodes_link").click();
			};
		}
	
		
		sessionSave.position = [];
		for(var i=0; i< nbNodes; i++) {
				var nodePosition = cy.$("#n"+i).position(); //select node id=n+i
				sessionSave.position[i] = nodePosition;
		};
		
		console.log(sessionSave);
		$.extend(sessionSave, headerSessionSave);
		var textSessionSave = JSON.stringify(sessionSave);
		var blob = new Blob([textSessionSave], {type: "text/plain;charset=utf-8"});
		saveAs(blob, "session.sjson");
	};

	//TODO: compatibility with new session save
	fakeInputFile = function (item_click) {
	if($(item_click).parent().find('input')[0]==undefined){
		$(item_click).parent().parent().parent().prepend('<input type="file" id="hiddenSessionLoad" class="ui-menu-title ui-state-default" style="display:none" />');
		//localStorage.clear();	
		$('#hiddenSessionLoad').change( function(){				
					var files = $(this)[0].files;
				 		fileName = files[0].name;	 		
						//localStorage["fileName"]= fileName;
						//$('#selectedfile').val(fileName);
						localStorage["sessionName"]= fileName;
		      			readBlob(files, null, null); 				 	 
		});
	};
	
	setTimeout(function(){
		$('#hiddenSessionLoad').trigger('click');
	
	},10);
	
	};
	
	loadSession = function (sessionData) {
		var currentTab = $("#side").find(".ui-tabs-selected").children();
		$("#vizmapper_link").click();
		$("#edges_link").click();

		var edges = cy.edges(),
			cssEdges = edges.css(); 
			/*initLine = edges.css("line-color"), 
			initTarget = edges.css("target-arrow-color"), 
			initSource = edges.css("source-arrow-color"), 
			initLabel = edges.css("color"), 
			initOpacity = edges.css("opacity"), 
			initLineStyle = edges.css("line-style"), 
			initSize = edges.css("width");*/

		var updateInitialOptsEdges = {
			controlPoints : [
								cssEdges.lineColor + " 0% " + cssEdges.opacity + " " + cssEdges.lineStyle + " " + cssEdges.width + " ", 
							 	cssEdges.lineColor + " 100% " + cssEdges.opacity + " " + cssEdges.lineStyle + " " + cssEdges.width + " "
							 ]
		};

		$("#vizmapper.content").vizMapRestore(sessionData.edges, updateInitialOptsEdges, currentConfig); 

		$("#nodes_link").click();
		
		var nodes = cy.nodes(),
			cssNodes = nodes.css();
			/*initBackground = nodes.css("background-color"), 
			initBorder = nodes.css("border-color"), 
			initLabel = nodes.css("color"), 
			initOpacity = nodes.css("opacity"), 
			initShape = nodes.css("shape"), 
			initSize = nodes.css("width");*/

		var updateInitialOptsNodes = {
			controlPoints : [
								cssNodes.backgroundColor + " 0% " + cssNodes.opacity + " " + cssNodes.shape + " " + cssNodes.width + " ", 
								cssNodes.backgroundColor + " 100% " + cssNodes.opacity + " " + cssNodes.shape + " " + cssNodes.width + " "
							]
		};
		
		$("#vizmapper.content").vizMapRestore(sessionData.nodes, updateInitialOptsNodes, currentConfig); 

			
		if(currentTab[0]==$("#vizstyle_link")[0]){
				$("#vizstyle_link").click();
				$("#core_link").click();
			}else if(currentTab[0]==$("#vizmapper_link")[0] && currentTab[1]==$("#edges_link")[0]) {
				$("#vizmapper_link").click();
				$("#edges_link").click();
			}
			
			var nbNodes= sessionData.position.length;	
			for(var i=0; i< nbNodes; i++) {	
					cy.$('#n'+i).position(sessionData.position[i]); 
			};	
		

	};	
	
	
	//TODO:Graph save in json
	//fix display bug with restore and set tab				
	/*f_update_preview = function () {
 
		$(".vizmapperPicker-ctrlPt").each(function() {
					var $data = $(this).data();
					console.log($data);
					//$data.shapeChanged();
					//$data.opacityChanged();
					//$data.sizeChanged();
		});	
	};*/
	var methods={
		init : function(type, config){
			var $el= $(this);	
			var cytoscapeMenu = new CytoscapeMenu($el);
			$el.data("CytoscapeMenu", cytoscapeMenu);
			if(type == "graph"){
				cytoscapeMenu.menuGraph(config);
			}else if(type == "sequence"){
				cytoscapeMenu.menuSeq();
			}
		return cytoscapeMenu;
		}
	};
	
	$.fn.extend({
			cytoscapeMenu: methods.init
	});
})(jQuery);