/**
 * @author ALEXAN ANDRIEUX
 */

//TODO:getMaxLayer et getMaxOrder dans graph.js pour avoir la bonne echelle 
;(function($$) {

	var defaults = {
		type : "line",
		orientation : "horizontal",
		fitPadding: 100, // padding when fitting
		root:undefined,
		rightChildren:undefined,
		leftChildren: undefined,
		withEdgesBends : true,
		withXOrdersShift : true,
		coefLayerDist: [0,100], // define distance between two nodes by coefLayerDist[0]+coefLayerDist[1]*node.layer
		coefXOrderDist: [0,100], // define distance between two nodes by coefXOrderDist[0]+coefXOrderDist[1]*node.xorder
		alertSizeGraph: 250,
		ready: undefined, // callback on layoutready
		stop: undefined // callback on layoutstop
	};

	function HierarchicalLayout(options) {
		this.options = $$.util.extend({}, defaults, options);
	}
	
	function drawLayout(options){
	var startTime = new Date().getTime();
	  
    var elapsedTime = 0;  

		var cy = options.cy,
			edges = cy.edges(),
			graph = new Graph();
			console.log(graph);
			
		var childrenPosition = {
									right:options.rightChildren,
									left: options.leftChildren
							};
							
		edges.each(function() {

			if (this.data("direction") == "FF" || this.data("direction") == "ff") {
				graph.addEdge(this.data("source"), this.data("target"));
			} else if ((this.data("direction") == "rf" || this.data("direction") == "RF") && this.data("source") > this.data("target")) {
				graph.addEdge(this.data("source"), this.data("target"));
			}

		});

		graph.hierarchicalDrawing(options.orientation, options.type, options.withEdgesBends, options.withXOrdersShift, childrenPosition);
		//console.log(graph.nodes)
		var coefLayerDist = options.coefLayerDist,
			coefXOrderDist = options.coefXOrderDist,
			graphNodes= graph.nodes;
		
		for (var n in graph.nodes) {
			var cyNode = cy.elements("node[id='" + graphNodes[n].id + "']");
			cyNode.position('y', coefLayerDist[0] + coefLayerDist[1] * graphNodes[n].layer);
			cyNode.position('x', coefXOrderDist[0] + coefXOrderDist[1] * graphNodes[n].xOrder);
		}
		
		 elapsedTime = new Date().getTime() - startTime;
		 var minutes =  elapsedTime/(1000*60);
		 var seconds = elapsedTime/1000;
    	 console.log(Math.floor(minutes) + "min "+Math.floor((minutes-Math.floor(minutes))*60)+ "sec "+Math.floor(((seconds)-Math.floor(seconds))*1000)+" ms");  

	}


	HierarchicalLayout.prototype.run = function() {
		var options = this.options,
			cy = options.cy,
			nodes = cy.nodes(),
			edges = cy.edges(),
			container = cy.container(),
			width = container.clientWidth,
			height = container.clientHeight;

		/*
		 * test of graph.js
		 *
		 */
		
		// arbor doesn't work with just 1 node
		if(nodes.length <= 1 ){
			if( options.fit ){
				cy.reset();
			}

			cy.one("layoutstop", options.stop);
			cy.trigger("layoutstop");

			cy.one("layoutstop", options.stop);
			cy.trigger("layoutstop");

			return;
		}
		
		options.ready = false;
		
		if (edges.length > options.alertSizeGraph) {
			$("#dialog-confirm").dialog({
				resizable : false,
				modal : true,
				buttons : {
					"Continue" : function() {
						$(this).dialog("close");
						drawLayout(options);

					},
					Cancel : function() {
						$(this).dialog("close");
						cy.layout({name: 'grid'});
					}
				}
			});
			$("#dialog-confirm").find(".ui-icon-alert").after("<div>The graph has " + cy.nodes().length + " nodes and " + cy.edges().length + " edges. Generate hierarchical layout can take lot of time. </div>");
		} else {
			drawLayout(options);
		}
		if( !options.ready ){
					options.ready = true;
					cy.one("layoutready", options.ready);
					cy.trigger("layoutready");
		}
		
		cy.one("layoutstop", options.stop);
		cy.trigger("layoutstop");
		
		if( cy.elements().size() === 0 ){
				cy.reset();
		} else {
				cy.fit( options.fitPadding );
		}

	};

	HierarchicalLayout.prototype.stop = function() {
		
	};
	
	
	$$("layout", "hierarchical", HierarchicalLayout);

})(cytoscape);
