$(function () {
	    var VISUAL_STYLE_URI = "./style/initStyle.tjson";
	    var CONFIG_STYLE_URI = "./config.json";
	    
	    //replace alert browser with jquery UI dialogue
	    window.alert = function(message){
			    $(document.createElement('div'))
			        .attr({title: 'Warning', 'class': 'alert'})
			        .html(message)
			        .dialog({
			            buttons: {OK: function(){$(this).dialog('close');}},
			            close: function(){$(this).remove();},
			            draggable: true,
			            modal: true,
			            resizable: false,
			            width: 'auto'
			        });
		};
		
		var 
	    	networkData = JSON.parse(localStorage.getItem('networkData')),
	        lengthMax = 0,
	        maxNodesCoverage = 0,
	        maxEdgesCoverage = 0,
	        visualStyles = {},
	        config = {}, 
	        requests = [], 
	        seqNodesLength = 0,
	        $cy = $("#cy"),
	  	    $body = $('body');
	  	    

	  	    //// Load default visual style (initStyle.tjson) ////	
		requests.push(
	          $.getJSON(VISUAL_STYLE_URI, function (tjson) {
	              visualStyles = tjson;
	           
	          }),
	          
	          $.getJSON(CONFIG_STYLE_URI, function (file) {
		              config = file;
		      }) 
	          
	     );
	      
	        //// Call drawNetwork() for load data graph (json file) ////	
	     $.when.apply($, requests).done(
	        function () {
	    					
			$(document)
				////Add gif picture when graph is loading: loading class add ajax-loader.gif (style.css)////
				.ajaxStart(function(){
		        		$("#cy").addClass("loading");			
		    	})
		    	.ready(function(){
		
						
						tabs("#dataTable");
						
						$('#side').prepend("<ul> </ul>");
					 	if(config.vizstyle.display){
					 			$('#side ul').append('<li>\
													<a id="vizstyle_link" href="#vizstyle">\
														<span>Visual Style</span>\
													</a>\
								</li>');
								$("#side_content").append(" <div id='vizstyle' class='content'> </div>");
					 	};
						  	
						if(config.vizmapper.display){
								$('#side ul').append('<li>\
														<a id="vizmapper_link" href="#vizmapper">\
															<span>Vizmapper</span>\
														</a>\
													</li>');
								$("#side_content").append(" <div id='vizmapper' class='content'> </div>");
						};
							
							//append header div for subtabs
						$("#side_content > .content").each(function(){
									 var id = $(this).attr("id");
										$("#side_header").append('<div id="' + id + '_header" class="header"></div>');
						});
		
						tabs("#side");
						
						//// Initialize menu for graph elements and check default values ////
						var $menu_northPaneVisuGraph = $("#menu_northPaneVisuGraph");
						$menu_northPaneVisuGraph.cytoscapeMenu("graph", config);
						$menu_northPaneVisuGraph.find("#nodesLabel").children(":first").addClass("ui-menu-checked");
						$menu_northPaneVisuGraph.find("#edgesLabel").children(":first").addClass("ui-menu-checked");
						$menu_northPaneVisuGraph.find("#default").children(":first").addClass("ui-menu-checked");
										
						//// Initialize all panel (jquery.layout-latest.js) ////
						$("body").layout({
									slideTrigger_open:		"mouseenter",
									north__paneSelector:  "#paneNorth",
									north__resizable:    false,
									north__slidable:     false,
									north__closable:     false,
									east__paneSelector:  "#side",
									east__size:  "280",
									west__paneSelector:  "#dataTable",
									west__size:  "280",
									south__paneSelector:  "#paneSouth",
									south__minSize: 21,
									south__initClosed:   true,
									south__spacing_closed:   28,
									south__slidable:     false,
	
						});
						$(".ui-layout-resizer-south").attr("id", "sequences-resizer");
						
						//// Initialize menu for sequences and check default values ////
						var $menu_southPaneVisuGraph = $("#menu_southPaneVisuGraph");
						$menu_southPaneVisuGraph.cytoscapeMenu("sequence");
						$menu_southPaneVisuGraph.find("#fasta").children(":first").addClass("ui-menu-checked");
						
			}); 
		
			drawNetwork(networkData, visualStyles, config); 
	     
			   	
	 });   
	     
	     


/********************************************************** defined functions *******************************************************/ 
        
		
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		////																											  		////
		////    If length is present in data node, function find and return the biggest length of sequence in the list of nodes	////
		////	else function calculate the length sequence of each node and return the biggest length calculated.				////
		////	Function fill tableNodes with data of each node (id, length, depth, sequence)									////
		////																													////						 		  		  																	  	  	////
		////		Inputs : - nodes : list of nodes with data (object)													 		////
		////				 - tableNodes: 	empty array (array[])														 		////
		////		Outputs: - return the biggest length of sequence founded in the list of nodes						  		////				 
		////				 - tableNodes is filled with data of each node														////
		////									  																		  		////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    	
        function initNodesData(nodes, tableNodes) {
            var nodeCount = nodes.length;
           	
            for (var i = 0; i < nodeCount; i++) {
            	
               var nodeData =  nodes[i].data,
				   seqNodesCoverage = nodeData.coverageValSelected;
				   seqNodesLength = nodeData.length;
			  
			  
			    //// If length is not present in data node, calculate the length sequence of each node ////
				if( seqNodesLength==undefined){
					seqNodesLength = nodeData.sequence.length;
					cy.nodes("[id="+i+"]").data("length", seqNodesLength);
				}

				//// find the biggest sequence length ////
				if( seqNodesLength > lengthMax){
						lengthMax = seqNodesLength;						
				};
				
				if(seqNodesCoverage!="none" || seqNodesCoverage!=undefined){
						if( seqNodesCoverage >  maxNodesCoverage){
							 maxNodesCoverage = seqNodesCoverage;						
						};
				}
				
				//// tableNodes is filled with data node ////
			  	tableNodes[i] ={
			  				"ids" : nodeData.id,
							"length" : seqNodesLength,
							"avg_coverage" : seqNodesCoverage,
							"sequence" : nodeData.sequence
			  	};	
            };
           
            return [lengthMax,  maxNodesCoverage];
        };
        
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		////																											  		////
		////	Function fill tableEdges with data of each edge (id, source, target, direction)									////
		////																													////						 		  		  																	  	  	////
		////		Inputs : - edges : list of edges with data (object)													 		////
		////				 - tableEdges: 	empty array (array[])														 		////
		////		Outputs: - tableEdges is filled with data of each edge														////
		////									  																		  		////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		function initEdgesData(edges, tableEdges){
        	var edgeCount = edges.length,
 				edgeData;
 			
            for (var i = 0; i < edgeCount; i++) {
            	
             	var  edgeData = edges[i].data,
             		 edgeCoverage = edgeData.coverageValSelected;     
				
				if(edgeCoverage!="none" || edgeCoverage!=undefined){
						if( edgeCoverage > maxEdgesCoverage){
							maxEdgesCoverage = edgeCoverage;						
						};
				}
			  //// tableEdges is filled with data edge ////
			  tableEdges[i] ={
			  				"ids" : edgeData.id,
							"source" : edgeData.source,
							"target" : edgeData.target,
							"direction" :  edgeData.direction,
							"avg_coverage" : edgeData.coverageValSelected
			  	};
			  	
            };
            
		return maxEdgesCoverage;
        };
        
        function sideTaskBarSupport(){
        	var height = $('#cy').height();
        	$('#side').css("height", height);
			var newHeight = height-$('.ui-layout-header').outerHeight()-$('#side > .ui-tabs-nav').outerHeight()-$('#paneTask').height();
		    $('#side_content').css("height", newHeight);	
        };
        
        function southTaskBarSupport(){
        	var correctionHeight = $('#sequences_content').height()-$('#paneTask').height();
			$('#sequences_content').css("height", correctionHeight);
		};
        
        function clickOnNodes (){	
        	$('#dataGraph_nodes tr').click( function(e){   	   				    	   				
    	   				var $this = $(this);
				        if ( !$this.hasClass('selected')) {
				        	if(!e.shiftKey){
				        		cy.nodes(":selected").unselect();
				           		//$this.parent().find(".selected").removeClass('selected');
				            }
				            $this.addClass('selected');
    	   					cy.nodes('#'+$this.children(":first").text()).select();
          				}
          	});
          	
          	
        };
        
        function clickOnEdges (){	
        	$('#dataGraph_edges tr').click( function(e){   	   				    	   				
    	   				var $this = $(this);
				        if ( !$this.hasClass('selected')) {
				        	if(!e.shiftKey){
				        		cy.edges(":selected").unselect();
				           		//$this.parent().find(".selected").removeClass('selected');
				           }
				            $this.addClass('selected');
    	   					cy.edges('#'+$this.children(":first").text()).select();
          				}
          	});
        };
        
        labelEdgesIsShow = function (bool){
		if(!bool){
			$(".label.edges > input").attr("disabled", true);
			$(".label.edges > select").attr("disabled", true);
			$(".ui-continuous_map[property=edges_label]").hide();

		}else{
			$(".label.edge > input").attr("disabled", false);
			$(".label.edge > select").attr("disabled", false);
			$(".ui-continuous_map[property=edges_label]").show();
		}
		
		};
		
		 labelNodesIsShow = function (bool){
			if(!bool){
				$(".label.nodes > input").attr("disabled", true);
				$(".label.nodes > select").attr("disabled", true);
				$(".ui-continuous_map[property=nodes_label]").hide();
			}else{
				$(".label.nodes > input").attr("disabled", false);
				$(".label.nodes > select").attr("disabled", false);
				$(".ui-continuous_map[property=nodes_label]").show();
			}
		};
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		////																											  		////
		////	Initialize table nodes and edges in west pane																	////
		////																													////
		////		Inputs : - tableNodes : array of nodes data													 				////
		////				 - tableEdges: 	array of edges data														 			////
		////		Outputs: - table : object contains array of nodes and array of edges										////
		////									  																		  		////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        function initPaneWestContent(tableNodes, tableEdges){
          var $tables ={},
			  height = $('#cy').height(),
			  tableHeight = height - $('#dataTable > .ui-tabs-nav').outerHeight() - $('#paneTask').height(),  //-22px for task panel size
			  tableWidth = $('#dataTable').width();  
          
		  $('#dataTable').css("height",  height);
		  $('#dataTable_content').css("height", tableHeight);
   			  
    	  $('#graphNodes').append('<table cellpadding="0" cellspacing="0" border="0" class="display dataGraph" id="dataGraph_nodes">\
							    	  <thead>\
											<tr>\
											<th>ID</th>\
											<th>Length</th>\
											<th>Coverage</th>\
											<th>Sequence</th>\
											</tr>\
									 </thead>\
    	  						</table>');

    	   
    	 $('#graphEdges').append('<table cellpadding="0" cellspacing="0" border="0" class="display dataGraph" id="dataGraph_edges">\
							    	  <thead>\
											<tr>\
											<th>ID</th>\
											<th>Source</th>\
											<th>Target</th>\
											<th>Direction</th>\
											<th>Coverage</th>\
											</tr>\
									 </thead>\
    	  						</table>');
    	//  $('#graphEdges').append('<table cellpadding="0" cellspacing="0" border="0" class="display dataGraph" id="dataGraph_edges"></table>');

    	  
    	  $tables.nodes= $('#dataGraph_nodes').dataTable({        										
        										"bJQueryUI": true,
        										"sScrollX": tableWidth,
        										"sScrollY": tableHeight,
    											"bPaginate": false,
        										//"sPaginationType": "full_numbers",
        										"bProcessing": true,
        										//"aLengthMenu": [[10, 25, 50, 100, -1], [10, 25, 50, 100, "All"]],
        										"aaData": tableNodes,
        										"aoColumns": [
            													{ "mData": "ids" },
            													{ "mData": "length" },
            													{ "mData": "avg_coverage" },
            													{ "mData": "sequence" }
            												 ],
            								//	"bDeferRender": true
								
    	   });
    	   
    	   $("#dataGraph_nodes_filter").find ("input").keyup(function(){
    	   	  	var highlightStr = $(this).val(); 
		    	
		    	$("#dataGraph_nodes > tbody > tr").each(function(){		    	   	  		
		    	   	  		var trSeq = $(this).children()[3];
		    	   	  		$(trSeq).highlight(highlightStr);

	    		});
	
    	   });
    	   
    	   $("#graphEdges_link").click();
    	   $tables.edges = $('#dataGraph_edges').dataTable({        										
        										"bJQueryUI": true,
        										"sScrollX": tableWidth,
        										"sScrollY": tableHeight,
    											"bPaginate": false,
        										//"sPaginationType": "full_numbers",
        										"bProcessing": true,
        										//"aLengthMenu": [[10, 25, 50, 100, -1], [10, 25, 50, 100, "All"]],
        										"aaData": tableEdges,
        										"aoColumns": [
            													{ "mData": "ids" },
            													{ "mData": "source" },
            													{ "mData": "target" },
            													{ "mData": "direction" },
            													{ "mData": "avg_coverage" }
            													
            												 ],
            									//"bDeferRender": true
									
    	   });

    	 //add updateTable to cy core
    	 cytoscape( "collection", "updateTable", function(idTable, index, columns, value, max){
					 var oTableElements =$(idTable).dataTable();
					 oTableElements.fnUpdate( value, index, columns ); // Single cell
					 if(this._private.group == "nodes"){
					 	 cy._private.maxNodesCoverage = max;
					 }else if(this._private.group = "edges"){
					 	 cy._private.maxEdgesCoverage = max;
					 }
		});

		   $("#graphNodes_link").click(function(){
				scrollBarSupport(50, config);
				clickOnNodes();		   	
		   });
		   
		    $("#graphEdges_link").click(function(){
				 scrollBarSupport(50, config);
				 clickOnEdges ();		   	
		   });
		   
		   
		   //// support for resize window and scrollbar appaerance ////	  
	 		$('.ui-layout-resizer-west')
				//// hack for fix mouseup event after mousemove/drag ////
				//TODO: make event resize canvas in vismapper.js
				.on('mousedown.namespace', function() {
						$(document).one('mouseup', function() {
								   $cy.cytoscapeNavigator().resize();
								   $(document).off('mousedown.namespace');
						});
						
						  
			});
		
														
			$(".ui-layout-toggler-west").click(function(){
							$cy.cytoscapeNavigator().resize();
			});
  			
  			$(window).resize(function(){												 				
					setTimeout(function(){
			    				sideTaskBarSupport();
			    	},200);
			    	scrollBarSupport(400, config);				
								
			});
			
  			$("#graphNodes_link").click();
  			

  	
  				
    		return $tables;
    	   
        };
        
              
       ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	   ////																											  		   ////
	   ////	Initialize vizstyle and vizmapper in east pane																	   ////
	   ////																													   ////
	   ////									  																		  		   ////
	   ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
       function initPaneEastContent (config){
			var 
				saveNodes,
				saveEdges,
				saveHoldRoot=false,
				first_click_vizmapper = undefined,
				first_click_vizstyle = true,
				vizstyle_is_active = false,
				vizmapper_is_active = false,
				first_click_nodes = false,
				first_click_edges = false,
				tab_nodes_is_active = false,
				tab_edges_is_active = false,
				vizstyle_display = config.vizstyle.display,
				vizmapper_display = config.vizmapper.display,
				save;
				
							
	  	//// define action on windows resize ////
	  	//// support for resize window and scrollbar appaerance //// 
	 	$(".ui-layout-resizer-east")
				//// hack for fix mouseup event after mousemove/drag ////
				//TODO: make event resize canvas in vismapper.js
				.on('mousedown.namespace', function() {
							$(document).one('mouseup', function() {
								    scrollBarSupport(400, config);
								    $cy.cytoscapeNavigator().resize();
									$(document).off('mousedown.namespace');
							});
												  
				})
				.mouseover(function(){
						if($("#vizmapper.content").children()[0] != undefined && $("#vizmapper.content").width()==0){
									scrollBarSupport(400, config);
						}
				});		
							
								
		$(".ui-layout-toggler-east").click(function(){
				if($("#vizmapper.content").children()[0] != undefined){
							scrollBarSupport(50, config);
							$cy.cytoscapeNavigator().resize();	
				}else if($("#vizstyle.content").children()[0] != undefined){		
							$cy.cytoscapeNavigator().resize();
				}		  	
		});
							
		//redimensionnement et placement des pickers aprés l'apparition d'une scrollbar
		//TODO: optimiser pour faire update vizmapper selelement quand necessaire 
						 	
		//var scrollbarBeforeResize;
		//setTimeout(function(){
		//scrollbarBeforeResize = $("#vizmapper.content").vizMapScrollable();
		 //}, 150);	
		
		
			if(vizstyle_display){
				//// define action on click vizstyle tab ////
				//TODO:unbind click  
				$("#vizstyle_link").click( function(){
					
					if(vizmapper_is_active && tab_nodes_is_active){
						saveNodes = $("#vizmapper.content").vizMapSave();
						saveHoldRoot=$("#hold_root").prop("checked");
						first_click_vizmapper = false;	
					};
					if(vizmapper_is_active && tab_edges_is_active){
						saveEdges = $("#vizmapper.content").vizMapSave();
						first_click_vizmapper = false;	
					};  
					
					emptyWestPane();
				
					$("#vizstyle_header").append(
											'<div id="vizstyle_tabs"><ul>\
													<li><a id=core_link>Core</a></li>\
													<li><a id=nodes_link>Nodes</a></li>\
													<li><a id=edges_link>Edges</a></li>\
											</ul></div>');
					
					tabs("#vizstyle_tabs");
													
					var vizstyle = $("#vizstyle.content").vizStyle("core");
					first_click_vizstyle = false;
			
					$("#core_link").click( function(){
						vizstyle.coreHtml();
						tab_nodes_is_active = false;
						tab_edges_is_active = false;
					});
					$("#nodes_link").click( function(){
					    vizstyle.nodesHtml();
					    if($("#nodesLabel").children(".ui-menu-checked")[0] != undefined){
					    	labelNodesIsShow(true);
					    }else{
					    	labelNodesIsShow(false);
					    }
						tab_nodes_is_active = true;
						tab_edges_is_active = false;               
					});
					
					$("#edges_link").click( function(){
							vizstyle.edgesHtml();
							if($("#edgesLabel").children(".ui-menu-checked")[0] != undefined){
					    		labelEdgesIsShow(true);
					    	}else{
					    		labelEdgesIsShow(false);
					    	}
							tab_nodes_is_active = false;
							tab_edges_is_active = true;                           
					});
					
					setTimeout(function(){	
				    		sideTaskBarSupport();
				    },250);
	
					vizmapper_is_active = false;
					vizstyle_is_active = true;
				});
			}else{
				vizmapper_is_active = true;
			}
			
			
			//// define action on click vizmapper tab ////
			$("#vizmapper_link").click( function(){
				if(vizstyle_display==false || vizstyle_is_active){
					emptyWestPane();
					
					$("#vizmapper_header").append(
											'<div id="vizmapper_tabs"><ul>\
													<li><a id=nodes_link>Nodes</a></li>\
											  </ul></div>');
				
					if(cy._private.maxEdgesCoverage!=0){
						$("#vizmapper_tabs ul").append("<li><a id=edges_link>Edges</a></li>");
					}
					
					tabs("#vizmapper_tabs");
			
					if(first_click_vizmapper == undefined){
						vizmapperNodes(config);
						first_click_vizmapper =true;
						tab_nodes_is_active = true;
						tab_edges_is_active = false;
						first_click_nodes = true;
						first_click_edges = undefined;
						
						if($("#nodesLabel").children(".ui-menu-checked")[0] != undefined){
						    	labelNodesIsShow(true);
						}else{
							   	labelNodesIsShow(false);
						}
						 	
					}else{
						
							$("#nodes_link").parent().addClass("ui-state-active ui-tabs-selected").siblings().removeClass("ui-state-active ui-tabs-selected");
							//set value of initialopts for vizmapper in the aim to define base style of vizmapper in other word define the result of reset vizmapper 
							var nodes = cy.nodes(),
								cssNodes = nodes.css(); 
								/*initBackground = nodes.css("background-color"), 
								initBorder = nodes.css("border-color"), 
								initLabel = nodes.css("color"), 
								initOpacity = nodes.css("opacity"), 
								initShape = nodes.css("shape"), 
								initSize = nodes.css("width");*/

							var updateInitialOpts = {
								controlPoints : [
													cssNodes.backgroundColor + " 0% " + cssNodes.opacity + " " + cssNodes.shape + " " + cssNodes.width + " ", 
													cssNodes.backgroundColor + " 100% " + cssNodes.opacity + " " + cssNodes.shape + " " + cssNodes.width + " "
												]
							};

							$("#vizmapper.content").vizMapRestore(saveNodes, updateInitialOpts, config); 
							
							tab_nodes_is_active = true;
							tab_edges_is_active = false;
							first_click_nodes = false;

			    	};
						
					//TODO:do the same without trigger on active sub-tab
					//// vizstyle save and restore ////						   
					$("#nodes_link").click( function(){
 
							if(tab_edges_is_active && vizmapper_is_active){
								
								if(first_click_edges != undefined){ //save if alraedy click edges
											saveEdges = $("#vizmapper.content").vizMapSave();	
								};
							
								if(first_click_nodes != undefined ){//restore if alredy click node
										//set value of initialopts for vizmapper in the aim to define base style of vizmapper in other word define the result of reset vizmapper 
										var nodes = cy.nodes(),
											cssNodes = nodes.css(); 
											/*initBackground = nodes.css("background-color"), 
											initBorder = nodes.css("border-color"), 
											initLabel = nodes.css("color"), 
											initOpacity = nodes.css("opacity"), 
											initShape = nodes.css("shape"), 
											initSize = nodes.css("width");*/
			
										var updateInitialOpts = {
											controlPoints : [
																cssNodes.backgroundColor + " 0% " + cssNodes.opacity + " " + cssNodes.shape + " " + cssNodes.width + " ", 
																cssNodes.backgroundColor + " 100% " + cssNodes.opacity + " " + cssNodes.shape + " " + cssNodes.width + " "
															]
										};
			
										$("#vizmapper.content").vizMapRestore(saveNodes, updateInitialOpts, config); 
										first_click_nodes=false;															
								}else{
										vizmapperNodes(config);
										first_click_nodes=true;			
								};

								tab_edges_is_active = false;
								tab_nodes_is_active = true;		
							};
							
							if($("#nodesLabel").children(".ui-menu-checked")[0] != undefined){
						    	labelNodesIsShow(true);
							}else{
							   	labelNodesIsShow(false);
							}	
												
						scrollBarSupport(0, config);					
					});
					//// vizstyle save and restore ////				
					$("#edges_link").click( function(){

							if(tab_nodes_is_active && vizmapper_is_active){
								if(first_click_nodes != undefined){ //save if alraedy click nodes
											saveNodes = $("#vizmapper.content").vizMapSave();
											saveHoldRoot = $("#hold_root").prop("checked");
								};	
							
								if(first_click_edges != undefined ){//restore if alredy click edges							
										var 
											edges = cy.edges(),
											cssEdges = edges.css();
											/*initLine = edges.css("line-color"),	
											initTarget = edges.css("target-arrow-color"),
											initSource = edges.css("source-arrow-color"),
											initLabel = edges.css("color"),
											initOpacity = edges.css("opacity"),
											initLineStyle= edges.css("line-style"),
											initSize = edges.css("width");*/
											
										var updateInitialOpts = {
											controlPoints: [
																cssEdges.lineColor + " 0% " + cssEdges.opacity + " " + cssEdges.lineStyle + " " + cssEdges.width + " ", 
							 									cssEdges.lineColor + " 100% " + cssEdges.opacity + " " + cssEdges.lineStyle + " " + cssEdges.width + " "
															]
										};
											
										$("#vizmapper.content").vizMapRestore(saveEdges, updateInitialOpts, config);
										first_click_edges=false;
								}else{

										vizmapperEdges(config);
										first_click_edges=true;
								};
								
								tab_edges_is_active = true;
								tab_nodes_is_active = false;
							};
							
						if($("#edgesLabel").children(".ui-menu-checked")[0] != undefined){
					    		labelEdgesIsShow(true);
					    }else{
					    		labelEdgesIsShow(false);
					    }		
					
					scrollBarSupport(0, config);
					});
			
				};
			
			
			vizmapper_is_active = true;
			vizstyle_is_active = false;
			scrollBarSupport(0, config);
			});
			
			
		};
	
		 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		 ////																											  		////
		 ////	Empty tabs and subtabs for vizstyle and vizmapper 																////
		 ////		Input: string 			 																					////
		 ////									  																		  		////
		 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		 function emptyWestPane(){	
			$("#vizstyle_header").empty();
			$("#vizstyle").empty();
			$("#vizmapper_header").empty();
			$("#vizmapper").empty();
					
			//$("#custom_"+custom)
				//.find(".ui-menu-check-icon").addClass("ui-menu-checked")
				//.siblings().find(".ui-menu-check-icon").removeClass("ui-menu-checked");
		 };
		 
		 
		 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		 ////																											  		////
		 ////	Constructor for nodes vizmapper in east pane																	////
		 ////									  																		  		////
		 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		 function vizmapperNodes (config) {
		   //// get nodes style ////
		   var 
		   		nodes = cy.nodes(),
		   		cssNodes = nodes.css(),
				/*initBackground =  nodes.css("background-color"),
				initBorder =  nodes.css("border-color"),
				initLabel = nodes.css("color"),
				initOpacity = nodes.css("opacity"),
				initShape= nodes.css("shape"),
				initSize = nodes.css("width"),*/
				initType = "gradient";
			
			cy._private.vizmapperType= initType;
			//// generate and display vizmapper for nodes////)
			//TODO:all opt in config file
			if(cy._private.maxNodesCoverage!=0){
				$("#vizmapper.content").vizMap({
									group : "nodes",
									property: ["Length", "Coverage"], //properties allow for nodes length, coverage // you can have one are some of them
									controlPoints: ["#ff0000 0% 1 ellipse 20 " , "#ffa500 50% 1 ellipse 30 ", "#008000 100% 1 ellipse 40 "],
									fillDirection: "left",
									/* example of attrCss: [{"stylesheet":["fill", "border", "label"]},
									{"stylesheet":["filyl"]}],*/
									attrCss: [{"stylesheet":["shapes"]},  //fill, border, or label for advanced mode and "shapes" and "colors" for pre-configured
											  {"stylesheet":["colors"]}],								 
									//type: "gradient",
									type: initType,
									tableOfNodes:'#dataGraph_nodes',
									tableOfEdges:'#dataGraph_edges'
									//change:function(){
									//}
				}, config);
			}else{
				$("#vizmapper.content").vizMap({
									group : "nodes",
									property: ["Length"], //properties allow for nodes length, coverage // you can have one are some of them
									controlPoints: [
														cssNodes.backgroundColor+" 0% "+cssNodes.opacity+" "+cssNodes.shape+" 20" , 
														cssNodes.backgroundColor+" 50% "+cssNodes.opacity+" "+cssNodes.shape+" 30",  
														cssNodes.backgroundColor+" 100% "+cssNodes.opacity+" "+cssNodes.shape+"40 "
													],
									fillDirection: "left",
									attrCss: [{"stylesheet":["shapes"]}], 	//fill, border, or label for advanced mode
									//type: "gradient",
									type: initType,
									tableOfNodes:'#dataGraph_nodes',
									tableOfEdges:'#dataGraph_edges'
									//change:function(){
									//}
				}, config);
			}

		};
		
		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		////																											  		////
		////	Constructor for edges vizmapper in east pane																	////
		////									  																		  		////
		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		//TODO: remove tab edges if coverage is undefined
		function vizmapperEdges (config){
			 //// get edges style ////
			var 
				edges = cy.edges(),
				/*cssEdges = edges.css(),
				initLine = $.Color(edges.css("line-color")).toHexString(),	
				initTarget = $.Color(edges.css("target-arrow-color")).toHexString(),
				initSource = $.Color(edges.css("source-arrow-color")).toHexString(),
				initLabel = $.Color(edges.css("color")).toHexString(),
				initOpacity = edges.css("opacity"),
				initLineStyle= edges.css("line-style"),
				initSize = edges.css("width"),*/
				initType = "gradient";
			
			cy._private.vizmapperType= initType;
			if(cy._private.maxEdgesCoverage!=0){
				//// generate and display vizmapper for edges////
				$("#vizmapper.content").vizMap({
										group : "edges",
										property: ["Coverage"],
										controlPoints: ["#ff0000 0% 1 ellipse 20 " , "#ffa500 50% 1 ellipse 30 ", "#008000 100% 1 ellipse 40 "],
										fillDirection: "left",
										attrCss: [{"stylesheet":["colors"]}], //line, target, source or label for advanced mode and "colors" for pre-configured
										type: initType,
										//type: "gradient",
										tableOfNodes:'#dataGraph_nodes',
										tableOfEdges:'#dataGraph_edges'
										//change:function(){
										//}
				}, config);
			}
			
					
		};
		
		//////////////////////////////////////////////////////////////////////////////////////////////
		/* function resetVizmapper() {
			$("#vizmapper.content").append("<div id=reset class=vizmapper><button>Reset vizmapper</button><div>");	   
			$("#reset.vizmapper").click(function() {
				$("#vizmapper.content").vizMapReset();
			});	
			
		};*/
        
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		////																											  		////
		////	apply border color on nodes when mouseover and mouseout 														////
		////									  																		  		////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        function mouseOnOffNode () {				
				
            	cy
            	.on("mouseover touchover", "node:unselected",  function(){
            					this.data().previousCss = previousCss = this.css();																									
								this.css({
									"border-color" :"blue",
									"background-color" :"grey",
									"border-width": "2.3"
								});
								
		       	})
		       	.on("mouseout touchout mouseup", "node:unselected",  function(){
		       					this.css({
		       						"border-color" : previousCss.borderColor,
		       						"background-color" : previousCss.backgroundColor,
		       						"border-width" : previousCss.borderWidth
		       					});
		       					
		       					
		       	});
		   };
		
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		////																											  		////
		////	apply line color on edges when mouseover and mouseout 															////
		////									  																		  		////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
		function mouseOnOffEdge () {
		   		
            	cy
		       	.on("mouseover touchover", "edge:unselected",  function(){
		       					this.data().previousCss = previousCss = this.css();					
																																	
								this.css({
										"line-color": "#aaa",
										"target-arrow-color": "#aaa",
										"source-arrow-color": "#aaa"
								});
										
		       	})
		       	.on("mouseout touchout mouseup", "edge:unselected",  function(){
								this.css({
										"line-color": previousCss.lineColor,
										"target-arrow-color": previousCss.targetArrowColor,
										"source-arrow-color": previousCss.sourceArrowColor
								});
	       		});
	       		
	       };
	    
	    
	    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		////																											  		////
		////	Apply cytoscapeEdgehandles function with defined parameters (see cytoscape.js documentation)					////
		////		Input : - html div include cytoscape graph 	($cy)															////
		////									  																		  		////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	   /* function Edgehandles($cy){    
	    	$cy.cytoscapeEdgehandles({
					lineType: "bezier",
					preview: true,
					handleSize: 12,
					handleColor: "orange",
					edgeType: function(){
						return "flat";
					},
					nodeParams: function(){
						return {
							classes: "intermediate"
						};
					},
					start: function( sourceNode ){
						//console.log("start(%o)", sourceNode);
					},
					complete: function( sourceNode, tathisrgetNodes, added ){
						//console.log("complete(%o, %o, %o)", sourceNode, targetNodes, added);
					},
					stop: function( sourceNode ){
						//console.log("stop(%o)", sourceNode);
					}
			});
		};*/
		
		
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		////																											  		////
		////	Set display of elements after scrollBar appearance/disappearance												////
		////		Input: time of setTimeout function	(timeout)																////
		////									  																		  		////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		function scrollBarSupport(timeout, config){
			//TODO: optimiser cf tab.js	
			if($("#vizmapper.content").children()[0] != undefined){
						setTimeout(function(){
				 			var save = $("#vizmapper.content").vizMapSave();
							$("#vizmapper.content").vizMapUpdate(save, config);							
						},timeout);
			};
			
			setTimeout(function(){
							height = $('#cy').height();
		    	   	 		tableHeight = height - $('#dataTable > .ui-tabs-nav').outerHeight() - $('#paneTask').height() ;
		    	   	 		$('#dataTable').css("height",  height);
    	    				$('#dataTable_content').css("height", tableHeight);
    	    				
    	    				var marginSouth = 21; 
    	    				/*if(!$('body').layout().state.south.isClosed){
    	    					marginSouth = $("#paneSouth").height()+8;
    	    				}*/
    	    				
    	    				//set size of datatable for scrollbar support
    	    				 if($("#graphNodes_link").parent().hasClass("ui-state-active")){
 	    	    				var fgNodes = $("#graphNodes").find(".fg-toolbar")[0];
								var correctionHeightNodes = $(fgNodes).outerHeight(); 
					    	    fgNodes = $("#graphNodes").find(".fg-toolbar")[1],
					    	    correctionHeightNodes += ($(fgNodes).outerHeight()+$("#graphNodes").find("dataTables_scrollHead").height()+marginSouth);
					    	    $("#graphNodes").find('.dataTables_scrollBody').css("height", $('#dataTable_content').height() - correctionHeightNodes);     	    				 	
    	    				 }else if($("#graphEdges_link").parent().hasClass("ui-state-active")){
    	    				 	var fgEdges= $("#graphEdges").find(".fg-toolbar")[0];
								var correctionHeightEdges = $(fgEdges).outerHeight(); 
					    	    fgEdges = $("#graphEdges").find(".fg-toolbar")[1],
					    	    correctionHeightEdges += ($(fgEdges).outerHeight()+$("#graphEdges").find("dataTables_scrollHead").height()+marginSouth);
					    	    $("#graphEdges").find('.dataTables_scrollBody').css("height", $('#dataTable_content').height() -  correctionHeightEdges);
    	    				 };
				    	        
		    	   	},timeout);
			
			/*var fg =  $(".fg-toolbar")[0],
				correctionHeight = $(fg).height();
				
		   	fg =  $(".fg-toolbar")[1];
		    correctionHeight += $(fg).height();
		    setTimeout(function(){
		    	 var tableHeight2 = $('#dataTable_content').height() - $('#dataTable_content').prev().height()-22 - correctionHeight ;
    	    	$('.dataTables_scrollBody').css("height", tableHeight2);
    			$('#dataGraph_nodes').dataTable().fnAdjustColumnSizing();
		    	   	 	
		    },timeout);	*/
 		};
 		
 		


	
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		////																											  		////
		////	Construct the graph with defined parameters (see cytoscape.js documentation) 									////
		////	When graph is ready : 																						    ////
		////							- define visual style of elements when there are selected								////
		////							- define action when elements are unselected											////
		////							- force straight lines for edges														////
		////		Input : - list of graph elements with data	(cyNetwork)														////
		////				- object define visual style 		(vsDict)														////
		////									  																		  		////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        function drawNetwork(cyNetwork, vsDict, config) {

			console.log(cyNetwork)
            var defaultStyle = vsDict.style,
            	rootId = undefined,
            	cyRight = undefined,
            	cyLeft= undefined,
            	dataNodes ={},
            	dataEdges ={};
            	
            if(cyNetwork.starter != undefined){
            	rootId = cyNetwork.starter.data.id;
            }
            
            if(cyNetwork.position != undefined){
            	cyRight = cyNetwork.position.right;
            	cyLeft = cyNetwork.position.left;
            }
            //TODO: parameters layout in config file;
            $cy
            .cytoscape({
                	layout: { 
                				name: config.default_layout,
    							roots: rootId, // id of root of the trees
    							rightChildren: cyRight, // id of the first right node
								leftChildren: cyLeft, //id of the first left node
    							ready:function(){
    								//// check good layout in menu ////
    								//$("#menu_northPaneVisuGraph").find("#"+this._private.layout.options.name).children(":first").addClass("ui-menu-checked");
    							},
                				stop: function (){
                					//// remove loading picture ////
                					$("#cy").removeClass("loading");
                					$(".modal").css("display", "none");
                					
                				}
                	 
                	 },
                	 
                	 			
                    elements: {
                        nodes: cyNetwork.nodes,
                        edges: cyNetwork.edges
                    },

                    style: (function () {
                    	    
                        var curStyleObj = cytoscape.stylesheet(),
                        	elementCount = defaultStyle.length;

                        for (var i = 0; i < elementCount; i++) {
                        	
                        	if(defaultStyle[i].selector=="root:unselected"){
                        		defaultStyle[i].selector="#"+rootId+":unselected";
                        	}else if(defaultStyle[i].selector=="root:selected"){
                        		defaultStyle[i].selector="#"+rootId+":selected";
                        	}else if(defaultStyle[i].selector=="root"){
                        		defaultStyle[i].selector="#"+rootId;
                        	}
                            curStyleObj.selector(defaultStyle[i].selector).css(defaultStyle[i].css);
                            
                        }

                        // Set some js-dependent props
                     	 /*  return curStyleObj.selector(".ui-cytoscape-edgehandles-source")
                            .css({
                                "border-color": "#5CC2ED",
                                "border-width": 3
                            })
                            .selector(".ui-cytoscape-edgehandles-target, node.ui-cytoscape-edgehandles-preview")
                            .css({
                                "background-color": "#5CC2ED"
                            })
                            .selector("edge.ui-cytoscape-edgehandles-preview")
                            .css({
                                "line-color": "#5CC2ED"
                            })
                            .selector("node.ui-cytoscape-edgehandles-preview, node.intermediate")
                            .css({
                                "shape": "rectangle",
                                "width": 15,
                                "height": 15
                            });*/
                          return curStyleObj; 
                    })(),
                    

          ready: function () {
            window.cy = this;
            
            if(rootId != undefined){
            	cy._private.root = cy.nodes("#"+rootId);
   				cy._private.root.data().previousCss = cy._private.root.css();
            }
   			
   			//// check good layout in menu ////
   			$("#menu_northPaneVisuGraph").find("#"+this._private.layout.options.name).children(":first").addClass("ui-menu-checked");

			var nodes = this.nodes(),
			    edges = this.edges(),
			    root = this.nodes("#"+rootId),
				widthNodes = 0,
			 	heightNodes = 0,
			 	seq_PaneSouth = null,
			 	tableNodes =[],
			 	tableEdges =[],
			 	dataNodes = networkData.nodes,
			 	dataEdges = networkData.edges;
    		
			
			nodes.css("content", "data(id)");
			edges.css("content", "data(direction)");
			nodes.data().previousCss = {};
			edges.data().previousCss = {};
			
			//// apply height correction for save scrollbar appearance////	    
	    	setTimeout(function(){		
				sideTaskBarSupport();	
			}, 300);
			//// apply functions ////
			var initAndMaxNodes = initNodesData(dataNodes, tableNodes);
 			this._private.maxNodesLength = initAndMaxNodes[0];
 			this._private.maxNodesCoverage = initAndMaxNodes[1];
			var initAndMaxEdges = initEdgesData(dataEdges, tableEdges);	
			this._private.maxEdgesCoverage = initAndMaxEdges;		
			initPaneWestContent(tableNodes, tableEdges);			
			initPaneEastContent(config);	  
  	  		mouseOnOffEdge();
  	  		mouseOnOffNode();

			var edges_ff = [],
				edges_rr = [];
			var isHidden;
			var preCss;
			edges
			.each(function () {
							
							if (this.data("direction")=="RR" || this.data("direction")=="rr" ){
								edges_rr.push(this);
								this.hide();
							}else if((this.data("direction")=="rf" || this.data("direction")=="RF") && this.data("source")<this.data("target")){
								edges_rr.push(this);
								this.hide();
							}
							

			})
			.select(function(){
				isHidden = this.hidden();
				this.data().hidden = isHidden;
				this.data("previousCss", this.css());	
				this.css({
								"line-color": "blue",
								"source-arrow-color": "blue",
								"target-arrow-color": "blue",
								"opacity": 1,
				});
				
				cy.elements(":unselected").css("opacity", 0.5);
				
				if($('#edgesLabel').children(":first").hasClass("ui-menu-checked")){
						this.css("content", "data(direction)");
				}else{
						this.css("content", "");
				}
				
				var self =this;
				var td = $('#dataGraph_edges tr').find(".sorting_1");
				td.each(function(){
					var $this = $(this);
					if($this.text()== self.data("id")){
						$this.parent().addClass("selected");
					}
				});
				
				//show hide edges
				if(isHidden){
					this.show();
				}
				
				var edgeCoverage = this.data("coverageValSelected"),
					edgeId = this.data("id"),
					edgeTarget = this.data("target"),
					edgeSource = this.data('source');
				
					
				$("#sequences_content ").append(" <di class='edgesData'> <pre>ID: "+edgeId+" Source: " +edgeSource+" Target: "+edgeTarget+" Coverage: " +edgeCoverage+"</pre></div>" );
				$("#menu_southPaneVisuGraph ul").children("#ConcaSeq").hide();
				$("#onSequenceSelectionChanged").text(' ');
				
				if(cy.nodes(":selected").length==0){
					$("#menu_southPaneVisuGraph ul").children().not('#holdSouth').hide();
				}
				
				//// Show south pane ////
				var $layout = $body.layout();
				if($layout.south.state.isClosed){
					setTimeout(function(){
						//cy.fit();
						southTaskBarSupport(); 
					}, 500);
				}
				
				
				$layout.open("south");
				$layout.sizePane("south", 200);
				//$layout.resetOverflow( "center" );
						
						
				//// Support scrollbar appearance for east and west pane when south pane is opened ////
				scrollBarSupport(250, config);
				
				
			})
			//// restore edges visual style ////
			.unselect(function(){
				//// remove hightlignt in dataTable ////
				$('#dataGraph_edges tr').filter(".selected").removeClass('selected');	
				$("#menu_southPaneVisuGraph ul").children().not('#holdSouth').show();
				$(".edgesData").remove();

				if(this.data().hidden){
					this.hide();
				}	
		
				this.css(this.data("previousCss"));
				cy.elements(":unselected").css("opacity", 1);
				
				$body.layout().close("south");
							
				//// Support scrollbar 	disappearance for east and west pane when south pane is opened //// 
				scrollBarSupport(300, config);
				if(!$("#holdSouth").hasClass('ui-state-active')){
					southTaskBarSupport();
					setTimeout( function() {
							sideTaskBarSupport();
							//cy.fit(100);
					}, 300);
				}
				
			});
			
			var arrayOfSelectedNodes =[];

			nodes
			//// Show south pane with sequence node when a node is selected //// 
			//TODO: utiliser setSequence()
			.select( function(){
						$("#menu_southPaneVisuGraph ul").children().not('#holdSouth').show();
						if(this.data("k") == undefined){
							$("#menu_southPaneVisuGraph ul").children("#ConcaSeq").hide();
						}
						
						arrayOfSelectedNodes.push(this);
						cy._private.orderingSelection = arrayOfSelectedNodes;	
						this.data("previousCss", this.css());	
						this.css({
									"border-color": "blue",
									"opacity" : 1
									
						});
						
						cy.elements(":unselected").css("opacity", 0.5);	
						
						if($('#nodesLabel').children(":first").hasClass("ui-menu-checked")){
							this.css("content", "data(id)");
						}else{
							this.css("content", "");
						}
						
						var self =this;
						var td = $('#dataGraph_nodes tr').find(".sorting_1");
						td.each(function(){
							var $this = $(this);
							if($this.text()== self.data("id")){
								$this.parent().addClass("selected");
							}
						});


						var nodeSequence = this.data("sequence"),
							nodeCoverage = this.data("coverageValSelected"),
							nodeId = this.data("id"),
							$onSequenceSelectionChanged = $("#onSequenceSelectionChanged"),
							selectSeq = undefined;

						var sequenceWidth = parseInt($("#paneSouth").width()/8.2);
						var formatSelected = $("#setFormat > ul").find(".ui-menu-checked").siblings("label").text(); 

						if (this.data("biojsData") == undefined){
							$("#sequences_content").append('<div id="divSequence_'+nodeId+'" class="ui-sequences ui-sequences-visible"> </div>');
							//associating $("#divSequence") to a node id					
							$("#divSequence_"+nodeId).data("nodeId",nodeId);
						 	//// First time the node is selected : Initialize the sequence of selected node (see biojs.js documentation) ////
							var biojs = new Biojs.Sequence({
	        										/*sequence : nodeSequence,
	        										target : 'divSequence',
	        										format : formatSelected,
	        										id : nodeId,
													fontSize: '18px',
													regions: [{start: 0}],
													columns : [{spacedEach: 2}],
													annotations: [
												       { name:"CATH", 
													  		color:"#F0F020", 
													  		html: "&lt;br&gt; Example of &lt;b&gt;HTML&lt;/b&gt;", 
													  		regions: [{start: 1, end: 5}]
														  }]*/
														sequence : nodeSequence,
														coverage : nodeCoverage,
														target : "divSequence_"+nodeId,
														format : formatSelected,
														id : nodeId,
														fontSize: '18px',
														columns: {size:sequenceWidth},
	    					});	
	    					biojs.hideFormatSelector();
		    				//// Display position in sequence of char selection //// 
							biojs.onSelectionChange(function( e ) {
													$(".ui-sequences-selected").show();
		      										$onSequenceSelectionChanged.text("In node "+nodeId+" interval selected: " + e.start + ", " + e.end );
		      										$onSequenceSelectionChanged.data( "selectedSequence", [e.start, e.end]);
		      										
		  							});		
		                   

	    				}else{
	    					////The node has been already selected before: Set sequence(s) with sequence(s) of selected node  ////
	    					$("#divSequence_"+nodeId).addClass("ui-sequences-visible").show();
	    				}
	    					
	  					$onSequenceSelectionChanged.text("In node "+nodeId+" interval selected: " +0 + ", " + 0 );	
	    				$("#divSequence_"+nodeId).data("biojsData",biojs);
	  					this.data("biojsData",biojs);
	  					
	  					
						//// Show south pane ////
						var $layout = $body.layout();
						if($layout.south.state.isClosed){
							setTimeout(function(){
								southTaskBarSupport(); 
								//cy.fit();
							}, 500);
						}
						$layout.open("south");
						$layout.sizePane("south", 200);
						//$layout.resetOverflow( "center" );
						
						
						//// Support scrollbar appearance for east and west pane when south pane is opened ////
						scrollBarSupport(250, config);
    	   				
						
						//// Option: focus on node selected ////
						if ($("#focus_node").is(":checked")){    
								cy.center(this);
						};

			})
			/// fix size grow up when event shift+click
			/*.click( function(e){		
					if(this.selected()){
						this.unselect();
					}
			})*/
			//// restore node visual style and close south pane ////
			.unselect(function () {
						var nodesWidth = this.width();
						var nodesHeight = this.height();
				
						arrayOfSelectedNodes =[];
						cy._private.orderingSelection = arrayOfSelectedNodes ;
						
						
						this.css(this.data("previousCss"));
						cy.elements(":unselected").css("opacity", 1);
						
						//// remove hightlignt in dataTable ////
				        $('#dataGraph_nodes tr').filter(".selected").removeClass('selected');

						//TODO:suppress concatenate div
						var biojs = this.data("biojsData");
						var nodeId= this.data("id");
						//remove selection when unselect node
						biojs.setSelection(0, 0);
						$("#divSequence_"+nodeId).removeClass("ui-sequences-visible").hide();
						$(".ui-concatenated-sequences").remove();
						

						$body.layout().close("south");
							
					//// Support scrollbar 	disappearance for east and west pane when south pane is opened //// 
					scrollBarSupport(300, config);
					if(!$("#holdSouth").hasClass('ui-state-active')){
						southTaskBarSupport();
						setTimeout( function() {
								sideTaskBarSupport();
								//cy.fit(100);
						}, 300);
					}
						
			});
			
			$(".ui-layout-resizer")
				//// Unbind event mouseover and mouseout when start drag a node for improve performances ////
				.on("mousedown", function(){
							cy.off("mouseout mouseover touchout touchover");
				})
				//// Bind event mouseover and mouseout when after drag a node ////
				.on("mouseup", function(){	
						mouseOnOffNode();
						mouseOnOffEdge();
						//Edgehandles($cy);

						//// Fix blank screen when open panel and apply taskPane correction for southPane////
						//setTimeout( function() {
								cy.panBy({x:0,});
						//}, 500);
	
				})
				.on("mouseover", function(){
					//// Fix blank screen when open panel and apply taskPane correction for southPane////
					//setTimeout( function() {
								cy.panBy({x:0,});
						//}, 500);
				});
				
			//support scrollbar on south pane rezize
			$(".ui-layout-resizer-south").on('mousedown.namespace', function() {
					    $(document).one('mouseup', function() {
					    			console.log("in")
					    			scrollBarSupport(100, config);
					    			southTaskBarSupport();
						        	$(document).off('mousedown.namespace');  		
					    });
			 });
			
				
			$cy
				//// Unbind event mouseover and mouseout when start drag a node for improve performances ////
				.on("mousedown", function(){
							cy.off("mouseout mouseover touchout touchover");
				})
				//// Bind event mouseover and mouseout when after drag a node ////
				.on("mouseup", function(){	
						mouseOnOffNode();
						mouseOnOffEdge();
						
						//// Fix blank screen when open panel and apply taskPane correction for southPane////
						cy.panBy({x:0,});
	
				})
				///// Show Zoom level in task bar //// 
				.on("mousewheel DOMMouseScroll",function(){
							var lvl = parseFloat(cy.zoom()).toFixed(2);
							$("#zoom_lvl").text('Zoom level: ' + lvl);
				})
				
				/*
				 make graph very slow !!! 
				//.on("mouseout", function(){
					//cy.elements().trigger("mouseout");
				//})
				*/
				
				///// apply cytoscapePanzoom function (see cytoscape.js documentation) ////
				.cytoscapePanzoom()
				.cytoscapeNavigator();
				/*.cxtmenu({
	      						selector: 'node',
	      						commands: [{
									content: 'Connect',
									select: function(){
										$("#cy").cytoscapeEdgehandles('start', this.id());
									}
								},
								{
	          						content: 'Delete',
	          						select: function(){
	            						this.remove();
	          						}
	       			 			}
	       			 		]
	    		});*/
    		
    		//Edgehandles($cy);
    		//cy.nodes()[0].select().unselect(); 
    		
    		//// Display visual style tab on start //// 		
			if(config.vizstyle.display){
				$("#vizstyle_link").click();
			}else if (config.vizmapper.display){
				$("#vizmapper_link").click();
				$("#edges_link").click();
				$("#nodes_link").click();
			}
			
			if(!config.vizstyle.display && config.vizmapper.display){
				$("#vizmapper_link").off("click");
			}else if(config.vizstyle.display && !config.vizmapper.display){
				$("#vizstyle_link").off("click");
			} 
			
			
			var session = localStorage.getItem('session');
			if(session){
				loadSession(JSON.parse(session));
				$('#currentSession').val(localStorage.getItem('sessionName'));
			};
			
	 		
        }

      });
    
	
    }

});
