/**
 *
 * Color picker
 * Author: Stefan Petre www.eyecon.ro
 * 
 * Dual licensed under the MIT and GPL licenses
 * 
 */
//TODO: sequencePicker input
(function ($) {
	var Picker = function () {
		var
			ids = {},
			inAction,
			charMin = 65,
			visible,
			tpl = '<div class="picker colorpicker">\
					<div class="colorpicker_color">\
					<div><div></div></div></div>\
					<div class="colorpicker_hue"><div></div></div>\
					<div class="colorpicker_new_color"></div>\
					<div class="colorpicker_current_color"></div>\
					<div class="colorpicker_hex colorpicker_field"><input type="text" maxlength="6" size="6" /></div>\
					<div class="colorpicker_rgb_r colorpicker_field"><input type="text" maxlength="3" size="3" /><span></span></div>\
					<div class="colorpicker_rgb_g colorpicker_field"><input type="text" maxlength="3" size="3" /><span></span></div>\
					<div class="colorpicker_rgb_b colorpicker_field"><input type="text" maxlength="3" size="3" /><span></span></div>\
					<div class="colorpicker_hsb_h colorpicker_field"><input type="text" maxlength="3" size="3" /><span></span></div>\
					<div class="colorpicker_hsb_s colorpicker_field"><input type="text" maxlength="3" size="3" /></div>\
					<div class="colorpicker_hsb_b colorpicker_field"><input type="text" maxlength="3" size="3" /><span></span></div>\
					<div class="colorpicker_submit"></div>\
					</div>',
			tps = '<div class="picker shapepicker"> </div>',
			node_shapepicker = '<div id="node_shapepicker" class="shapepicker_shape"><label class="style"> Nodes Shape: </label></div>',
			line_shapepicker = '<div id="line_shapepicker" class="shapepicker_shape"><label class="style">  Border Style: </label></div>',
			source_shapepicker = '<div id="edge_shapepicker" class="shapepicker_shape"><label class="style">  Source Style: </label></div>',
			target_shapepicker = '<div id="edge_shapepicker" class="shapepicker_shape"><label class="style">  Target Style: </label></div>',
			node_sequencepicker = '<div id="node_sequencepicker" class="sequencepicker_annotation sequencepicker_field">\
											<label class="style" style="position:relative;">  Annotation Name: </label><input style="position:relative;" type="text" maxlength="30" size="30"/>\
											<label class="style" style="position:relative;">  Annotation Text: </label><textarea  style="position:relative;" type="text"> </textarea>\
											</div>',
			size_shapepicker = '<div class="shapepicker_size shapepicker_field"><label class="style">  Size : </label><input  type="number" maxlength="3" size="3"/></div>',
			opacity_colorpicker ='<div class="colorpicker_opacity colorpicker_field"><label class="style">  Opacity(%) : </label><input type="number" maxlength="3" size="3"" /></div>',
			
			defaults = {
				eventName: 'click',
				onShow: function () {},
				onBeforeShow: function(){},
				onHide: function () {},
				onChangeColor: function () {},
				onChangeSize: function () {},
				onChangeName: function () {},
				onChangeText: function () {},
				onFocus: function () {},
				onBlur: function () {},
				onClick: function () {},
				onSubmit: function () {},
				color: '000',
				livePreview: true,
				flat: false,
				shape: 'ellipse',
				opacity: 1,
				size: 35,
				name: "",
				text: "test"
			},
			

			/*addProperty = function (colpk){
					var $nodeShapePicker = colpk.find("#node_shapepicker");
					var $lineShapePicker =  colpk.find("#line_shapepicker");
					
					if (($nodeShapePicker.length === 0) && ($lineShapePicker.length === 0) && (colpk.find(".property_input").length === 0)) {

						colpk.append(node_shapepicker).append(line_shapepicker).addClass("continuous_map").attr("property","node_length");

                		for(var i = 0; i < types_shapes.length; i++){
                   		 	type = types_shapes[i];        			
                    		$nodeShapePicker.append('<div id=shape class="shape ' + type + '" shape="' + type + '"></div>');

                		};

			 			for(var i = 0; i < types_lines.length; i++){
                    		type = types_lines[i];
                    		$lineShapePicker.append('<div class="shape ' + type + '" shape="' + type + '"></div>');
                		};
					
					};//end if
					
			},*/
			 
			fillRGBFields = function  (hsb, cal) {
				var RGB = HSBToRGB(hsb);
				$(cal).data('picker').fields
					.eq(1).val(RGB.r).end()
					.eq(2).val(RGB.g).end()
					.eq(3).val(RGB.b).end();
				
			},
			fillHSBFields = function  (hsb, cal) {
				$(cal).data('picker').fields
					.eq(4).val(hsb.h).end()
					.eq(5).val(hsb.s).end()
					.eq(6).val(hsb.b).end();
			},
			fillHexFields = function (hsb, cal) {
				$(cal).data('picker').fields
					.eq(0).val(HSBToHex(hsb)).end();
			},
			fillOpacityFields = function (op, cal) {
				$(cal).data('picker').fields
					.eq(8).val(op).end();

			},
			fillSizeFields = function (sz, cal) {
				$(cal).data('picker').fields
					.eq(7).val(sz).end();

			},
			fillSizeFieldsOnly = function (sz, cal) {
				$(cal).data('picker').fields
					.eq(0).val(sz).end();
			},
			fillNameFields = function (nm, cal) {
				
				$(cal).data('picker').fields
					.eq(7).val(nm).end();

			},
			fillTextFields = function (txt, cal) {
				$(cal).data('picker').fields
					.eq(8).val(txt).end();
			},
			
			setSelector = function (hsb, cal) {
				var $dataPicker = $(cal).data('picker');
				
				$dataPicker.selector.css('backgroundColor', '#' + HSBToHex({h: parseInt(hsb.h), s: 100, b: 100}));
				$dataPicker.selectorIndic.css({
					left: parseInt(150 * hsb.s/100, 10),
					top: parseInt(150 * (100-hsb.b)/100, 10)
				});
			},
			setHue = function (hsb, cal, op) {
				$(cal).data('picker').hue.css('top', parseInt(150 - 150 * hsb.h/360, 10));
			},
			setCurrentColor = function (hsb, cal, op) {
				$(cal).data('picker').currentColor.css({
									backgroundColor : '#' + HSBToHex(hsb),
									opacity : op
									});
			},
			setNewColor = function (hsb, cal, op) {
				$(cal).data('picker').newColor.css({
									backgroundColor : '#' + HSBToHex(hsb),
									opacity : op
									});
			},
			
			
			keyDown = function (ev) {
				var cal = $(this).parents(".picker");
				if($(this).parent().hasClass("colorpicker_field")){
					var pressedKey = ev.charCode || ev.keyCode || -1;
					if ((pressedKey > charMin && pressedKey <= 90) || pressedKey == 32) {
						return false;
					}
					
					if (cal.data('picker').livePreview === true){
						change.apply(this);
					}
				}else if($(this).parent().hasClass("shapepicker_field")){
					if (cal.data('picker').livePreview === true){
							changeSize.apply(this);
					
					} 
					
				}else if($(this).parent().hasClass("sequencepicker_field")){
					if (cal.data('picker').livePreview === true){
							change.apply(this);
					}

				}
					
			},

			//click on shape function
			click = function (ev) {
				var $this = $(this),
					cal = $this.parents(".picker");
				
				$dataPicker = cal.data('picker'); 
				$dataPicker.shape = $this.attr("shape");
				$dataPicker.onClick.apply(cal, $this.shape);
				//$(cal).data('picker').selector.attr("shape", $this.attr("shape"));
			},

			//change function
			change = function (ev) {
				var $this = $(this),
					cal = $this.parents(".picker"),
					dataCal= cal.data('picker'),
					$dataFields = dataCal.fields,
					calGet0 = cal.get(0),
					col;
				
				if (this.parentNode.className.indexOf('_hex') > 0) {
					$dataColor = col = HexToHSB(fixHex(this.value));
				} else if (this.parentNode.className.indexOf('_hsb') > 0) {
					dataCal.color = col = fixHSB({
						h: parseInt($dataFields.eq(4).val(), 10),
						s: parseInt($dataFields.eq(5).val(), 10),
						b: parseInt($dataFields.eq(6).val(), 10)
					});
				} else {
					dataCal.color = col = RGBToHSB(fixRGB({
						r: parseInt($dataFields.eq(1).val(), 10),
						g: parseInt($dataFields.eq(2).val(), 10),
						b: parseInt($dataFields.eq(3).val(), 10)					
					}));
					

				}
				
				if (ev) {						
					fillRGBFields(col,  calGet0);
					fillHexFields(col,  calGet0);
					fillHSBFields(col,  calGet0);
				}
				
				setSelector(col, calGet0);
				setHue(col, calGet0);
				setNewColor(col, calGet0, op);
				
							
				if (cal.hasClass("colorpicker advanced")){
					var op, sz;
					dataCal.size = sz = parseInt($dataFields.eq(7).val(), 10);
					dataCal.opacity = op = parseInt($dataFields.eq(8).val(), 10)/100;
					if (ev) {
						fillSizeFields(sz,  calGet0);
						fillOpacityFields(op*100,  calGet0);
					}
					
					// TODO: apply with an other method
					dataCal.onChangeOpacity.apply(cal, $this.opacity);
					dataCal.onChangeSize.apply(cal, $this.size);
				} 
				
				if(cal.hasClass("colorpicker sequencepicker")){
					var nm, txt;
					dataCal.name = nm = $dataFields.eq(7).val();
					dataCal.text = txt = $dataFields.eq(8).val();
					if (ev) {
						fillNameFields(nm,  calGet0);
						fillTextFields(txt,  calGet0);
					}
					
					dataCal.onChangeName.apply(cal, $this.name);
					dataCal.onChangeText.apply(cal, $this.text);
				};
				
				dataCal.onChangeColor.apply(cal, [col, HSBToHex(col), HSBToRGB(col)]);
			},
			
			changeSize = function (ev) {
				var $this = $(this),
					cal = $this.parents(".picker"),
					dataCal= cal.data('picker'),
					$dataFields = dataCal.fields,
					calGet0 = cal.get(0),
					col, op, sz;
					
					dataCal.size = sz = parseInt($dataFields.eq(0).val(), 10);
					if(isNaN(sz)){
						dataCal.size = sz = 0;
					}
					
					if (ev) {
						fillSizeFields(sz,  calGet0);
					}
					
					
					dataCal.onChangeSize.apply(cal, $this.size);
			},

			blur = function (ev) {	
				$(this).parents(".picker").data('picker').fields.parent().removeClass('colorpicker_focus');
			},
			focus = function () {
				var $this = $(this);
				charMin = this.parentNode.className.indexOf('_hex') > 0 ? 70 : 65;
				$this.parent().addClass('colorpicker_focus');
			},
			downIncrement = function (ev) {
				var $this = $(this);
				var $parent = $this.parent();
				var field = $parent.find('input').focus();
				var current = {
					el: $parent.addClass('colorpicker_slider'),
					max: this.parentNode.className.indexOf('_hsb_h') > 0 ? 360 : (this.parentNode.className.indexOf('_hsb') > 0 ? 100 : 255),
					y: ev.pageY,
					field: field,
					val: parseInt(field.val(), 10),
					preview: $this.parents(".picker").data('picker').livePreview					
				};
				$(document).on('mouseup', current, upIncrement).on('mousemove', current, moveIncrement);
			},
			moveIncrement = function (ev) {
				ev.data.field.val(Math.max(0, Math.min(ev.data.max, parseInt(ev.data.val + ev.pageY - ev.data.y, 10))));
				if (ev.data.preview) {
					change.apply(ev.data.field.get(0), [true]);
				}
				return false;
			},
			upIncrement = function (ev) {
				change.apply(ev.data.field.get(0), [true]);
				ev.data.el.removeClass('colorpicker_slider').find('input').focus();
				$(document).off('mouseup', upIncrement).off('mousemove', moveIncrement);
				return false;
			},
			downHue = function (ev) {
				var $this = $(this);
				var current = {
					cal: $this.parent(),
					y: $this.offset().top
				};
				current.preview = current.cal.data('picker').livePreview;
				$(document).on('mouseup', current, upHue).on('mousemove', current, moveHue);
			},
			moveHue = function (ev) {
				change.apply(
					ev.data.cal.data('picker')
						.fields
						.eq(4)
						.val(parseInt(360*(150 - Math.max(0,Math.min(150,(ev.pageY - ev.data.y))))/150, 10))
						.get(0),
					[ev.data.preview]
				);
				return false;
			},
			upHue = function (ev) {
				var cal = ev.data.cal,
					dataCal = cal.data('picker'),
					calGet0 = cal.get(0);
					
				if (cal.hasClass("colorpicker")){
					fillRGBFields(dataCal.color, calGet0);
					fillHexFields(dataCal.color, calGet0);
					fillHSBFields(dataCal.color, calGet0);
				}
				
				if (cal.hasClass("colorpicker advanced") ){
					fillOpacityFields(dataCal.opacity*100, calGet0);
				}
				
				if (cal.hasClass("shapepicker pre-configured")){
					fillSizeFields(dataCal.size, calGet0);
				} 
				
				if("sequencepicker"){
					fillNameFields(dataCal.name, calGet0);
					fillTextFields(dataCal.text, calGet0);
				}
				
				$(document).off('mouseup', upHue).off('mousemove', moveHue);
				return false;
			},
			downSelector = function (ev) {
				var $this = $(this);
				var current = {
					cal: $this.parent(),
					pos: $this.offset()
				};
				current.preview = current.cal.data('picker').livePreview;
				$(document).on('mouseup', current, upSelector).on('mousemove', current, moveSelector);
			},
			moveSelector = function (ev) {
				change.apply(
					ev.data.cal.data('picker')
						.fields
						.eq(6)
						.val(parseInt(100*(150 - Math.max(0,Math.min(150,(ev.pageY - ev.data.pos.top))))/150, 10))
						.end()
						.eq(5)
						.val(parseInt(100*(Math.max(0,Math.min(150,(ev.pageX - ev.data.pos.left))))/150, 10))
						.get(0),
					[ev.data.preview]
				);
				return false;
			},
			upSelector = function (ev) {
				var cal =  ev.data.cal,
					dataCal = cal.data('picker'),
					calGet0 = cal.get(0);
				
				if (cal.hasClass("colorpicker")){
					fillRGBFields(dataCal.color, calGet0);
					fillHexFields(dataCal.color, calGet0);
					fillHSBFields(dataCal.color, calGet0);
					
				}
				
				if (cal.hasClass("colorpicker advanced") ){
					fillOpacityFields(dataCal.opacity*100, calGet0);
				}
				
				if (cal.hasClass("shapepicker pre-configured")){
					fillSizeFields(dataCal.size, calGet0);
				} 
				
				if("sequencepicker"){
					fillNameFields(dataCal.name, calGet0);
					fillTextFields(dataCal.text, calGet0);
				}
				
				
				$(document).off('mouseup', upSelector).off('mousemove', moveSelector);
				return false;
			},
			enterSubmit = function (ev) {
				$(this).addClass('colorpicker_focus');
			},
			leaveSubmit = function (ev) {
				$(this).removeClass('colorpicker_focus');
			},
			clickSubmit = function (ev) {
				var cal = $(this).parent(),
					dataCal = cal.data('picker'),
					col = dataCal.color,
					op = dataCal.opacity,
					sz = dataCal.size,
					nm = dataCal.name,
					txt = dataCal.text;
				dataCal.origColor = col;
				dataCal.origOpacity = op;
				dataCal.origSize = sz;
				dataCal.origName = nm;
				dataCal.origText = txt;
				setCurrentColor(col, cal.get(0) ,op);
				dataCal.onSubmit(col, HSBToHex(col), HSBToRGB(col), dataCal.el);
			},
			show = function (ev) {
				var $this = $(this),
					pos = $this.offset(),
					viewPort = getViewport(),
					//top = pos.top + this.offsetHeight - 28,
					top = pos.top,
					left = pos.left-3,
					cal = $('#' + $this.data('pickerId')),
					calGet0 = cal.get(0),
					calData = cal.data('picker');
					
					calData.onBeforeShow.apply(this, [calGet0]);

				if (top + 176 > viewPort.t + viewPort.h) {
					top -= this.offsetHeight + 176;
				}
				if (left + 356 > viewPort.l + viewPort.w) {
					left -= 356;
				}
				cal.css({left: left + 'px', top: top + 'px'});
				if (calData.onShow.apply(this, [calGet0]) != false) {
					cal.show();
				}
				$(document).on('mousedown', {cal: cal}, hide);
				return false;
			},
			hide = function (ev) {
				var evCal =ev.data.cal,
					calGet0 = evCal.get(0);
					
				if($(this).parent().hasClass("colorpicker_field")){
						change.apply(this);
				}else if($(this).parent().hasClass("shapepicker_field")){
							changeSize.apply(this);
				}else if($(this).parent().hasClass("sequencepicker_field")){
							change.apply(this);
				}
				
				if (!isChildOf(calGet0, ev.target ,calGet0)) {
					if (evCal.data('picker').onHide.apply(this, [calGet0]) != false) {
						evCal.hide();
					}
					$(document).off('mousedown', hide);
				}
			},
			isChildOf = function(parentEl, el, container) {
				if (parentEl == el) {
					return true;
				}
				if (parentEl.contains) {
					return parentEl.contains(el);
				}
				if ( parentEl.compareDocumentPosition ) {
					return !!(parentEl.compareDocumentPosition(el) & 16);
				}
				var prEl = el.parentNode;
				while(prEl && prEl != container) {
					if (prEl == parentEl)
						return true;
					prEl = prEl.parentNode;
				}
				return false;
			},
			getViewport = function () {
				var m = document.compatMode == 'CSS1Compat';
				return {
					l : window.pageXOffset || (m ? document.documentElement.scrollLeft : document.body.scrollLeft),
					t : window.pageYOffset || (m ? document.documentElement.scrollTop : document.body.scrollTop),
					w : window.innerWidth || (m ? document.documentElement.clientWidth : document.body.clientWidth),
					h : window.innerHeight || (m ? document.documentElement.clientHeight : document.body.clientHeight)
				};
			},
			fixHSB = function (hsb) {
				return {
					h: Math.min(360, Math.max(0, hsb.h)),
					s: Math.min(100, Math.max(0, hsb.s)),
					b: Math.min(100, Math.max(0, hsb.b))
				};
			}, 
			fixRGB = function (RGB) {
				return {
					r: Math.min(255, Math.max(0, RGB.r)),
					g: Math.min(255, Math.max(0, RGB.g)),
					b: Math.min(255, Math.max(0, RGB.b))
				};
			},
			fixHex = function (hex) {
				var len = 6 - hex.length;
				if (len > 0) {
					var o = [];
					for (var i=0; i<len; i++) {
						o.push('0');
					}
					o.push(hex);
					hex = o.join('');
				}
				return hex;
			}, 
			HexToRGB = function (hex) {
				var hex = parseInt(((hex.indexOf('#') > -1) ? hex.substring(1) : hex), 16);
				return {r: hex >> 16, g: (hex & 0x00FF00) >> 8, b: (hex & 0x0000FF)};
			},
			HexToHSB = function (hex) {
				return RGBToHSB(HexToRGB(hex));
			},
			RGBToHSB = function (RGB) {
				var hsb = {
					h: 0,
					s: 0,
					b: 0
				};
				var min = Math.min(RGB.r, RGB.g, RGB.b);
				var max = Math.max(RGB.r, RGB.g, RGB.b);
				var delta = max - min;
				hsb.b = max;
				if (max != 0) {
					
				}
				hsb.s = max != 0 ? 255 * delta / max : 0;
				if (hsb.s != 0) {
					if (RGB.r == max) {
						hsb.h = (RGB.g - RGB.b) / delta;
					} else if (RGB.g == max) {
						hsb.h = 2 + (RGB.b - RGB.r) / delta;
					} else {
						hsb.h = 4 + (RGB.r - RGB.g) / delta;
					}
				} else {
					hsb.h = -1;
				}
				hsb.h *= 60;
				if (hsb.h < 0) {
					hsb.h += 360;
				}
				hsb.s *= 100/255;
				hsb.b *= 100/255;
				return hsb;
			},
			HSBToRGB = function (hsb) {
				var RGB = {};
				var h = Math.round(hsb.h);
				var s = Math.round(hsb.s*255/100);
				var v = Math.round(hsb.b*255/100);
				if(s == 0) {
					RGB.r = RGB.g = RGB.b = v;
				} else {
					var t1 = v;
					var t2 = (255-s)*v/255;
					var t3 = (t1-t2)*(h%60)/60;
					if(h==360) h = 0;
					if(h<60) {RGB.r=t1;	RGB.b=t2; RGB.g=t2+t3}
					else if(h<120) {RGB.g=t1; RGB.b=t2;	RGB.r=t1-t3}
					else if(h<180) {RGB.g=t1; RGB.r=t2;	RGB.b=t2+t3}
					else if(h<240) {RGB.b=t1; RGB.r=t2;	RGB.g=t1-t3}
					else if(h<300) {RGB.b=t1; RGB.g=t2;	RGB.r=t2+t3}
					else if(h<360) {RGB.r=t1; RGB.g=t2;	RGB.b=t1-t3}
					else {RGB.r=0; RGB.g=0;	RGB.b=0}
				}
				return {r:Math.round(RGB.r), g:Math.round(RGB.g), b:Math.round(RGB.b)};
			},
			RGBToHex = function (RGB) {
				var hex = [
					RGB.r.toString(16),
					RGB.g.toString(16),
					RGB.b.toString(16)
				];
				$.each(hex, function (nr, val) {
					if (val.length == 1) {
						hex[nr] = '0' + val;
					}
				});
				return hex.join('');
			},
			HSBToHex = function (hsb) {
				return RGBToHex(HSBToRGB(hsb));
			},
			restoreOriginal = function () {
				var cal = $(this).parent(),
					dataCal = cal.data('picker'),
					calGet0 = cal.get(0),
					col = dataCal.origColor,
					op = dataCal.origOpacity,
					sz = dataCal.origSize,
					nm = dataCal.origName,
					txt = dataCal.origText;
				
				dataCal.color = col;
				dataCal.opacity = op;
				dataCal.size = sz;
				dataCal.name = nm;
				dataCal.text = txt;
				
				if($this.hasClass("color-chooser continuous_map") ){
							fillRGBFields(col, calGet0);
							fillHSBFields(col, calGet0);
							fillHexFields(col, calGet0);
							fillOpacityFields(op*100, calGet0);
							fillSizeFields(sz, calGet0);
					}else if($this.hasClass("shape-chooser continuous_map")){
							fillSizeFieldsOnly(sz, calGet0);
					}if($this.hasClass("annotation-chooser")){
							fillRGBFields(col, calGet0);
							fillHSBFields(col, calGet0);
							fillHexFields(col, calGet0);
							fillNameFields(nm, calGet0);
							fillTextFields(txt, calGet0);
				}
				
				setSelector(col, calGet0);
				setHue(col, calGet0);
				setNewColor(col, calGet0, op);
			};

		return {
			init: function (opt) {
				
				opt = $.extend({}, defaults, opt||{});
				var $this = $(this),
					optColor = opt.color;
				if (typeof optColor == 'string') {
					optColor = HexToHSB(optColor);
				} else if (optColor.r != undefined && optColor.g != undefined && optColor.b != undefined) {
					optColor = RGBToHSB(optColor);
				} else if (optColor.h != undefined && optColor.s != undefined && optColor.b != undefined) {
					optColor = fixHSB(optColor);
				} else {
					return this;
				}

				return this.each(function () {
					if (!$this.data('pickerId')) {
						var options = $.extend({}, opt),
							idPicker = 'picker_' + parseInt(Math.random() * 1000),							
							cal,
							type,
							types_lines = ["dotted", "dashed", "solid"],
                			types_shapes = ["square", "roundrectangle", "ellipse", "triangle"],
							types_arrows = ["diamond", "triangle", "square", "circle", "tee", "none"];
						

						if($this.hasClass("color-chooser continuous_map") ){
							
							options.origColor = opt.color;
							options.origOpacity = opt.opacity;
							options.orgSize = opt.size;
							
							cal = $(tpl).attr('id', idPicker);
							$this.data('pickerId', idPicker);
						     switch ($this.attr('class')){
							     	case "color-chooser continuous_map nodes_fill"  :
							    	 	cal.append($(node_shapepicker).addClass("advanced"));
							    	 	cal.append($(size_shapepicker).addClass("advanced").append($(opacity_colorpicker).addClass("advanced")));
							    	 	
									for(var i = 0; i < types_shapes.length; i++){
                   		 						type = types_shapes[i];        			
                    		 						cal.addClass("advanced").find("#node_shapepicker").append('<div class="shape ' + type + '" shape="' + type + '"></div>');
                							};

							     	break;
									case "color-chooser continuous_map nodes_border":
										//cal.append($(line_shapepicker));
										// cal.append($(node_colorpicker));
										/*for(var i = 0; i < types_lines.length; i++){
                    								type = types_lines[i];
                    								cal.find("#line_shapepicker").append('<div class="shape ' + type + '" shape="' + type + '"></div>');
                							};*/
									break;
									case "color-chooser continuous_map nodes_label" :
											cal.addClass("advanced").append($(size_shapepicker).addClass("advanced"));
									break;
									case "color-chooser continuous_map edges_target"  :
								    	 	cal.append($(target_shapepicker).addClass("advanced"));
										for(var i = 0; i < types_arrows.length; i++){
	                   		 						type = types_arrows[i];     			
	                    		 						cal.addClass("advanced").find("#edge_shapepicker").append('<div class="shape ' + type + '" shape="' + type + '"></div>');
	                							};
								    break;
									case "color-chooser continuous_map edges_source"  :
								    	 	cal.append($(source_shapepicker).addClass("advanced"));
										for(var i = 0; i < types_arrows.length; i++){
	                   		 						type = types_arrows[i];        			
	                    		 						cal.addClass("advanced").find("#edge_shapepicker").append('<div class="shape ' + type + '" shape="' + type + '"></div>');
	                							};
								    break;
									case "color-chooser continuous_map edges_line":
										cal.append($(line_shapepicker).addClass("advanced"));
										cal.append($(size_shapepicker).addClass("advanced"));
										for(var i = 0; i < types_lines.length; i++){
	                    								type = types_lines[i];
	                    								cal.addClass("advanced").find("#line_shapepicker").append('<div class="shape ' + type + '" shape="' + type + '"></div>');
	                							};
									break;
									case "color-chooser continuous_map edges_label" :
											cal.addClass("advanced").append($(size_shapepicker).addClass("advanced"));
										
									break;
						     };
						     
						    options.fields = cal.find('input').on('keydown', keyDown)
								    					  	  .on('change', change)
								    					  	  .on('blur', blur)
								   						  	  .on('focus', focus);
						   
						  
						   $(".picker").find(".shape").on('click', click);
					   }else if($this.hasClass("annotation-chooser")){
					   				options.origColor = opt.color;
									options.origOpacity = opt.opacity;;
									options.origName = opt.name;
									options.origText = opt.text;
					   				cal = $(tpl).attr('id', idPicker);
					   				$this.data('pickerId', idPicker);
					   				cal.addClass("sequencepicker").append($(node_sequencepicker).addClass("pre-configured"));
					   				options.fields = cal.find('input, textarea').on('keydown', keyDown)
								    					  			  .on('change', change)
								    					  			  .on('blur', blur)
								   						  			  .on('focus', focus);
								   
					   				
					   	}else if($this.hasClass("shape-chooser continuous_map")){
									options.orgSize = opt.size;
					   				
					   				cal = $(tps).attr('id', idPicker);
					   				$this.data('pickerId', idPicker);
					   				cal.append($(node_shapepicker).addClass("pre-configured"));
					   				cal.append($(size_shapepicker).addClass("pre-configured"));
						   			 for(var i = 0; i < types_shapes.length; i++){
	                   		 				
	                   		 				type = types_shapes[i];        			
	                    		 			cal.addClass("pre-configured").find("#node_shapepicker").append('<div class="shape ' + type + '" shape="' + type + '"></div>');
                					 };
                					 
								  
								    setTimeout(function(){
								    	$(".shapepicker").find(".shape").on('click', click);
								    	
								    },10);
								    
								    options.fields = cal.find('input').on('keyup', keyDown)
                													  .on('change', changeSize)
								    					  			  .on('blur', blur)
								   						  			  .on('focus', focus);
								    
					   	}
					   	

						if (options.flat) {
							cal.appendTo(this).show();
						} else {
							cal.appendTo(document.body);
						}
						
						
								   						 
								   		
						cal.find('span').on('mousedown', downIncrement).end()
						   .find('div.colorpicker_current_color').click(restoreOriginal);
						   
						options.selector = cal.find('div.colorpicker_color').on('mousedown', downSelector);
						options.selectorIndic = options.selector.find('div div');
						options.el = this;
						options.hue = cal.find('div.colorpicker_hue div');
						cal.find('div.colorpicker_hue').on('mousedown', downHue);
						options.newColor = cal.find('div.colorpicker_new_color');
						options.currentColor = cal.find('div.colorpicker_current_color');
						cal.data('picker', options);
						cal.find('div.colorpicker_submit').on('mouseenter', enterSubmit)
					           							  .on('mouseleave', leaveSubmit)
														  .on('click', clickSubmit);
						
						var calGet0 = cal.get(0);

						if($this.hasClass("color-chooser continuous_map") ){
							fillRGBFields(options.color, calGet0);
							fillHSBFields(options.color, calGet0);
							fillHexFields(options.color, calGet0);
							fillOpacityFields(options.opacity*100, calGet0);
							fillSizeFields(options.size, calGet0);
						}else if($this.hasClass("shape-chooser continuous_map")){
							fillSizeFieldsOnly(options.size, calGet0);
						}else if($this.hasClass("annotation-chooser")){
							fillRGBFields(options.color, calGet0);
							fillHSBFields(options.color, calGet0);
							fillHexFields(options.color, calGet0);
							fillNameFields(options.name, calGet0);
							fillTextFields(options.text, calGet0);
						}
						
						setHue(options.color, calGet0);
						setSelector(options.color, calGet0);
						setCurrentColor(options.color, calGet0 , options.opacity);
						setNewColor(options.color, calGet0, options.opacity);
						if (options.flat) {
							cal.css({
								position: 'relative',
								display: 'block'
							});
						} else {
							$this.on(options.eventName, show);
						}
					}
				});
			},
			showPicker: function() {
				return this.each( function () {
					if ($(this).data('pickerId')) {
						show.apply(this);
					}
				});
			},
			hidePicker: function() {
				var $this = $(this);
				return this.each( function () {
					if ($this.data('pickerId')) {
						$('#' + $this.data('pickerId')).hide();
					}
				});
			},
			setColor: function(col, op, sz, nm, txt) {
				if (typeof col == 'string') {
					col = HexToHSB(col);
				} else if (col.r != undefined && col.g != undefined && col.b != undefined) {
					col = RGBToHSB(col);
				} else if (col.h != undefined && col.s != undefined && col.b != undefined) {
					col = fixHSB(col);
				} else {
					return this;
				}
				return this.each(function(){
					var $this = $(this);
					if ($this.data('pickerId')) {
						var cal = $('#' + $this.data('pickerId')),
						    calGet0 = cal.get(0),
							calData = cal.data('picker');
						calData.color = col;
						calData.opacity = op;
						calData.size = sz;
						calData.name = nm;
						calData.text = txt;
						calData.origColor = col;
						calData.origOpacity = op;
						calData.origSize = sz;
						calData.origName = nm;
						calData.origText = txt;
						if($this.hasClass("color-chooser continuous_map") ){
							fillRGBFields(col, calGet0);
							fillHSBFields(col, calGet0);
							fillHexFields(col, calGet0);
							fillOpacityFields(op*100, calGet0);
							fillSizeFields(sz, calGet0);
						}else if($this.hasClass("shape-chooser continuous_map")){
							fillSizeFieldsOnly(sz, calGet0);
						}if($this.hasClass("annotation-chooser")){
							fillRGBFields(col, calGet0);
							fillHSBFields(col, calGet0);
							fillHexFields(col, calGet0);
							fillNameFields(nm, calGet0);
							fillTextFields(txt, calGet0);
						}
						
						setHue(col, calGet0);
						setSelector(col, calGet0);
						setCurrentColor(col, calGet0, op);
						setNewColor(col, calGet0, op);
					}
				});
			}
	     };
	}();
	$.fn.extend({
		picker: Picker.init,
		pickerHide: Picker.hidePicker,
		pickerShow: Picker.showPicker,
		pickerSetColor: Picker.setColor,
	});
})(jQuery);
