/**
Inspire by Gradient-picker.js @author Matt Crinklaw-Vogt (tantaman)
*/

/*the graph data (here cy._private) must be contained:
* - the maximum length of sequence nodes (maxNodesLenght) 
* - the maximum coverage of nodes (maxNodesCoverage) (undefined if coverage is not present) 
* - the maximum coverage of edges (maxEdgesCoverage) (undefined if coverage is not present)
* - the initial value of type of vizmapper (discrete/gradient) 
*/

//TODO: support with vertical vizmapper
//TODO: specific attribut for each vizsel in initialization ( add attribut in opts)
(function( $ ) {

	if (!$.event.special.destroyed) {
		$.event.special.destroyed = {
		    remove: function(o) {
		    	if (o.handler) {
		    		o.handler();
		    	};
		    }
		};
	}

	function ctrlPtComparator(l,r) {
		return l.position - r.position;
	}

	function bind(fn, ctx) {
		if (typeof fn.bind === "function") {
			return fn.bind(ctx);
		} else {
			return function() {
				fn.apply(ctx, arguments);
			};
		}
	}

	var browserPrefix = "";
	if ($.layout.browser.mozilla) {
		browserPrefix = "-moz-";
	} else if ($.layout.browser.webkit) {
		browserPrefix = "-webkit-";
	} else if ($.layout.browser.opera) {
		browserPrefix = "-o-";
	} else if ($.layout.browser.msie) {
		browserPrefix = "-ms-";
	}
	
	function isScrollable() {
  			var divWidth = parseInt($("#side_content").height());
  			var scroll    = $("#vizmapper.content").height();
 			return (divWidth < scroll);
	} 
	
	//TODO: need optimization because resize is long with 2 loops  
	function ajustedAccordion(vizMap, outerWidth, timeout){
		
		var originalCanvasWidth = $(".ui-continuous_map").width()-outerWidth;
		var originalCtrlPtPos=[];
		var i =0;
		
		//loop needed for support setTimeout write after
		$(".vizmapperPicker-ctrlPt").each(function(){
			    				var $this = $(this);	
			    				originalCtrlPtPos[i] = parseFloat($this.css("left"));
			    				i++;
		});
		
		vizMap.accordion();
		// setTimeout for catch the good width (time to make accordion and time for display scrollbar or remove it);
		setTimeout(function(){

					var newCanvasWidth = $(".ui-continuous_map").width()-outerWidth;
							
			    	$(".ui-continuous_map > canvas").each(function(){
			    				$(this).attr("width", newCanvasWidth);					
					});
					
					var scaleFactor = newCanvasWidth / originalCanvasWidth;
					var j =0;
					$(".vizmapperPicker-ctrlPt").each(function(){
			    				var $this = $(this);	
			    				var newCtrlPtPos =  parseInt(originalCtrlPtPos[j] * scaleFactor);
			    				$this.css("left", newCtrlPtPos);
			    				$this.data().posChanged(newCtrlPtPos);
			    				j++;	
			    				   					   		  				
			    	});
		    	
	   },timeout);

	}
//Idea make gradient shape transformation function//
////////////////////////////////////////////////////
//--------------------------------------------------------------function vizmapper------------------------------------------------------//
	
	function nodesFill  (arrayProperty,  arrayColor, arrayShape , arrayOpacity, arraySize, stringProperty, holdRoot) {
						var mapNodes = cy.nodes("["+stringProperty+">="+arrayProperty+"]" );
						if(mapNodes.length != 0){	
						
							mapNodes.css({
										"width": arraySize,
										"height": arraySize,
										"shape": arrayShape,
										"backgroundColor" : arrayColor,
										"backgroundOpacity" : arrayOpacity
								});	
						}
						
						if(holdRoot && cy._private.root!=undefined){
							
							//hold node root fill style
							var root = cy._private.root;
							var previousCss = root.data("previousCss");
							root.css({
										"width": previousCss.width,
										"height": previousCss.height,
										"shape": previousCss.shape,
										"backgroundColor" : previousCss.backgroundColor,
										"backgroundOpacity" : previousCss.backgroundOpacity
							});
						};
						
						
	};
	
	function nodesBorder (arrayProperty,  arrayColor, arrayShape , arrayOpacity, arraySize, stringProperty, holdRoot) {
						var mapNodes = cy.nodes("["+stringProperty+">="+arrayProperty+"]");
						if(mapNodes.length != 0){
							mapNodes.css({
										"border-color" :arrayColor,
										"border-opacity" : arrayOpacity
										//"weight": array_size
									});
						};
												
						if(holdRoot && cy._private.root!=undefined){
							//hold node root border style
							var root = cy._private.root;
							var previousCss = root.data("previousCss");
							root.css({
										"borderColor" :previousCss.borderColor,
										"borderOpacity" : previousCss.Opacity,
										//weight: previousCss.weight
										
							});
						};
	};

	 function nodesLabel (arrayProperty,  arrayColor , arrayOpacity, arraySize, stringProperty, holdRoot) {
						var mapNodes = cy.nodes("["+stringProperty+">="+arrayProperty+"]" );
						if(mapNodes.length != 0){
							mapNodes.css({
										"color" :arrayColor,
										"label-opacity" : arrayOpacity,
										//"font-size": array_size
									});
						}
						
						if(holdRoot && cy._private.root!=undefined){
							//hold node root label style
							var root = cy._private.root;
							var previousCss = root.data("previousCss");
							root.css({
										"color" :previousCss.color,
										"labelOpacity" : previousCss.labelOpacity,
										//fontSize: previousCss.fontSize,
										
							});
						}
						
	};

	function  edgesLine(arrayProperty,  mapdata, arrayShape , arrayOpacity, arraySize, stringProperty) {
						var mapEdges = cy.edges("["+stringProperty+">="+arrayProperty+"]");
						if(mapEdges.length != 0){
							mapEdges.css({
										"line-style": arrayShape,
										"line-color" :mapdata,
										"opacity" : arrayOpacity,
										//"width": array_size,
							});
						};

	};

	function edgesTarget (arrayProperty,  arrayColor, arrayShape, stringProperty) {
						var mapEdges = cy.edges("["+stringProperty+">="+arrayProperty+"]" );
						if(mapEdges.length != 0){
							mapEdges.css({
										"target-arrow-shape": arrayShape,
										"target-arrow-color" :arrayColor,
							});
						};
	};

	function edgesSource (arrayProperty,  arrayColor, arrayShape, stringProperty) {
						var mapEdges = cy.edges("["+stringProperty+">="+arrayProperty+"]" );
						if(mapEdges.length != 0){
							var previousCss = mapEdges.data("previousCss");
							mapEdges.css({
										"source-arrow-shape": arrayShape,
										"source-arrow-color" :arrayColor,
							});
						};
	};


	function egdesLabel  (arrayProperty,  arrayColor, arrayShape , arrayOpacity, arraySize, stringProperty) {
						var mapEdges = cy.edges("["+stringProperty+">="+arrayProperty+"]" );
						if(mapEdges.length != 0){
							var previousCss = mapEdges.data("previousCss");
							mapEdges.css({
									"color" : arrayColor,
									"label-opacity" : arrayOpacity,
									//"font-size": array_size,
							});
						}

	};
	
//--------------------------------------------------------------------end---------------------------------------------------------------------//

	function vizSwitcherGrad ($elAttr, arrayProperty0, arrayProperty1, arrayColor0, arrayColor1, arrayShape , arrayOpacity, arraySize0, arraySize1, stringProperty, holdRoot) {

				var mapdataColor = "mapData("+stringProperty+","+arrayProperty0+","+arrayProperty1+","+arrayColor0+","+arrayColor1+")",
					mapdataSize = "mapData("+stringProperty+","+arrayProperty0+","+arrayProperty1+","+arraySize0+","+arraySize1+")";
				switch($elAttr){
 						case "nodes_fill" :
 						case "nodes_colors": //pre-configured
 						case "nodes_shapes": //preconfigured
							nodesFill (arrayProperty0,  mapdataColor, arrayShape , arrayOpacity,  mapdataSize, stringProperty, holdRoot);	
						break;
						case "nodes_border" :	
							nodesBorder (arrayProperty0,  mapdataColor, arrayShape , arrayOpacity,  mapdataSize, stringProperty, holdRoot);	
						break;
						case "nodes_label" :	
							nodesLabel(arrayProperty0,  mapdataColor , arrayOpacity,  mapdataSize, stringProperty, holdRoot);	
						break;
						case "edges_line" :
						case "edges_shapes": //preconfigured
						case "edges_colors": //pre-configured		
							edgesLine (arrayProperty0,  mapdataColor, arrayShape , arrayOpacity,  mapdataSize, stringProperty);	
						break;
						case "edges_target" :	
							edgesTarget (arrayProperty0,  mapdataColor, arrayShape, stringProperty);	
						break;
						case "edges_source" :	
							edgesSource (arrayProperty0,  mapdataColor, arrayShape, stringProperty);	
						break;
						case "edges_label" :	
							egdesLabel (arrayProperty0,  mapdataColor, arrayShape , arrayOpacity,  mapdataSize, stringProperty);	
						break;
						
					};
			
	};
	
	function vizSwitcherDisc ($elAttr, arrayProperty0, arrayProperty1, arrayColor, arrayShape , arrayOpacity, arraySize, stringProperty, holdRoot) {
				switch($elAttr){
 						case "nodes_fill" :
 						case "nodes_colors": //pre-configured
 						case "nodes_shapes": //preconfigured
							nodesFill (arrayProperty0,  arrayColor, arrayShape , arrayOpacity, arraySize, stringProperty, holdRoot);	
						break;
						case "nodes_border" :	
							nodesBorder (arrayProperty0,  arrayColor, arrayShape , arrayOpacity, arraySize, stringProperty, holdRoot);	
						break;
						case "nodes_label" :	
							nodesLabel (arrayProperty0,  arrayColor , arrayOpacity, arraySize, stringProperty, holdRoot);	
						break;
						case "edges_line" :
						case "edges_shapes": //preconfigured
						case "edges_colors": //pre-configured	
							edgesLine (arrayProperty0,  arrayColor, arrayShape , arrayOpacity, arraySize, stringProperty);	
						break;
						case "edges_target" :	
							edgesTarget (arrayProperty0,  arrayColor, arrayShape, stringProperty);	
						break;
						case "edges_source" :	
							edgesSource (arrayProperty0,  arrayColor, arrayShape, stringProperty);	
						break;
						case "edges_label" :	
							egdesLabel (arrayProperty0,  arrayColor, arrayShape , arrayOpacity, arraySize, stringProperty);	
						break;
					};
				
			
	};
	
	function addFileCoverageTable($parentEl, config){
		$parentEl.append(
						'<div id="coverageFiles" class="content">\
							<label class="files ui-widget-header ui-corner-tl ui-corner-tr ui-helper-clearfix">Coverage Files :</label>\
							<table cellpadding="0" cellspacing="0" border="0" class="display dataCoverage" id="table_coverageFiles">\
							    	  <thead>\
											<tr>\
											<th>File</th>\
											<th>Global avg coverage</th>\
											</tr>\
									 </thead>\
							</table>\
						</div>'
					);
		

					var arrayCoverage= cy.$("#n0").data("coverage");
					var tableCoverageFiles = [];
					var nbFiles =  arrayCoverage.length;
					var nbNodes = cy.nodes().length;
					var nbEdges = cy.edges().length;
					
					
					//define global average coverage for each coverage files 			
					var globalAvgCoverage = [];
					var lenCoverage;
					var avg = 0;
					
					for (var l = 0; l<arrayCoverage.length; l++) {
						lenCoverage = 0;
						cy.nodes().each(function(){
							//if the node is the root break loop
						 	if(this.data("id") == cy._private.root.data("id")){
						 		return;
						 	}
						 	lenCoverage++;
							var coverage = this.data("coverage")[l];
							avg += coverage.avg_coverage;
							globalAvgCoverage[l] = avg;
						 });


						globalAvgCoverage[l] = (globalAvgCoverage[l] / lenCoverage).toFixed(4);
		
					}

					for (var j=0; j<nbFiles; j++){
						tableCoverageFiles[j]={
							"Files":arrayCoverage[j].id,
							"Global avg coverage":globalAvgCoverage[j]
						};
						
					};
					
			
						//// Initialize dataTable with coverage file data ////
					   	 $('#table_coverageFiles').dataTable({       										
																"bPaginate": false,
														        "bFilter": false,
														        "bInfo": false,
														        "bProcessing": true,
				        										"bJQueryUI": true,
				        										"oTableTools": {
																"sRowSelect": "single"
																},
																/*"aoColumnDefs": [
      																{ "sTitle": "My column title", "aTargets": [ 0 ] }
   																],*/
				        										"aaData": tableCoverageFiles,
				        										"aoColumns": [
				            													{ "mData": "Files" },
				            													{ "mData": "Global avg coverage" }
				            												 ],
													
				    	 });

						
				    //remove header part
				    $(".dataTables_wrapper").children(":first").remove();
				    
				    //highlight the current coverage file
				    var defaultSelectedFile = cy.nodes("#n0").data("coverageFileSelected");
    				$("#table_coverageFiles td").each(function(){
    					if($(this).text()==defaultSelectedFile){
    						$(this).parent().addClass('selected');
    					}
    				});
	 
					//define click on coverage file action
					var fileSelected ={};
					$('#table_coverageFiles tr').click( function(){
						var $this = $(this);
						
						//highlight
						if ( !$this.hasClass('selected') ) {
						        	$this.parent().find(".selected").removeClass('selected');
						 			$this.addClass('selected');
						}
						
					   fileSelected = $this.children(":first").text();
					   
					   //define the new value for each node
					 
					   var vizSelActif;
					  if(config.vizmapper.with_accordion){
					  		vizSelActif = $(".property_filters[aria-hidden=false]").children(".coverage-content");
							
					  }else{
							vizSelActif = $(".property_filters").children(".coverage-content");
					  }

						var opts = vizSelActif.data("VizMapSelection").opts;
					  	var indexNodes = 0;
					  	var maxCoverage = 0;	
					   cy.nodes().each(function(){
					   		var self = this;
						   	self.data("coverageFileSelected", fileSelected);
						   	var coverage = self.data("coverage");
						   	var lenCoverage = coverage.length;
						   	for(var k=0; k<lenCoverage; k++){
						   		if(coverage[k].id == fileSelected){
						   			//update coverage in nodes datatable 
						   			self.data("coverageValSelected", coverage[k].avg_coverage);
						   			if(coverage[k].avg_coverage != "none" && coverage[k].avg_coverage != undefined && maxCoverage< coverage[k].avg_coverage){
						   				maxCoverage = coverage[k].avg_coverage;
						   			};
						   			
						   			self.updateTable(opts.tableOfNodes, indexNodes, 2, coverage[k].avg_coverage, maxCoverage);
						   			indexNodes++;
						   			break;
						   		};
						   		
						   	}
						   	
					   });

					   var indexEdges = 0;
					   cy.edges().each(function(){
						   	var self = this;
						   	self.data("coverageFileSelected", fileSelected);
						   		
						   	var coverage = self.data("coverage");
						   	var lenCoverage = coverage.length;
						   	for(var l=0; l<lenCoverage; l++){
						   		if(coverage[l].id == fileSelected){
						   			this.data("coverageValSelected", coverage[l].avg_coverage);
						   			//update coverage in nodes datatable 
						   			if( coverage[l].avg_coverage != "none" && coverage[l].avg_coverage != undefined && maxCoverage< coverage[l].avg_coverage){
						   				maxCoverage = coverage[l].avg_coverage;
						   			};
						   			self.updateTable(opts.tableOfEdges, indexEdges, 4, coverage[l].avg_coverage, maxCoverage);
						   			indexEdges++;
						   			break;
						   		};
						   	}

					   });
						
						//update scale of vizmapper and max value 
						var unactiveTab = $("#vizmapper_tabs > ul > li").not(".ui-state-active").children(); 
						unactiveTab.click();
						unactiveTab = $("#vizmapper_tabs > ul > li").not(".ui-state-active").children();
						unactiveTab.click();
					});		
	}
	
	
	function VizMap ($el, opts){
		
		var self =this;
		self.$el = $el;
		self.$el.css("position", "relative");
		self.opts = opts;
		//self.group = opts.group;
		self.propContainer =[];
		var propContainer = self.propContainer;
		
		var len = opts.property.length;
		for (var i = 0; i < len; ++i) {
			var property= self.createElProperty(opts.property[i], i);
			propContainer.push(property);
		}
		
		setTimeout( function(){
			self.listener = self.propContainer[0].attrCss[0].VizMapSelection;
			self.scrollable =  isScrollable();

		},100);				
	};	
	
	VizMap.prototype = {
		createElProperty:function(property, index){
			return new ElementProperty (this.$el, property, this.opts, this, index);
				
		},
		
		updateOptions: function(opts, accordion) {
			var vizMap = $("#vizmapper").data("VizMap");
			var CurrentOpts = vizMap.opts;
			$.extend(CurrentOpts, opts);
			vizMap.listener.updateOptions(CurrentOpts, accordion);
		}
				
	};
	
	
	
	//TODO: optimisation de vizsel le créer avec élément property 
	function ElementProperty ($parentEl, property, opts, listener, index) {
				var toLowerCaseProperty = property.toLowerCase();
				var $el = $('<label class="property ui-widget-header ui-corner-tl ui-corner-tr ui-helper-clearfix" property='+toLowerCaseProperty+'>'+property+': </label><div class="property_filters" property ='+property+'></div>');
				var self = this;
				self.$el=$el;
				var attrCss = [];
				var $childEl;
				var attributSet = opts.attrCss[index].stylesheet;
				self.opts = opts;
 				self.attrCss  = attrCss; 
 				
 				
 				
 				var len = attributSet.length;
 				var extendLabel;
				for (var i = 0; i < len; ++i) {
					
					if (opts.group =="nodes"){
						if(attributSet[i] == "shapes"){
							extendLabel = " and sizes";
						}else{
							extendLabel = "";
						}
						$childEl = $('<div class="ui-continuous_map ui-discrete '+toLowerCaseProperty+'-content ui-state-default" property="nodes_'+attributSet[i]+'"><label class="style ">'+attributSet[i]+extendLabel+' : </label></div>');
						//this.createVizsel($childEl, this.opts);
					} else if (opts.group =="edges"){
						$childEl = $('<div class="ui-continuous_map ui-discrete '+toLowerCaseProperty+'-content ui-state-default" property="edges_'+attributSet[i]+'"><label class="style">'+attributSet[i]+extendLabel+' : </label></div>');
						//this.createVizsel($childEl, this.opts);
					};
					
					self.$el.filter('div').append($childEl);	
					self.attrCss[i] =  {"idCss" : attributSet[i]};
					
					self.attrCss[i].$el = $childEl;
					
				};
			
				$el.click(function(){

						var vizSelActif = self.attrCss;
						var vizSelActifLen = attrCss.length;
						for (var j = 0; j < vizSelActifLen; j++) {
							attrCss[j].VizMapSelection.updatePreview();
							attrCss[j].VizMapSelection.updateView();	
						};	
				});
				
							
				$parentEl.append($el);
				self.$parentEl = $parentEl;
				self.property = toLowerCaseProperty;
				
				setTimeout( function(){
					self.listener = self.attrCss[0].VizMapSelection;		
				},100);
				
	}
	/*ElementProperty.prototype = {
		
		createVizsel: function($el) {
			return new VizMapSelection($el, this.opts);
	
		}
	};	*/

	function VizMapSelection($el, opts, property) {
			
		this.$el = $el;
		this.$el.css("position", "relative");
		this.property = property; //TODO: replace with //opts.property = property; dificulty with vizmap function with propcontainer array
		this.opts = opts;

		var widthCorrection;
		if(this.opts.advanced){
			var $previewShape = $("<canvas class='vizmapperPicker-preview-shape'></canvas>");
			this.$el.append($previewShape);
			var canvasShape = $previewShape[0];	
			canvasShape.width = parseFloat(canvasShape.clientWidth);
			canvasShape.height = canvasShape.clientHeight;
			this.g2d = canvasShape.getContext("2d");
			
			var $previewColor = $("<canvas class='vizmapperPicker-preview-color'></canvas>");
			this.$el.append($previewColor);
			var canvasColor = $previewColor[0];
			canvasColor.width = parseFloat(canvasColor.clientWidth);
			canvasColor.height = canvasColor.clientHeight;
			this.g2d = canvasColor.getContext("2d");
		}else if( property == "length"){
			var $previewShape = $("<canvas class='vizmapperPicker-preview-shape'></canvas>");
			this.$el.append($previewShape);
			var canvasShape = $previewShape[0];	
			canvasShape.width = parseFloat(canvasShape.clientWidth);
			canvasShape.height = canvasShape.clientHeight;
			this.g2d = canvasShape.getContext("2d");
		}else if(property == "coverage" ){
			var $previewColor = $("<canvas class='vizmapperPicker-preview-color'></canvas>");
			this.$el.append($previewColor);
			var canvasColor = $previewColor[0];
			canvasColor.width = parseFloat(canvasColor.clientWidth);
			canvasColor.height = canvasColor.clientHeight;
			this.g2d = canvasColor.getContext("2d");
		}
		
		var $ctrlPtContainer = $("<div class='vizmapperPicker-ctrlPts'></div>");
		this.$el.append($ctrlPtContainer);
		this.$ctrlPtContainer = $ctrlPtContainer;

		this.updatePreview = bind(this.updatePreview, this);
		this.updateView = bind(this.updateView, this);
		this.drawPreviewShape = bind(this.drawPreviewShape, this);
		this.controlPoints = [];
		var len = opts.controlPoints.length;
		this.ctrlPtConfig = new ControlPtConfig(this.$el, opts);
		for (var i = 0; i < len; ++i) {
			var ctrlPt = this.createCtrlPt(opts.controlPoints[i]);
			this.controlPoints.push(ctrlPt);
			/*var linePos = ctrlPt.position * canvasShape.width;
			$previewShape.drawLine({
  							strokeStyle: "#000",
  							strokeWidth: 2,
  							x1: linePos, y1: 0,
  							x2: linePos, y2: 21
			});*/
		}

		this.docClicked = bind(this.docClicked, this);
		this.destroyed = bind(this.destroyed, this);
		$(document).bind("click", this.docClicked);
		this.$el.bind("destroyed", this.destroyed);
		
		
		this.previewClicked = bind(this.previewClicked, this);
		if($previewColor != undefined){
			$previewColor.click(this.previewClicked);
		} 
		
		if($previewShape != undefined){
			$previewShape.click(this.previewClicked);
		}
		
		this.updatePreview();
	}

	VizMapSelection.prototype = {
		docClicked: function() {
			this.ctrlPtConfig.hide();
		},
		
		
		createCtrlPt: function(ctrlPtSetup) {
			return new ControlPoint(this.$ctrlPtContainer, ctrlPtSetup, this.opts.orientation, this, this.ctrlPtConfig);
	
		},

		destroyed: function() {
			$(document).unbind("click", this.docClicked);
		},

		updateOptions: function(opts, accordion) {
			var vizSelActif;
			if(accordion){
				vizSelActif = $(".property_filters[aria-hidden=false]").children();
			}else{
				vizSelActif = $(".property_filters").children();
			}
			
			var CurrentOpts = vizSelActif.data("VizMapSelection").opts;
			$.extend(CurrentOpts, opts);
			vizSelActif.data("VizMapSelection").updatePreview();
			vizSelActif.data("VizMapSelection").updateView();
		},
		
		updateView: function () {

				var arrayColor = [];
				var arraySeq = [];
				var arrayShape = [];
				var arrayOpacity = [];
				var arraySize = [];
				var arrayType = [];
				var arrayCoverage = [];
				

				var len = this.controlPoints.length;
				for (var i = 0; i <len;  i++) {
					var pt = this.controlPoints[i];
					
					arrayColor[i]= $.Color(pt.color).toHexString();				
					arraySeq[i] = pt.lengthSeq;
					arrayShape[i] = pt.shape;
					arrayOpacity[i] = pt.opacity;
					arraySize[i] = pt.size;
					//arrayType[i] = pt.type;
					arrayCoverage[i]= pt.coverage;

					var stringProperty = this.property;
					var holdRoot = this.opts.holdRoot;
					
					
					
					if(stringProperty == "length"){
			
						if(!this.opts.advanced){
							arrayColor[i] = undefined;
							arrayOpacity[i] = undefined;
						}
						if(this.opts.type == "discrete"){
							//console.log(stringProperty, this.opts.type );
							if(arraySeq[i-1] != undefined){						
								vizSwitcherDisc (this.$el.attr("property"), arraySeq[i-1], arraySeq[i], arrayColor[i-1] , arrayShape[i-1], arrayOpacity[i-1], arraySize[i-1], stringProperty, holdRoot );					
							}else if(arraySeq[i+1] != undefined){
								vizSwitcherDisc (this.$el.attr("property"), arraySeq[i], arraySeq[i+1], arrayColor[i] , arrayShape[i], arrayOpacity[i], arraySize[i], stringProperty, holdRoot );
							};
						}else if(this.opts.type == "gradient"){
							if(arraySeq[i-1] != undefined){
								vizSwitcherGrad (this.$el.attr("property"), arraySeq[i-1], arraySeq[i], arrayColor[i-1],arrayColor[i] , arrayShape[i-1], arrayOpacity[i-1], arraySize[i-1],arraySize[i], stringProperty, holdRoot );					
							}else if(arraySeq[i+1] != undefined){
								vizSwitcherGrad (this.$el.attr("property"), arraySeq[i], arraySeq[i+1], arrayColor[i],arrayColor[i+1] , arrayShape[i], arrayOpacity[i], arraySize[i], arraySize[i+1], stringProperty, holdRoot );
							};
						};
					}else if(stringProperty == "coverage"){
						if(!this.opts.advanced){
							arrayShape[i] = undefined;
							arraySize[i] = undefined;
						}
						//console.log(stringProperty, this.opts.type );
						var coverageStringProperty = "coverageValSelected";
						if(this.opts.type == "discrete"){
							if(arrayCoverage[i-1] != undefined){
								vizSwitcherDisc (this.$el.attr("property"), arrayCoverage[i-1], arrayCoverage[i], arrayColor[i-1] , arrayShape[i-1], arrayOpacity[i-1], arraySize[i-1], coverageStringProperty );					
							}else if(arrayCoverage[i+1] != undefined){
								vizSwitcherDisc (this.$el.attr("property"), arrayCoverage[i], arrayCoverage[i+1], arrayColor[i] , arrayShape[i], arrayOpacity[i], arraySize[i], coverageStringProperty );
							};
						}else if(this.opts.type == "gradient"){
							if(arrayCoverage[i-1] != undefined){
								vizSwitcherGrad (this.$el.attr("property"), arrayCoverage[i-1], arrayCoverage[i], arrayColor[i-1],arrayColor[i] , arrayShape[i-1], arrayOpacity[i-1], arraySize[i-1],arraySize[i], coverageStringProperty );					
							}else if(arrayCoverage[i+1] != undefined){
								vizSwitcherGrad (this.$el.attr("property"), arrayCoverage[i], arrayCoverage[i+1], arrayColor[i],arrayColor[i+1] , arrayShape[i], arrayOpacity[i], arraySize[i], arraySize[i+1], coverageStringProperty );
							};
						};
					}	
					
				};
				

				this.arrayColor = arrayColor;
				this.arraySeq = arraySeq;
				this.arrayShape = arrayShape;
				this.arrayOpacity = arrayOpacity;
				this.arrayCoverage = arrayCoverage;

		},
		updatePreview: function() {
			
			var result = [];
			this.controlPoints.sort(ctrlPtComparator);
			var len = this.controlPoints.length;
			
			if(this.opts.type == "discrete"){
					
				for (var i = 0; i <len;  i++) {
					var pt = this.controlPoints[i];
					
					result.push({
						position: pt.position,
						renderPos: pt.renderPos,
						color: pt.color,
						length: pt.length,
						shape : pt.shape,
						opacity: pt.opacity,
						size: pt.size,
						//type: pt.type,
						coverage: pt.coverage
					});
					
					if(this.opts.advanced || this.property=="coverage"){
						var fillRectWidth = this.g2d.canvas.width-pt.renderPos;
						this.g2d.fillStyle = pt.color;
						this.g2d.fillRect(pt.renderPos, 0, fillRectWidth, this.g2d.canvas.height);
					};
					
				};
			}else if(this.opts.type == "gradient"){
				
				var grad = this.g2d.createLinearGradient(0, 0, this.g2d.canvas.width, 0);
				for (var i = 0; i <len;  i++) {
					var pt = this.controlPoints[i];

					grad.addColorStop(pt.position, pt.color);
					result.push({
						position: pt.position,
						renderPos: pt.renderPos,
						color: pt.color,
						length: pt.length,
						shape : pt.shape,
						opacity: pt.opacity,
						size: pt.size,
						//type: pt.type,
						coverage: pt.coverage
					});
				
				};
				 
				if(this.opts.advanced || this.property=="coverage"){				
					this.g2d.fillStyle = grad;
					this.g2d.fillRect(0, 0, this.g2d.canvas.width, this.g2d.canvas.height);
				};
				
			}; 
			
			/*if (this.opts.generateStyles){
					var styles = this._generatePreviewStyles();
			}*/
			//this.opts.change(result, styles);	
			//this.opts.change();	

		},

		removeControlPoint: function(ctrlPt) {
			var cpidx = this.controlPoints.indexOf(ctrlPt);	
			if (cpidx != -1) {
			    ctrlPt.colorChanged("#000");
				this.controlPoints.splice(cpidx, 1);
				ctrlPt.$el.remove();
			}
		},
		

		previewClicked: function(e) {
			var offset = $(e.target).offset();
			var x = e.pageX - offset.left;
			var y = e.pageY - offset.top;
			
			
			var initialState = this.opts.controlPoints[0];
			var init = {};
			var $elAttr = this.$el.attr("property");
			var shape = this.shape;
		
			if (typeof initialState === "string") {
				initialState = initialState.split(" ");
				init.position = parseFloat(initialState[1])/100;
				init.renderPos = x;
				init.color = initialState[0];
				init.opacity = initialState[2];
				init.shape = initialState[3];
				init.size = initialState[4];	
				//init.type = initialState[5];
			} else {
				init.position = initialState.position;
				init.renderPos = initialState.renderPos;
				init.color = initialState.color;
				init.opacity = initialState.opacity;
				init.shape = initialState.shape;
				init.size = initialState.size;
				//init.type = initialState.type;
				
			}
			
			switch(shape){
 				case "ellipse" :
 				break;
 				case "rectangle" :
 				break;
 				case "roundrectangle" :
 				break;
 				case "triangle":
 				break;
 				case "none":
			  		if ($elAttr == "nodes_border" || $elAttr == "edges_line"){
 						shape = "solid";
					}else if ($elAttr == "nodes_label" || $elAttr == "edges_label"){
 						shape = "";
					};
				break;
				case "solid" :
				break;
				case "dotted" :
				break;
				case "dashed" :
			 	 	if ($elAttr == "nodes_fill"){
 						shape = "ellipse";
					}else if ($elAttr == "nodes_label"){
 						shape = "";
					}else if ($elAttr == "edges_target"){
 						shape = "triangle";
					}else if ($elAttr == "edges_source"){
 						shape = "none";
					};
				break;
				case "" :
			  		if ($elAttr == "nodes_fill"){
 						shape = "ellipse";
					}else if ($elAttr == "nodes_border" || $elAttr == "edges_line"){
 						shape = "solid";
					}else if ($elAttr == "edges_target"){
 						shape = "triangle";
					}else if ($elAttr == "edges_source"){
 						shape = "none";
					};
				break;
	 		};
			
			var cp = this.createCtrlPt({
				position: x / this.g2d.canvas.width,
				renderPos :x,
				color: init.color,
				opacity: init.opacity,
				shape: init.shape,
				size: init.size,
				//type: init.type
			});
			//var imgData = this.g2d.getImageData(x,y,1,1);
			//var colorStr = "rgba(" + imgData.data[0] + "," + imgData.data[1] + "," + imgData.data[2] + "," + imgData.data[3] + ")";
			
			this.controlPoints.push(cp);
			this.controlPoints.sort(ctrlPtComparator);
			this.updatePreview();
		},
		
		drawPreviewShape: function ($previewShape, ControlPoint){
			var canvasShape={};
			canvasShape.$previewShape = $previewShape;
			//TODO: mauvais linepose pour certaine resolution probléme lié à la taskbar
			var linePos = ControlPoint.position * $previewShape.width();
			var lineSize = $previewShape.height();
			var xShape = linePos+12;
			var yShape = lineSize/2;
			var colorShape;
			
			if(this.opts.advanced){
				colorShape = ControlPoint.color;
			}else{
				colorShape = "#000";
			}
			
			var strPosProperty;
			
			if(ControlPoint.property=="length"){
				strPosProperty = JSON.stringify(ControlPoint.lengthSeq);
			}else if(ControlPoint.property=="coverage"){
				strPosProperty = JSON.stringify(ControlPoint.coverage);
			}
			var ctrlPtnameLine = "ctrlPt"+strPosProperty+"Line";
			var ctrlPtnameShape = "ctrlPt"+strPosProperty+"Shape";
			var ctrlPtgroup = "ctrlPt"+strPosProperty+"Group";
			canvasShape.ctrlPtnameLine = ctrlPtnameLine;
			canvasShape.ctrlPtnameShape = ctrlPtnameShape;
			canvasShape.ctrlPtgroup = ctrlPtgroup;
			
			$previewShape.drawLine({
						layer:true,
						name:ctrlPtnameLine,
						group:ctrlPtgroup,
  						strokeStyle: "#000",
  						strokeWidth: 1,
  						x1: linePos, y1: 0,
  						x2: linePos, y2: lineSize
			});
			//TODO: add more shape
			switch (ControlPoint.shape){
				case  "ellipse"	:
					$previewShape.drawArc({
						layer: true,
						name:ctrlPtnameShape,
						group:ctrlPtgroup,
						strokeStyle: colorShape,
						fillStyle: colorShape,
  						x: xShape, y: yShape,
  						radius: yShape/3.5
  				});
  				break;
  				case "square":
					$previewShape.drawRect({
  						layer: true,
  						name:ctrlPtnameShape,
  						group:ctrlPtgroup,
  						fillStyle: colorShape,
  						x: xShape, y: yShape,
  						width: yShape/2, height: yShape/2
				});
				break;
				//TODO: fix this
				case "roundrectange":
					$previewShape.drawRect({
  						layer: true,
  						name:ctrlPtnameShape,
  						group:ctrlPtgroup,
  						fillStyle: colorShape,
  						x: xShape, y: yShape,
  						width: yShape/2, height: yShape/2,
  						cornerRadius: 3
				});
				break;	
				case "triangle":
					$previewShape.drawPolygon({
						layer: true,
  						name:ctrlPtnameShape,
  						group:ctrlPtgroup,
  						strokeStyle: colorShape,
  						fillStyle: colorShape,
  						strokeWidth: yShape/3.5,
  						x: xShape, y: yShape,
  						radius: 3,
 						sides: 3
				});
				break;
				case "solid":
					$previewShape.drawLine({
						layer:true,
						name:ctrlPtnameShape,
						group:ctrlPtgroup,
  						strokeStyle: colorShape,
  						strokeWidth: yShape/5,
  						x1: xShape, y1: yShape,
  						x2: xShape+20, y2: yShape
				});
				break;
				case "dashed":
					$previewShape.draw({
						layer:true,
						name:ctrlPtnameShape,
						group:ctrlPtgroup,
  						fn: function(ctx) {
   					 		ctx.beginPath();
   					 		ctx.lineWidth = yShape/5; 
   					 		ctx.dashedLine(xShape, yShape, xShape+20, yShape, [5,3]);
   					 		ctx.strokeStyle = colorShape;
    						ctx.stroke();
  					}
				});	
				break;
				case "dotted":
					$previewShape.draw({
						layer:true,
						name:ctrlPtnameShape,
						group:ctrlPtgroup,
  						fn: function(ctx) {
   					 		ctx.beginPath();
   					 		ctx.lineCap   = 'round';
							ctx.lineWidth = yShape/5; // Lines 4px wide, dots of diameter 4
   					 		ctx.dashedLine(xShape, yShape, xShape+20, yShape, [1,6]);
   					 		ctx.strokeStyle = colorShape;
    						ctx.stroke();
  					}
				});	
				break;		
		};
		return canvasShape;
	}//,

		/*_generatePreviewStyles: function() {
			//linear-gradient(top, rgb(217,230,163) 86%, rgb(227,249,159) 9%)
			var str = this.opts.gradType + "-gradient(" + ((this.opts.gradType == "linear") ? (this.opts.fillDirection + ", ") : "");
			
			var first = true;
			for (var i = 0; i < this.controlPoints.length; ++i) {
				var pt = this.controlPoints[i];
				if (!first) {
					str += ", ";
				} else {
					first = false;
				}
				str += pt.color + " " + ((pt.position*100)|0) + "%" ;
			}

			str = str + ")"
			var styles = [str, browserPrefix + str];
			return styles;
		}*/
	};

	function ControlPoint($parentEl, initialState, orientation, listener, ctrlPtConfig) {
		var self = this;
		self.$el = $("<div class='vizmapperPicker-ctrlPt'></div>");
		$parentEl.append(self.$el);
		self.$parentEl = $parentEl;
	
		self.configView = ctrlPtConfig;
		self.listener = listener;
		
		var $elAttr = $parentEl.parent().attr("property");
		var shape = self.shape;
		
		if (typeof initialState === "string") {
			initialState = initialState.split(" ");
			self.position = parseFloat(initialState[1])/100;
			self.renderPos = self.position * listener.g2d.canvas.width;
			self.color = initialState[0];
			self.opacity = initialState[2];
			self.shape = initialState[3];
			self.size = parseInt(initialState[4]);
			//self.type = initialState[5];
		} else {
			self.position = initialState.position;
			self.renderPos = initialState.renderPos;
			self.color = initialState.color;
			self.shape = initialState.shape;
			self.opacity = initialState.opacity;
			self.size = parseInt(initialState.size);
			//self.type = initialState.type;
		}
		
		
		switch(self.shape){
 				case "ellipse" :
 				case "rectangle" :
 				case "roundrectangle" :
 				case "triangle":
 				case "tee":
 				case "diamond":
 				case "none":
			  		if ($elAttr == "nodes_border" || $elAttr == "edges_line"){
 						self.shape = "solid";
					}else if ($elAttr == "nodes_label" || $elAttr == "edges_label"){
 						self.shape = "";
					};
				break;
				case "solid" :
				case "dotted" :
				case "dashed" :
			 	 	if ($elAttr == "nodes_fill"){
 						self.shape = "ellipse";
					}else if ($elAttr == "nodes_label" || $elAttr == "edges_label"){
 						self.shape = "";
					}else if ($elAttr == "edges_target"){
 						self.shape = "triangle";
					}else if ($elAttr == "edges_source"){
 						self.shape = "none";
					};
				break;
				case "" :
			  		if ($elAttr == "nodes_fill"){
 						self.shape = "ellipse";
					}else if ($elAttr == "nodes_border" || $elAttr == "edges_line"){
 						self.shape = "solid";
					}else if ($elAttr == "edges_target"){
 						self.shape = "triangle";
					}else if ($elAttr == "edges_source"){
 						self.shape = "none";
					};
				break;
	 	};
		
		self.outerWidth = self.$el.outerWidth();
		

		if(this.listener.opts.advanced || this.listener.property=="coverage"){
			self.$el.css("background-color", self.color);
		}else{
			self.$el.css("background-color", "#000");
		}
		
		self.$el.attr("opacity", self.opacity);
		self.$el.attr("shape", self.shape);
		self.$el.attr("size", self.size);
		if (orientation == "horizontal") {
			var pxLeft = ($parentEl.width() - self.$el.outerWidth()) * (self.position);
			self.$el.css("left", pxLeft);

		} else {
			var pxTop = ($parentEl.height() - self.$el.outerHeight()) * (self.position);
			self.$el.css("top", pxTop);
		}
		
		self.property=$parentEl.parent().parent().attr("property").toLowerCase();
		if(self.listener.opts.group=="nodes"){	
			if(self.property=="length"){
				self.lengthSeq = parseInt(self.position * (cy._private.maxNodesLength+1)) ;
				var posCtrlPtLen = '<a class=ui-sel_pos>' +self.lengthSeq+ '</a>';
				self.$posCtrlPtLen = $(posCtrlPtLen);
				self.$el.append(self.$posCtrlPtLen);
			}else if(self.property=="coverage"){
				self.coverage = parseInt(self.position * (cy._private.maxNodesCoverage+1)) ;
				var posCtrlPtCoverage = '<a class=ui-sel_pos>' +self.coverage+ '</a>';
				self.$posCtrlPtCoverage = $(posCtrlPtCoverage);
				self.$el.append(self.$posCtrlPtCoverage);
			}
		}else if(self.listener.opts.group=="edges" ){
			if(self.property=="coverage"){
				self.coverage = parseInt(self.position * (cy._private.maxEdgesCoverage+1)) ;
				var posCtrlPtCoverage = '<a class=ui-sel_pos>' +self.coverage+ '</a>';
				self.$posCtrlPtCoverage = $(posCtrlPtCoverage);
				self.$el.append(self.$posCtrlPtCoverage);
			}
		} 

		self.drag = bind(self.drag, self);
		self.stop = bind(self.stop, self);
		self.clicked = bind(self.clicked, self);
		self.colorChanged = bind(self.colorChanged, self);
		self.shapeChanged = bind(self.shapeChanged, self);
		self.opacityChanged = bind(self.opacityChanged, self);
		self.sizeChanged = bind(self.sizeChanged, self);
		//self.typeChanged = bind(self.typeChanged, self);
		self.posChanged = bind(self.posChanged, self);
		self.$el.draggable({
			axis: (orientation == "horizontal") ? "x" : "y",
			drag: self.drag,
			stop: self.stop,
			containment: $parentEl
		});
		
		self.$el.click(self.clicked);
		self.$el.data(self);
		
		var $previewShape = self.$parentEl.parent().find(".vizmapperPicker-preview-shape");
		self.canvasShape = listener.drawPreviewShape($previewShape, self);

		/*setTimeout(function() {
			self.typeChanged();
		},50);*/
		

		}

	//TODO:evité si possible d'utiliser le stockage des données de l'objet cy (maxNodesLength maxNodesCoverage)
	//TODO: if else to switch case 
	ControlPoint.prototype = {
		drag: function(e, ui) {
			// convert position to a %
			var left = ui.position.left;
			var strPosProperty;
			this.position = (left / (this.$parentEl.width() - this.outerWidth));
			this.renderPos = left;
			//update sequence length on drag
			if(this.listener.opts.group=="nodes"){	
				if(this.property=="length" && this.listener.opts.group=="nodes"){
					this.lengthSeq = parseInt(this.position * (cy._private.maxNodesLength+1));
					this.$posCtrlPtLen.text(this.lengthSeq);
					strPosProperty = JSON.stringify(this.lengthSeq);
				}else if(this.property=="coverage"){
					this.coverage = parseInt(this.position * (cy._private.maxNodesCoverage+1));
					this.$posCtrlPtCoverage.text(this.coverage);
					strPosProperty = JSON.stringify(this.coverage);
				}
			}else if(this.listener.opts.group=="edges"){
				if(this.property=="coverage"){
					this.coverage = parseInt(this.position * (cy._private.maxEdgesCoverage+1));
					this.$posCtrlPtCoverage.text(this.coverage);
					strPosProperty = JSON.stringify(this.coverage);
				}
			}
			var linePos = this.position * this.canvasShape.$previewShape.width();
			var lineSize = this.canvasShape.$previewShape.height();
			var xShape = linePos+12;
			var yShape = lineSize/2;
			var canvasShape = this.canvasShape;
			var $previewShape = canvasShape.$previewShape;
			
			var ctrlPtgroup = "ctrlPt"+strPosProperty+"Group";
			var colorShape = this.color;
			var currentShape = this.shape;
						
			$previewShape.setLayer(this.canvasShape.ctrlPtnameLine, {
  				x1: linePos, y1: 0,
  				x2: linePos, y2: lineSize
			}).drawLayers();
			
			if(currentShape == "ellipse" || currentShape == "triangle" || currentShape == "square" || currentShape == "roundrectangle"){
				$previewShape.setLayer(this.canvasShape.ctrlPtnameShape, {
  					x: xShape, y: lineSize/2,
				}).drawLayers();
			} else if(currentShape == 'solid'){
				$previewShape.setLayer(this.canvasShape.ctrlPtnameShape, {
  					x1: xShape, y1: yShape,
  					x2: xShape+20, y2: yShape
				}).drawLayers();
			}else if(currentShape=='dotted'){ 
				$previewShape
				.setLayer(this.canvasShape.ctrlPtnameShape, {
  					fn: function(ctx){
  							ctx.beginPath();
   					 		ctx.lineCap   = 'round';
							ctx.lineWidth = yShape/5; // Lines 4px wide, dots of diameter 4
   					 		ctx.dashedLine(xShape, yShape, xShape+20, yShape, [1,6]);
   					 		ctx.strokeStyle = colorShape;
    						ctx.stroke();
  					}
				}).drawLayers();
			}else if(currentShape=='dashed'){
				$previewShape
				.setLayer(this.canvasShape.ctrlPtnameShape, {
  					fn: function(ctx){
						ctx.beginPath();
   					 		ctx.lineWidth = yShape/5; 
   					 		ctx.dashedLine(xShape, yShape, xShape+20, yShape, [5,3]);
   					 		ctx.strokeStyle = colorShape;
    						ctx.stroke();
    				}
    			}).drawLayers();
			};
			
				
			//this.configView.show(this.$el.position(), this.color, this, this.shape, this.opacity, this.size);
			this.listener.updatePreview();
		},

		stop: function() {
			//this.configView.show(this.$el.position(), this.color, this, this.shape, this.opacity, this.size);
			this.listener.updateView();
		},

		clicked: function() {
			this.configView.show(this.$el.position(), this.color, this, this.shape, this.opacity, this.size);
			this.listener.updatePreview();
			return false;
		},

		colorChanged: function(c) {	
			this.color = c;
			this.$el.css("background-color", c);
			
			this.canvasShape.$previewShape.setLayer(this.canvasShape.ctrlPtnameShape, {
  							fillStyle: c,
							strokeStyle: c,
			}).drawLayers();
			this.listener.updatePreview();
			
		},

		shapeChanged: function(s) {
	
			this.shape = s;
			this.$el.attr("shape", this.shape);
			
			var canvasShape = this.canvasShape;
			var $previewShape = canvasShape.$previewShape;
			
			this.canvasShape.$previewShape.removeLayerGroup(this.canvasShape.ctrlPtgroup).drawLayers();
			this.canvasShape = this.listener.drawPreviewShape($previewShape, this);
			this.listener.updateView();
		},

		opacityChanged: function(o) {
			this.opacity = o;
			this.$el.attr("opacity", o);
			//this.$el.css("opacity", o);
			//this.listener.updatePreview();
		},

		sizeChanged: function(w) {
			this.size = w;
			this.$el.attr("size", w);
			//this.listener.updateView();
		},
		
		/*typeChanged: function(t) {
			this.type = t;
		},*/
		
		posChanged: function(p){
			var canvasShape = this.canvasShape;
			var $previewShape = canvasShape.$previewShape;
			var widthCorrection = $(".ui-continuous_map > canvas")[0].width;
			var $continuousMap = this.$parentEl.parent();
			canvasShape.$previewShape.css("width", widthCorrection);
			this.renderPos = p;

			//TODO: fix bug set position after resize
			//this.position = (p / (parseFloat($(".ui-continuous_map").css("width")) - this.outerWidth));
			this.canvasShape.$previewShape.removeLayerGroup(this.canvasShape.ctrlPtgroup).drawLayers();
			this.canvasShape = this.listener.drawPreviewShape($previewShape, this);
			this.listener.updatePreview();
		},

		removeClicked: function() {
			this.listener.removeControlPoint(this);
			this.canvasShape.$previewShape.removeLayerGroup(this.canvasShape.ctrlPtgroup).drawLayers();
			this.listener.updatePreview();
		},
		
		
	};

	function ControlPtConfig($parent, opts) {
		var self = this;

		//color-chooser
		self.$el = $('<div class="vizmapperPicker-ptConfig" style="visibility: hidden"></div>');
		$parent.append(self.$el);
		
		var $cpicker;
		if(!opts.advanced && $parent.attr('property')=="nodes_shapes"){
			$cpicker = $('<div class="shape-chooser"></div>');
		}else{
			$cpicker = $('<div class="color-chooser"></div>');
		}
		self.$el.append($cpicker);
		var $rmEl = $("<div class='vizmapperPicker-close'></div>");
		self.$el.append($rmEl);
		 	
		$cpicker.addClass("continuous_map "+ $parent.attr('property')).attr("property", $parent.parent().attr('property'));
		self.colorChanged = bind(self.colorChanged, self);
		self.shapeChanged = bind(self.shapeChanged, self);
		self.opacityChanged = bind(self.opacityChanged, self);
		self.sizeChanged = bind(self.sizeChanged, self);
		//self.typeChanged = bind(self.typeChanged, self);
		self.removeClicked = bind(self.removeClicked, self);
		
		if(opts.advanced){
			$cpicker.picker({
				onShow: function (colpkr) {
								var $colpkr = $(colpkr);
								//right_Pickr= $("#side-resizer").css("right");
								//$colpkr.css("right",right_Pickr).css("left", "") ; 
								$colpkr.addClass($this.attr('class')).removeClass('color-chooser continuous_map').attr('property',$this.attr('property'));
								$colpkr.addClass("advanced");
								cy.off("mouseout mouseover touchout touchover");
								return;
				},
				onSubmit : function () {
							cy.elements(":selected").unselect();
							self.listener.listener.updateView();
							return;
				},
				onChangeSize:function(){
						self.sizeChanged(this.data("picker").size);
				},
				onChangeOpacity:function(){
						self.opacityChanged(this.data("picker").opacity);
				},
				onChangeColor: self.colorChanged,
				onHide: function () {
								cy.elements(":selected").unselect();
								self.listener.listener.updateView();
								return;
				},
				onClick: function () {						
								self.shapeChanged(this.data("picker").shape);
								
				}


			});
		}else{	
			
			if($parent.parent().attr("property").toLowerCase() == "length"){
	            	
	             $cpicker.picker({
						onShow: function (shapkr) {
								var $shapkr = $(shapkr);
								$shapkr.addClass("pre-configured");
								cy.off("mouseout mouseover touchout touchover");
						},
						
						onChangeSize:function () {
										self.sizeChanged(this.data("picker").size);
										
										
						},
						onClick: function () {						
										self.shapeChanged(this.data("picker").shape);
						},
						
		
		
					});

			}else if($parent.parent().attr("property").toLowerCase() == "coverage"){
					//self.shapeChanged(this.data("picker").shape);
					$cpicker.picker({
						onShow: function (colpkr) {
										var $colpkr = $(colpkr);
											$colpkr.addClass("pre-configured");
										cy.off("mouseout mouseover touchout touchover");
										return;
						},
						onSubmit : function () {
									cy.elements(":selected").unselect();
									self.listener.listener.updateView();
									return;
						},
						onChangeColor: self.colorChanged,
						onHide: function () {
										cy.elements(":selected").unselect();
										self.listener.listener.updateView();
										return;
						}
				});
			}
		}
		
		self.$cpicker = $cpicker;
		self.opts = opts;
		self.visible = false;
		$rmEl.click(self.removeClicked);
		self.$el.data("ControlPtConfig", self);
		
	}

	ControlPtConfig.prototype = {
		show: function(position, color, listener, shape, opacity, size) {
			
			this.visible = true;
			this.listener = listener;
			this.$el.css("visibility", "visible");
			this.$cpicker.pickerSetColor(color, opacity, size);
			this.$cpicker.css("background-color", "transparent");

			
			//this.$cpicker.css("opacity", opacity);
			if (this.opts.orientation === "horizontal") {
				this.$el.css("left", position.left);
			} else {
				this.$el.css("top", position.top);
			}
			//else {
			//	this.visible = false;
				//this.$el.css("visibility", "hidden");
			//}
			this.$cpicker.click();
		},

		hide: function() {
			if (this.visible) {
				this.$el.css("visibility", "hidden");
				this.visible = false;
			}
		},

		colorChanged: function(hsb, hex, rgba) {
			hex = "#" + hex;
			this.listener.colorChanged(hex);
			//this.$cpicker.css("background-color", hex);
		},

		shapeChanged: function(s) {
			this.listener.shapeChanged(s);
			this.listener.shape = s;
		},

		opacityChanged: function(o) {
			this.listener.opacityChanged(o);
			this.listener.opacity = o;
			//this.$cpicker.css("opacity", o);
		},

		sizeChanged: function(w) {
			this.listener.sizeChanged(w);
			this.listener.size = w;
		},
		
		/*typeChanged: function(t) {
			this.listener.typeChanged(t);
			this.listener.type = t;
		},*/

		removeClicked: function() {
			this.listener.removeClicked();
			this.hide();
		}
	};


	var methods = {
		//TODO:overflow, resetButton in opts
		init: function(opts, config) {	
		opts = $.extend({
				group: undefined,
				property: undefined,
				controlPoints:["#FFF 0% 1 ellipse 30", "#000 100% 1 ellipse 30"],
				orientation: "horizontal",
				fillDirection: "left",
				attrCss: undefined,
				type: undefined,
				tableOfNodes:undefined,
				tableOfEdges:undefined,
				advanced:config.vizmapper.advanced 
				//gradType: "linear", 
				//generateStyles: true,
				//change: function() {}
		}, opts);

	
		this.empty();
		if(this.hasClass("ui-accordion")){
			this.accordion('destroy');
			//force display scrollbar before construct vizmap
			this.parent().css("overflow", "scroll");
		};
		
		var vizmapData = {pickers : []};

		var data = {
					property: opts.property,
					mapdata: 	[opts],
		};				
		vizmapData.pickers.push(data);
			
		
		var arrayOpts = vizmapData.pickers[0].mapdata;			
		var vizMap = new VizMap(this, arrayOpts[0]);
		var propContainer = vizMap.propContainer;
		var propContainerLen = propContainer.length;
		var $parent = vizMap.$el.parent();
		var outerWidth;
		
		
		if(config.vizmapper.with_hold_root == true && opts.group == "nodes"){
			opts.holdRoot = true;
		}
		 
		for (var i=0; i<propContainerLen; i++){
	
			var attrCssLen = propContainer[i].attrCss.length;

			//var size = propContainer[0].attrCss[0].$el.css("width");
			for (var j=0; j<attrCssLen; j++){
					var attrCss = propContainer[i].attrCss[j];
					var vizSel = new VizMapSelection(attrCss.$el, arrayOpts[0], propContainer[i].property);
					var ctrlPtLen = vizSel.controlPoints.length;
					//vizSel.$el.css("width", size);
					vizSel.initialOpts = opts; 
					vizSel.controlPoints[0].$el.draggable("destroy");
					vizSel.controlPoints[ctrlPtLen-1].$el.draggable("destroy");	
					outerWidth = vizSel.controlPoints[ctrlPtLen-1].outerWidth;			
					attrCss.VizMapSelection = vizSel;
					attrCss.VizMapSelection.$el.data("VizMapSelection", vizSel); 
					if(config.vizmapper.advanced){
						if(attrCss.VizMapSelection.property == opts.property[0].toLowerCase()){
							attrCss.VizMapSelection.updateView();
						};
					}else{
						attrCss.VizMapSelection.updateView();
					}			
			};	
		}
		
		
		//set display scrollbar to auto for remove it if necessary 
		
		 if(config.vizmapper.with_accordion){
		 			 $parent.css("overflow-x", "hidden");
		 		 	 ajustedAccordion(this, outerWidth, 100);
		 		 	 $parent.css("overflow-y", "auto");
		 }
		
			

		if(config.vizmapper.typeChoose){
			
			this.prepend('<form>\
								<label class="type" for="discrete">Discrete</label>\
								<input type="radio"  class="vizmapper_type" name="typeof_vizmap" id="discrete" value="discrete">\
								<label class="type" for="gradient">Gradient</label>\
								<input type="radio"  class="vizmapper_type" name="typeof_vizmap" id="gradient" value="gradient">\
						 </form>');
	
			
			if(opts.type == "discrete"){
				$(this).find("#discrete").prop("checked", true);
			}else if(opts.type == "gradient"){
				$(this).find("#gradient").prop("checked", true);	
			};
			
			this.find('.vizmapper_type').click(function(){
				//console.log(vizMap.listener.initialOpts)
				var type = $(this).val();
				var updateOpts= {type:type};
				vizMap.updateOptions(updateOpts, config.vizmapper.with_accordion);
				
			});
		}
		
		if(config.vizmapper.with_reset_button){
			this.append("<button id=reset_vizmapper>Reset vizmapper</button>");	   
			$("#reset_vizmapper").click(function() {
				//TODO:reset dans vizmap prototype
				$("#vizmapper.content").vizMapReset(opts, config);
			});
		};
		
		if(config.vizmapper.with_center_input){
			this.append('<div class="property behaviourGraph core">\
							<input id=focus_node type="checkbox" />\
							<label class="style">Center on selected node</label>\
						</div>');
		};
		
		if(opts.group == "nodes"){
			
			this.append("<div id=root_behaviour class=behaviourGraph core>\
							<input id=hold_root type='checkbox' \>\
							<label class='style'>Hold root node style</label>\
						</div>");
						
			if(opts.holdRoot == true){
				$("#hold_root").prop("checked", true);
			}else{
				$("#hold_root").prop("checked", false);
			}
			
			var self =this;
			$("#hold_root").click(function(){
				var newOpts= {holdRoot:!opts.holdRoot};
				vizMap.updateOptions(newOpts, config.vizmapper.with_accordion);
				//self.data("VizMap").updateOptions(NewOpts, holdRoot);
			});
		}
		
		//Test if coverage is in the array property if yes add table of coverage files
		var lenProperty = opts.property.length;
		for(var n=0; n<lenProperty; n++){
			if(opts.property[n].toLowerCase()=="coverage"){
				addFileCoverageTable(this, config);
				break;
			}
		}
		
		this.data("VizMap", vizMap);
		
		},
						
		save:function() {			
			var vizMap = this.data("VizMap");
	
			var picker=[];
			var vizmapData = { pickers : picker};
			var propContainer = vizMap.propContainer;
			var propContainerLen = propContainer.length;
			var initialOpts;
			
			for (var i=0; i<propContainerLen; i++){
					var arrayVizSel=[];
					var attrCss = propContainer[i].attrCss;
					var attrCssLen = propContainer[i].attrCss.length;
					
					for (var j=0; j<attrCssLen; j++){
							var vizSel = attrCss[j].VizMapSelection;
							var opts = vizSel.opts;
							initialOpts = vizSel.initialOpts;
							arrayCtrlPts = [];
							var controlPoints =  vizSel.controlPoints;
							var controlPointsLen = controlPoints.length;
							
						for (var k=0; k<controlPointsLen; k++){
							    var ctrlPrl = controlPoints[k];				
								var color = ctrlPrl.color ;
								var pos = ctrlPrl.position *100;
								var shape = ctrlPrl.shape;
								var opacity = ctrlPrl.opacity;
								var size = ctrlPrl.size;
								var ctrlPt_str= color+" "+pos+" "+opacity+" "+shape+" "+size;
								arrayCtrlPts[k]=ctrlPt_str;
						};
									
						var newOpts = {
								//change :opts.change ,
								controlPoints : arrayCtrlPts,
								fillDirection :opts.fillDirection ,
								holdRoot:opts.holdRoot,
								//generateStyles : opts.generateStyles,
								group : opts.group,
								orientation: opts.orientation,
								attrCss : opts.attrCss,
								property : opts.property,
								type : opts.type,
								tableOfNodes:opts.tableOfNodes,
								tableOfEdges:opts.tableOfEdges,
								advanced:opts.advanced
						
						};				
					arrayVizSel.push(newOpts);
	
					};	
			var data = {
							property: vizMap.propContainer[i].property,
							mapdata: 	arrayVizSel,
							initialOpts: initialOpts
						};
						
		    vizmapData.pickers.push(data);
				
		};
		return vizmapData;		
		},
		
		
		restore:function(save , newInitialOpts, config){

		this.empty();
		if(this.hasClass("ui-accordion")){
			this.accordion('destroy');
			//force display scrollbar before construct vizmap
			vizMap.$el.parent().css("overflow-y", "scroll");
		}
		
		//var vizMap = $el.data("VizMap");
		var pickers = save.pickers;
		var arrayOpts = pickers[0].mapdata;
		var vizMap = new VizMap(this, arrayOpts[0]);
		var opts = vizMap.opts;
		var property = opts.property;	
		var propContainer = vizMap.propContainer;
		var propContainerLen = propContainer.length;
		var $parent = vizMap.$el.parent(); 
		var outerWidth;
		
		var h=0;
		for (var i=0; i<propContainerLen; i++){
				
			arrayOpts = pickers[h].mapdata;
			var optsLen = arrayOpts.length;
			var initialOpts = pickers[h].initialOpts;
			//initialOpts has been updated to define style of when style has bee reset (state of holdroot has bee updated too)
			initialOpts = $.extend(initialOpts, newInitialOpts);
			for (var j=0; j<optsLen; j++ ){
					var attrCss = propContainer[i].attrCss[j];
					var vizSel = new VizMapSelection(attrCss.$el, arrayOpts[j], propContainer[i].property);
					var ctrlPtLen = vizSel.controlPoints.length;					
					vizSel.initialOpts = initialOpts;
					//arrayOpts[j] = $.extend({change: function() {}}, arrayOpts[j]);
					vizSel.controlPoints[0].$el.draggable("destroy");
					vizSel.controlPoints[ctrlPtLen-1].$el.draggable("destroy");	
					outerWidth = vizSel.controlPoints[ctrlPtLen-1].outerWidth;	
					attrCss.VizMapSelection = vizSel;
					attrCss.VizMapSelection.$el.data("VizMapSelection", vizSel);
					if(config.vizmapper.advanced){
						if(attrCss.VizMapSelection.property == pickers[0].property){
								attrCss.VizMapSelection.updateView();
						};
					}else{
						attrCss.VizMapSelection.updateView();
					}
								
			};
			
			h++;			
		};
		
		//set display scrollbar to auto for remove it if necessary
		
		if(config.vizmapper.with_accordion){
				$parent.css("overflow-x", "hidden"); 
			 	ajustedAccordion(this, outerWidth, 1); 
			 	$parent.css("overflow-y", "auto");
		}
		
		if(config.vizmapper.with_type_choose){	
			this.prepend('<form>\
								<label class="type" for="discrete">Discrete</label>\
								<input type="radio"  class="vizmapper_type" name="typeof_vizmap" id="discrete" value="discrete">\
								<label class="type" for="gradient">Gradient</label>\
								<input type="radio"  class="vizmapper_type" name="typeof_vizmap" id="gradient" value="gradient">\
						 </form>');
			
	
			if(opts.type == "discrete"){
				$(this).find("#discrete").prop("checked", true);
			}else if(vizMap.opts.type == "gradient"){
				$(this).find("#gradient").prop("checked", true);	
			};
			
			this.find('.vizmapper_type').click(function(){
				var type = $(this).val();
				var opts= {type:type};
				vizMap.updateOptions(opts, config.vizmapper.with_accordion);
			});
		}
			
	
		if(config.vizmapper.with_reset_button){	
			this.append("<div id=reset class=vizmapper><button>Reset vizmapper</button><div>");	   
			$("#reset[class=vizmapper]").click(function() {
				$("#vizmapper.content").vizMapReset(opts, config);
			});
		};
		
		if(config.vizmapper.with_center_input){
			this.append('<div class="property behaviourGraph core">\
							<input id=focus_node type="checkbox" />\
							<label class="style">Center on selected node</label>\
						</div>');
		};		

		if(opts.group == "nodes"){
			this.append("<div id=root_behaviour class=behaviourGraph core>\
							<input id=hold_root type='checkbox' \>\
							<label class='style'>Hold root node style</label>\
						</div>");
			
			var holdRoot = opts.holdRoot;
			
			if(holdRoot){
				$("#hold_root").prop("checked", true);
			}else{
				$("#hold_root").prop("checked", false);
			}
			
			var self =this;
			$("#hold_root").click(function(){
				var newOpts= {holdRoot:!opts.holdRoot};
				vizMap.updateOptions(newOpts, config.vizmapper.with_accordion);
				//self.data("VizMap").updateOptions(opts, config);
			});
		}
		
		//Test if coverage is in the array property if yes add table of coverage files
		var lenProperty = save.pickers.length;
		for(var n=0; n<lenProperty; n++){
			if(save.pickers[n].property=="coverage"){
				addFileCoverageTable(this, config);
				break;
			}
		}
		
		this.data("VizMap", vizMap);
		},
		
		update:function(opts, config){
			var vizMap = this.data("VizMap");
			var property = vizMap.opts.property;	
			var propContainer = vizMap.propContainer;
			var propContainerLen = propContainer.length; 
			var outerWidth;
			var pickers = opts.pickers;
			var h=0;
			for (var i=0; i<propContainerLen; i++){	
				var arrayOpts = pickers[h].mapdata;
				var initialOpts = pickers[h].initialOpts;
				var optsLen = arrayOpts.length;
				for (var j=0; j<optsLen; j++ ){
						var attrCss = propContainer[i].attrCss[j];
						attrCss.$el.find('canvas, div').remove();
						var vizSel = new VizMapSelection(attrCss.$el, arrayOpts[j], propContainer[i].property);					
						var ctrlPtLen = vizSel.controlPoints.length;
						//arrayOpts[j] = $.extend({change: function() {}}, arrayOpts[j]);
						vizSel.initialOpts = initialOpts;
						vizSel.controlPoints[0].$el.draggable("destroy");
						vizSel.controlPoints[ctrlPtLen-1].$el.draggable("destroy");	
						outerWidth = vizSel.controlPoints[ctrlPtLen-1].outerWidth;			
						attrCss.VizMapSelection = vizSel;
						attrCss.VizMapSelection.$el.data("VizMapSelection", vizSel);
						if(config.vizmapper.advanced){
							if(attrCss.VizMapSelection.property == pickers[0].property.toLowerCase()){
								attrCss.VizMapSelection.updateView();
							};
						}else{
							attrCss.VizMapSelection.updateView();
						}
												
				};
				
				h++;			
			};
		
			this.data("VizMap", vizMap);
		}
		
		/*updateOnlyView:function(){
			var vizSelActif = this.find(".ui-accordion-content-active").children();
			vizSelActif.each(function(){
				//console.log($(this).data("VizMapSelection"))
				$(this).data("VizMapSelection").updateView();				
			});	
		}*/
			
		
	};
	
	var methods2 = {
		reset: function(opts, config){
			
			cy.elements(":selected").unselect();
			var initType ={
				type : cy._private.vizmapperType
			};
				  	
			$.extend(opts,  initType);
			
			this.empty();
			if(this.hasClass("ui-accordion")){
				this.accordion('destroy');
			};
			
			this.vizMap(opts, config);
			
			//this.parent().css("overflow-y", "auto");
			//this.vizMapUpdateOnlyView();
					
		},
		
		scrollable: function(){
			
			return this.data().VizMap.scrollable = isScrollable();
			
		}
		
	};
	
	$.fn.extend({
		vizMap: methods.init,
		vizMapSave: methods.save,
		vizMapRestore: methods.restore,
		vizMapUpdate: methods.update,
		//vizMapUpdateOnlyView: methods.updateOnlyView,
		vizMapScrollable: methods2.scrollable,
		vizMapReset: methods2.reset
		//vizMapResize: methods2.resize
		//VizMapRemove: methods.remove
	});
	
	
	
	/*$.fn.VizMap = function(method, opts) {
		if (typeof method === "string" && method !== "init") {
			methods[method].call(this, opts);	
		} else {
			opts = method;
			methods.init.call(this, opts);
		}
		
	};*/
	
})( jQuery );
